package com.delfines.business;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.LinkedList;
import java.util.List;

import com.delfines.dao.ConnectionFactoryCostos;
import com.delfines.dao.ConnectionFactoryCostos160;

import read.Constante;
import vo.ChecksMicros;
import vo.DailyFood;
import vo.FinJrnlArticles;
import vo.GuiaMerma;
import vo.GuiaTransfCosto;
import vo.OutlHjTrb;
import vo.Resumen;
import vo.SalesArticleRVC;

public class CostosBo {
	
	public void insertarOutlHjtrb(String query){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            ps = conn.prepareStatement(query);
            ps.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public Integer getNextLastRow(){
		Integer lastRow=0; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

	    try {
	      	  Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
	          
	          StringBuilder query = new StringBuilder();
	          query.append("SELECT isnull(last_row,0) next_lastrow FROM dbo.seq_outl_hjtrb ");
	          ps = conn.prepareStatement(query.toString());
	          
	          rs = ps.executeQuery();
	          
	          if(rs.next()){
	        	  lastRow=rs.getInt("next_lastrow");
	          }
	          
	    } catch (SQLException e) {
	          throw new RuntimeException(e);
	    } finally {
	      	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
	          if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
	    }
	      
	    return lastRow;
	}
	
	public void updateLastRow(){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("update dbo.seq_outl_hjtrb set last_row=last_row+1 ");
            ps = conn.prepareStatement(query.toString());
            Integer ins=ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	
	public void deleteOutlHjtrb(Integer lastRow){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("delete from dbo.outl_hjtrb where lastrow=? ");
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, lastRow);
            Integer ins=ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	
	public void insertarFinJrnlArticles(String insertValues){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("INSERT INTO dbo.finjrnl_articles(quantity,room,article_id,article_code,description,guest_account_debit,guest_account_credit,cashier_id,cashier_name,trx_date)VALUES ");
	        query.append(insertValues);
            ps = conn.prepareStatement(query.toString());
            Integer ins=ps.executeUpdate();
            System.out.println("insert dbo.finjrnl_articles..."+ins);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void deleteFinJrnlArticles(String fecha){
		PreparedStatement ps=null;
        try {
        	
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.finjrnl_articles WHERE trx_date=?");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	
	public void insertarSalesArticleStatistics(String query){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            ps = conn.prepareStatement(query);
            ps.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void insertarSparte(String insertValues){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("INSERT INTO dbo.sparte(spa_id,spa_name,sgr_id)VALUES ");
	        query.append(insertValues);
	        System.out.println(query.toString());
            ps = conn.prepareStatement(query.toString());
            ps.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void insertarSparteGr(String insertValues){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("INSERT INTO dbo.spartegr(sgr_id,sgr_name)VALUES ");
	        query.append(insertValues);
	        System.out.println(query.toString());
            ps = conn.prepareStatement(query.toString());
            ps.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void insertarProdukt(String insertValues){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("INSERT INTO dbo.produkt(pro_plu,pro_name,pro_id,kst_id,kst_id2,spa_id,pro_preis1)VALUES ");
	        query.append(insertValues);
            ps = conn.prepareStatement(query.toString());
            ps.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void insertarGuiasTransferenciaCosto(String insertValues){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("INSERT INTO dbo.guia_transf_costo(lbw_date,kst_id,kst_name,lbw_name,lbw_info,lbw_total)VALUES ");
	        query.append(insertValues);
            ps = conn.prepareStatement(query.toString());
            Integer ins=ps.executeUpdate();
            System.out.println("insert dbo.guia_transf_costo..."+ins);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void deleteGuiasTransferenciaCosto(String fecha){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.guia_transf_costo WHERE lbw_date=? ");
	        ps = conn.prepareStatement(query.toString());
	        ps.setString(1, fecha);
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void insertarGuiasTransferenciaGasto(String insertValues){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("INSERT INTO dbo.guia_transf_gasto(lbw_date,kst_id,kst_name,lbw_name,lbw_info,lbw_total)VALUES ");
	        query.append(insertValues);
            ps = conn.prepareStatement(query.toString());
            Integer ins=ps.executeUpdate();
            System.out.println("insert dbo.guia_transf_gasto..."+ins);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void deleteGuiasTransferenciaGasto(String fecha){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.guia_transf_gasto WHERE lbw_date=? ");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void insertarGuiasMermaGasto(String insertValues){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("INSERT INTO dbo.guia_merma_gasto(verbr_date,kst_id,kst_name,verbr_total,vbr_info,vbr_name)VALUES ");
	        query.append(insertValues);
            ps = conn.prepareStatement(query.toString());
            Integer ins=ps.executeUpdate();
            System.out.println("insert dbo.guia_merma_gasto..."+ins);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void deleteGuiasMermaGasto(String fecha){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.guia_merma_gasto WHERE verbr_date=? ");
	        ps = conn.prepareStatement(query.toString());
	        ps.setString(1, fecha);
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public OutlHjTrb getOutlHjTrb(String fecha){
		OutlHjTrb obj = null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(Util.stringToDate(fecha));
				
		Integer aa=calendar.get(Calendar.YEAR);
		Integer mm=calendar.get(Calendar.MONTH)+1;
		Integer dd=calendar.get(Calendar.DAY_OF_MONTH);
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.CRoom_Service,t.BRoom_Service,t.CKnossos,t.BKnossos,t.CLobby_Bar,t.BLobby_Bar,t.COceanus,t.BOceanus,t.CDelphos,t.BDelphos,t.CknoEvt,t.BknoEvt,t.CBanquetes,t.BBanquetes ");
            query.append(" ,isnull(t.CExecut_Floor,0) CExecut_Floor,isnull(t.CbCasino,0) CbCasino ");
            query.append(" ,isnull(t.HDesay_Incluido,0) HDesay_Incluido ");
            query.append(" ,isnull(t.BServibar,0) BServibar ");
            query.append(" from dbo.outl_hjtrb t where t.AA=? AND t.MM=? AND t.DD=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, aa);
            ps.setInt(2, mm);
            ps.setInt(3, dd);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new OutlHjTrb();
            	obj.setcRoomService(rs.getDouble("CRoom_Service"));
            	obj.setbRoomService(rs.getDouble("BRoom_Service"));
            	
            	obj.setcKnossos(rs.getDouble("CKnossos"));
            	obj.setbKnossos(rs.getDouble("BKnossos"));
            	
            	obj.setcLobbyBar(rs.getDouble("CLobby_Bar"));
            	obj.setbLobbyBar(rs.getDouble("BLobby_Bar"));
            	
            	obj.setcOceanus(rs.getDouble("COceanus"));
            	obj.setbOceanus(rs.getDouble("BOceanus"));
            	
            	obj.setcDelphos(rs.getDouble("CDelphos"));
            	obj.setbDelphos(rs.getDouble("BDelphos"));
            	
            	obj.setcKnoEvt(rs.getDouble("CknoEvt"));
            	obj.setbKnoEvt(rs.getDouble("BknoEvt"));
            	
            	obj.setcBanquetes(rs.getDouble("CBanquetes"));
            	obj.setbBanquetes(rs.getDouble("BBanquetes"));
            	
            	Double m1=rs.getDouble("CExecut_Floor");
            	Double m2=rs.getDouble("CbCasino")*(-1);
            	
            	obj.setDelphosEventos(m2);
            	obj.setEventosIncluido(m1-m2);
            	
            	obj.sethDesayIncluido(rs.getDouble("HDesay_Incluido"));
            	obj.setbServiBar(rs.getDouble("BServibar"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public SalesArticleRVC getCOSTotalFromRVC(String fecha,String overGroup,String outlet,String salesLocation){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select s.over_group,s.outlet,s.sales_location,SUM(s.cos_total) cos_total,SUM(ISNULL(s.qty,0)*ISNULL(s.s_price,0)) ven_total from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu,  ");
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet  ");
            query.append(" from dbo.sales_article_statistics s  "); 
            query.append(" where s.date_rvc=?  ");
            query.append(" and s.qty>0  ");
            query.append(" ) s where s.over_group=? and s.outlet=? and s.sales_location=?  ");
            query.append(" group by s.over_group,s.outlet,s.sales_location ");
            query.append(" order by s.over_group,s.outlet,s.sales_location ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, overGroup);
            ps.setString(3, outlet);
            ps.setString(4, salesLocation);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
								 
	public List<SalesArticleRVC> detalleCOSTotalFromRVC(String fecha,String overGroup,String outlet,String salesLocation){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from ( ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu,   ");
            query.append(" dbo.getOverGroup(s.no_product) over_group,   ");
            query.append(" dbo.getOutlet(s.no_product) outlet   ");
            query.append(" from dbo.sales_article_statistics s   ");
            query.append(" where s.date_rvc=? ");
            query.append(" and s.qty>0   ");
            query.append(" ) t where t.over_group=? and t.outlet=? and t.sales_location=? ");
            query.append(" order by t.product ASC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, overGroup);
            ps.setString(3, outlet);
            ps.setString(4, salesLocation);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	SalesArticleRVC article=new SalesArticleRVC();
            	
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	public Double getCostoTransferenciaFromGuia(String fecha,String concepto){
		Double costo = 0.0; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select c.lbw_date,SUM(lbw_total) lbw_total "); 
            query.append(" from dbo.guia_transf_costo c ");
            query.append(" where c.lbw_date=? ");
            query.append(" and c.lbw_info like '").append(concepto).append("'  ");
            query.append(" group by c.lbw_date  ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	costo=rs.getDouble("lbw_total");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return costo;
	}
	
	
	public List<GuiaTransfCosto> detalleCostoTransferenciaFromGuia(String fecha,String concepto){
		
		List<GuiaTransfCosto> lGuia=new LinkedList<GuiaTransfCosto>();
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT c.lbw_date,c.kst_id,c.kst_name,c.lbw_name,c.lbw_total,c.lbw_info ");
            query.append(" FROM dbo.guia_transf_costo c "); 
            query.append(" WHERE c.lbw_date=? ");
            query.append(" and c.lbw_info like '").append(concepto).append("' ");
            query.append(" ORDER BY c.kst_name,c.lbw_name,c.lbw_info ASC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	GuiaTransfCosto guia=new GuiaTransfCosto();
            	guia.setLbwDate(rs.getString("lbw_date"));
            	guia.setKstId(rs.getInt("kst_id"));
            	guia.setKstName(rs.getString("kst_name"));
            	guia.setLbwName(rs.getString("lbw_name"));
            	guia.setLbwTotal(rs.getDouble("lbw_total"));
            	guia.setLbwInfo(rs.getString("lbw_info"));
            	lGuia.add(guia);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lGuia;
	}
	
	
	public SalesArticleRVC getCOSTotalFromRVCOutlet(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from ( ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, ");   
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");   
            query.append(" dbo.getOutlet(s.no_product) outlet    ");
            query.append(" from dbo.sales_article_statistics s ");    
            query.append(" where s.qty>0    ");
            query.append(" and s.date_rvc=? "); 
            query.append(" ) t   ");
            query.append(" where t.over_group='ALIMENTO' and t.sales_location='RVC ROOM SERVICE (3)' and t.outlet='ROOM SERVICE' ");
            query.append(" group by t.over_group,t.outlet ");
            query.append(" order by t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalFromRVCOutlet(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>();
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from ( "); 
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, "); 
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t    ");
            query.append(" where t.over_group='ALIMENTO' and t.sales_location='RVC ROOM SERVICE (3)' and t.outlet='ROOM SERVICE' ");
            query.append(" order by t.product ASC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	SalesArticleRVC article=new SalesArticleRVC();
            	
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	
	public SalesArticleRVC getCOSTotalFromRVCSalesLocation(String fecha,String overGroup,String salesLocation){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from ( ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, ");  
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");  
            query.append(" dbo.getOutlet(s.no_product) outlet   ");
            query.append(" from dbo.sales_article_statistics s ");   
            query.append(" where s.qty>0   ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t  ");
            query.append(" where t.over_group=? and t.sales_location=?  ");
            query.append(" group by t.sales_location,t.over_group ");
            query.append(" order by t.sales_location,t.over_group ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, overGroup);
            ps.setString(3, salesLocation);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public Double getVentaTotalFromFrigobar(String fecha,String concepto){
		Double venta=0.0; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT g.description,SUM(a.guest_account_debit) guest_account_debit FROM dbo.finjrnl_articles a ");
            query.append(" inner join dbo.article_codes_group ag on (ag.article_id=a.article_id) ");
            query.append(" inner join dbo.article_group g on (g.article_group_id=ag.article_group_id) ");
            query.append(" where trx_date=? and g.description=? ");
            query.append(" group by g.description ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, concepto);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	venta=rs.getDouble("guest_account_debit");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return venta;
	}

	public List<FinJrnlArticles> detalleVentaTotalFromFrigobar(String fecha,String concepto){
		 
		List<FinJrnlArticles> list=new LinkedList<FinJrnlArticles>();
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT a.quantity ");
            query.append(" ,a.room ");
            query.append(" ,a.article_id ");
            query.append(" ,a.article_code ");
            query.append(" ,a.description ");
            query.append(" ,a.guest_account_debit ");
            query.append(" ,a.guest_account_credit ");
            query.append(" ,a.cashier_id ");
            query.append(" ,a.cashier_name ");
            query.append(" ,a.trx_date FROM dbo.finjrnl_articles a ");
            query.append(" inner join dbo.article_codes_group ag on (ag.article_id=a.article_id) ");
            query.append(" inner join dbo.article_group g on (g.article_group_id=ag.article_group_id) ");
            query.append(" where trx_date=? and g.description=? ");
            query.append(" order by g.description ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, concepto);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	FinJrnlArticles art=new FinJrnlArticles();
            	art.setQuantity(rs.getInt("quantity"));
            	art.setRoom(rs.getString("room"));
            	art.setArticleId(rs.getInt("article_id"));
            	art.setArticleCode(rs.getString("article_code"));
            	art.setDescription(rs.getString("description"));
            	art.setGuestAccountDebit(rs.getDouble("guest_account_debit"));
            	art.setGuestAccountCredit(rs.getDouble("guest_account_credit"));
            	art.setCashierId(rs.getInt("cashier_id"));
            	art.setCashierName(rs.getString("cashier_name"));
            	art.setTrxDate(rs.getString("trx_date"));
            	list.add(art);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return list;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalAlimentoFromRVCBarOcean(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet,t.over_group_logico from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, ");  
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");  
            query.append(" dbo.getOutlet(s.no_product) outlet,  ");
            query.append(" dbo.getOverGroupLogico(s.no_product) over_group_logico "); 
            query.append(" from dbo.sales_article_statistics s ");  
            query.append(" where s.qty>0      ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t  ");
            query.append(" where t.sales_location='RVC OCEANUS LOUNGE (5)' and t.over_group='ALIMENTO' ");
            query.append(" order by t.sales_location,t.over_group,t.product ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	
	public SalesArticleRVC getVentaTotalFromRVCBarOcean(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (   ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, ");  
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");  
            query.append(" dbo.getOutlet(s.no_product) outlet,  ");
            query.append(" dbo.getOverGroupLogico(s.no_product) over_group_logico "); 
            query.append(" from dbo.sales_article_statistics s ");  
            query.append(" where s.qty>0      ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t  ");
            query.append(" where t.sales_location='RVC OCEANUS LOUNGE (5)' and t.over_group='ALIMENTO' ");
            query.append(" group by t.sales_location,t.over_group ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	
	
	
	public SalesArticleRVC getVentaTotalFromRVCDelphosBuffet(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, "); 
            query.append(" dbo.getOutlet(s.no_product) outlet, ");
            query.append(" dbo.getOverGroupLogico(s.no_product) over_group_logico ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t ");
            query.append(" where t.over_group ='LOGICO' and t.sales_location='RVC CAFET. DELPHOS (1)' AND T.over_group_logico='DESAYUNO' ");
            query.append(" group by t.over_group,t.outlet ");
            query.append(" order by t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleVentaTotalFromRVCDelphosBuffet(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from ( ");  
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, ");  
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");  
            query.append(" dbo.getOutlet(s.no_product) outlet,  ");
            query.append(" dbo.getOverGroupLogico(s.no_product) over_group_logico "); 
            query.append(" from dbo.sales_article_statistics s ");  
            query.append(" where s.qty>0      ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t  ");
            query.append(" where t.over_group ='LOGICO' and t.sales_location='RVC CAFET. DELPHOS (1)' AND T.over_group_logico='DESAYUNO' "); 
            query.append(" order by t.over_group,t.outlet  ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	SalesArticleRVC article= new SalesArticleRVC();
            	
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	
	public SalesArticleRVC getCOSTotalFromRVCDelphosCarta(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0 ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t ");
            query.append(" where t.sales_location='RVC CAFET. DELPHOS (1)' AND t.over_group ='ALIMENTO' and t.outlet='ROOM SERVICE' ");
            query.append(" group by t.sales_location,t.over_group,t.outlet  ");
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}

	public List<SalesArticleRVC> detalleCOSTotalFromRVCDelphosCarta(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0 ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t ");
            query.append(" where t.sales_location='RVC CAFET. DELPHOS (1)' AND t.over_group ='ALIMENTO' and t.outlet='ROOM SERVICE' ");
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	
	public Double getCostoTransferenciaFromGuiaMenusLogicos(String fecha){
		/**
		 	MENU EJECUTIVO
			MENU LAY OVER
			MENU TURISTICO
			MENU SWEET TIME
			DELPHOS EVENTOS
			PQTE. DE FIN DE SEMANA
			VTA. PERSONAL (COFFE EXPRESSE)
			DELPHOS ABIERTO
		 */
		Double costo = 0.0; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select c.lbw_date,SUM(lbw_total) lbw_total "); 
            query.append(" from dbo.guia_transf_costo c  ");
            query.append(" where c.lbw_date=? ");
            query.append("  and (c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_MENU_EJECUTIVO).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_MENU_LAYOVER).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_MENU_TURISTICO).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_MENU_SWEETTIME).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_DELPHOS_EVENTOS).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_PQTE_FINDESEMANA).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_VTA_PERSONA_COFFE_EXPRESSE).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_DELPHOS_ALIMENTO_ABIERTO).append("') ");
            query.append(" group by c.lbw_date ");
            query.append(" order by c.lbw_date ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	costo=rs.getDouble("lbw_total");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return costo;
	}

	public List<GuiaTransfCosto> detalleCostoTransferenciaFromGuiaMenusLogicos(String fecha){
		List<GuiaTransfCosto> lGuia = new LinkedList<GuiaTransfCosto>();
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT c.lbw_date,c.kst_id,c.kst_name,c.lbw_name,c.lbw_total,c.lbw_info ");
            query.append(" FROM dbo.guia_transf_costo c "); 
            query.append(" WHERE c.lbw_date=? ");
            query.append("  and (c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_MENU_EJECUTIVO).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_MENU_LAYOVER).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_MENU_TURISTICO).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_MENU_SWEETTIME).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_DELPHOS_EVENTOS).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_PQTE_FINDESEMANA).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_VTA_PERSONA_COFFE_EXPRESSE).append("' ");
            query.append("  or c.lbw_info like '").append(Constante.GUIA_CONCEPTO_LOG_DELPHOS_ALIMENTO_ABIERTO).append("') ");
            query.append(" ORDER BY c.kst_name,c.lbw_name,c.lbw_info ASC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	GuiaTransfCosto guia=new GuiaTransfCosto();
            	guia.setLbwDate(rs.getString("lbw_date"));
            	guia.setKstId(rs.getInt("kst_id"));
            	guia.setKstName(rs.getString("kst_name"));
            	guia.setLbwName(rs.getString("lbw_name"));
            	guia.setLbwTotal(rs.getDouble("lbw_total"));
            	guia.setLbwInfo(rs.getString("lbw_info"));
            	lGuia.add(guia);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lGuia;
	}
	
	public SalesArticleRVC getCOSTotalAlimentoFromRVCSanisBar(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (   ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");  
            query.append(" dbo.getOutlet(s.no_product) outlet   ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0  ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t  ");
            query.append(" where t.sales_location='RVC SANIS BAR (6)' AND t.over_group ='ALIMENTO' and t.outlet='ROOM SERVICE' "); 
            query.append(" group by t.sales_location,t.over_group,t.outlet   ");
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalAlimentoFromRVCSanisBar(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (   ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");  
            query.append(" dbo.getOutlet(s.no_product) outlet   ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0  ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t  ");
            query.append(" where t.sales_location='RVC SANIS BAR (6)' AND t.over_group ='ALIMENTO' and t.outlet='ROOM SERVICE' "); 
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	SalesArticleRVC article= new SalesArticleRVC();
            	
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	public SalesArticleRVC getCOSTotalAlimentoFromRVCEventos(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (   ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet      ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t ");
            query.append(" where t.sales_location='RVC EVENTOS Y BANQ. (4)' AND t.over_group='ALIMENTO'  ");
            query.append(" group by t.over_group,t.outlet,t.sales_location ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	
	public List<SalesArticleRVC> detalleCOSTotalAlimentoFromRVCEventos(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (   ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet      ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t ");
            query.append(" where t.sales_location='RVC EVENTOS Y BANQ. (4)' AND t.over_group='ALIMENTO'  ");
            query.append(" order by t.over_group,t.outlet,t.sales_location,t.product ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
				
	
	public SalesArticleRVC getVentaTotalFromRVCFrigobar(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (   ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet      ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t ");
            query.append(" where t.over_group ='ALIMENTO' and t.outlet='FRIGOBAR' and t.sales_location='RVC ROOM SERVICE (3)' ");
            query.append(" group by t.over_group,t.outlet,t.sales_location ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleVentaTotalFromRVCFrigobar(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (   ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet      ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t ");
            query.append(" where t.over_group ='ALIMENTO' and t.outlet='FRIGOBAR' and t.sales_location='RVC ROOM SERVICE (3)' ");
            query.append(" order by t.over_group,t.outlet,t.sales_location,t.product ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return larticle;
	}
	
	
	public SalesArticleRVC getCOSTotalFromRVCRoomServ(String fecha){//ok
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("  select s.over_group,s.outlet,SUM(s.cos_total) cos_total,SUM(ISNULL(s.qty,0)*ISNULL(s.s_price,0)) ven_total from (   ");
            query.append("  select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, ");  
            query.append("  dbo.getOverGroup(s.no_product) over_group, ");  
            query.append("  dbo.getOutlet(s.no_product) outlet   ");
            query.append("  from dbo.sales_article_statistics s ");   
            query.append("  where s.date_rvc=? "); 
            query.append("  and s.qty>0   ");
            query.append("  ) s where s.over_group='BEBIDA' and s.outlet='ROOM SERVICE' and s.sales_location='RVC ROOM SERVICE (3)' ");
            query.append("  group by s.over_group,s.outlet  ");
            query.append("  order by s.over_group,s.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalFromRVCRoomServ(String fecha){//ok
		List<SalesArticleRVC> larticle = new LinkedList<>();
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("  select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu,s.over_group,s.outlet from (   ");
            query.append("  select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, ");  
            query.append("  dbo.getOverGroup(s.no_product) over_group, ");  
            query.append("  dbo.getOutlet(s.no_product) outlet   ");
            query.append("  from dbo.sales_article_statistics s ");   
            query.append("  where s.date_rvc=? "); 
            query.append("  and s.qty>0   ");
            query.append("  ) s where s.over_group='BEBIDA' and s.outlet='ROOM SERVICE' and s.sales_location='RVC ROOM SERVICE (3)' ");
            query.append("  order by s.over_group,s.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	
	public SalesArticleRVC getCOSTotalFromRVCRestOcea(String fecha){//ok
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t    ");
            query.append(" where t.over_group='BEBIDA' and t.outlet='ROOM SERVICE' and t.sales_location='RVC REST. OCEANUS (2)' ");
            query.append(" group by t.over_group,t.outlet,t.sales_location ");
            query.append(" order by t.over_group,t.outlet,t.sales_location ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalFromRVCRestOcea(String fecha){//ok
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t    ");
            query.append(" where t.over_group='BEBIDA' and t.outlet='ROOM SERVICE' and t.sales_location='RVC REST. OCEANUS (2)' ");
            query.append(" order by t.over_group,t.outlet,t.sales_location ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            	
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	public Integer getQtyVentaTotalFromRVCDelphosDesayAlmCenaIncluido(String fecha){
		Integer qty=0; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select ISNULL(SUM(t.qty),0) qty from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t    ");
            query.append(" where t.product = 'Desay Inc_Buff (102017)' ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	qty=rs.getInt("qty");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return qty;
	}
	
	public SalesArticleRVC getCOSTotalFromRVCDelphos(String fecha){//ok
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t    ");
            query.append(" where t.over_group='BEBIDA' and t.outlet='ROOM SERVICE' and t.sales_location='RVC CAFET. DELPHOS (1)' ");
            query.append(" group by t.over_group,t.outlet,t.sales_location  ");
            query.append(" order by t.over_group,t.outlet,t.sales_location ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalFromRVCDelphos(String fecha){//ok
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group,  ");
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t    ");
            query.append(" where t.over_group='BEBIDA' and t.outlet='ROOM SERVICE' and t.sales_location='RVC CAFET. DELPHOS (1)' ");
            query.append(" order by t.over_group,t.outlet,t.sales_location ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            	
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	
		public Integer getCOSTotalFromRVCWelcomeDrink(String fecha){//ok
			Integer qty=0; 
			
			PreparedStatement ps=null;
			ResultSet rs=null;
			
	        try {
	        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
	            
	            StringBuilder query = new StringBuilder();
	            query.append(" select t.grouped_by,SUM(ISNULL(t.qty,0)) qty from ( "); 
	            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu,s.grouped_by, "); 
	            query.append(" dbo.getOverGroup(s.no_product) over_group, ");
	            query.append(" dbo.getOutlet(s.no_product) outlet    ");
	            query.append(" from dbo.sales_article_statistics s ");
	            query.append(" where s.qty>0    ");
	            query.append(" and s.date_rvc=?");
	            query.append(" ) t   ");
	            query.append(" where t.grouped_by = '").append(Constante.RVC_ETIQUETA_WDRINK).append("' ");
	            query.append(" group by t.grouped_by ");
	            
	            ps = conn.prepareStatement(query.toString());
	            ps.setString(1, fecha);
	            
	            rs = ps.executeQuery();
	            
	            if(rs.next()){
	            	qty=rs.getInt("qty");
	            }
	            
	        } catch (SQLException e) {
	            throw new RuntimeException(e);
	        } finally {
	        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
	            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
	        }
	        
	        return qty;
		}
	
		public List<SalesArticleRVC> detalleCOSTotalFromRVCWelcomeDrink(String fecha){//ok
			List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>();
			
			PreparedStatement ps=null;
			ResultSet rs=null;
			
	        try {
	        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
	            
	            StringBuilder query = new StringBuilder();
	            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet,t.grouped_by from ( "); 
	            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu,s.grouped_by, "); 
	            query.append(" dbo.getOverGroup(s.no_product) over_group, ");
	            query.append(" dbo.getOutlet(s.no_product) outlet    ");
	            query.append(" from dbo.sales_article_statistics s ");
	            query.append(" where s.qty>0    ");
	            query.append(" and s.date_rvc=?");
	            query.append(" ) t   ");
	            query.append(" where t.grouped_by = '").append(Constante.RVC_ETIQUETA_WDRINK).append("' ");
	            query.append(" order by t.over_group,t.product ");
	            
	            ps = conn.prepareStatement(query.toString());
	            ps.setString(1, fecha);
	            
	            rs = ps.executeQuery();
	            
	            while(rs.next()){
	            	
	            	SalesArticleRVC article=new SalesArticleRVC();
	            	article.setSalesLocation(rs.getString("sales_location"));
	            	article.setNoProduct(rs.getString("no_product"));
	            	article.setProduct(rs.getString("product"));
	            	article.setDateRvc(rs.getString("date_rvc"));
	            	article.setQty(rs.getDouble("qty"));
	            	article.setPrice(rs.getDouble("s_price"));
	            	article.setNetTotal(rs.getDouble("net_total"));
	            	article.setGrossTotal(rs.getDouble("gross_total"));
	            	article.setCosUni(rs.getDouble("cos_uni"));
	            	article.setCosTotal(rs.getDouble("cos_total"));
	            	article.setCosPorc(rs.getDouble("cos_porc"));
	            	article.setCm(rs.getDouble("cm"));
	            	article.setCmTotal(rs.getDouble("cm_total"));
	            	article.setMu(rs.getDouble("mu"));
	            	article.setPotMu(rs.getDouble("pot_mu"));
	            	article.setOverGroup(rs.getString("over_group"));
	            	article.setOutlet(rs.getString("outlet"));
	            	larticle.add(article);
	            	
	            }
	            
	        } catch (SQLException e) {
	            throw new RuntimeException(e);
	        } finally {
	        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
	            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
	        }
	        
	        return larticle;
		}
		
		
		
	public void deleteSalesArticleStatistics(String fechaCosto){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.sales_article_statistics WHERE date_rvc=? ");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fechaCosto);
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public SalesArticleRVC getCOSTotalFromRVCMenusLogicos(String fecha){//ok
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, "); 
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t    ");
            query.append(" where t.sales_location='RVC CAFET. DELPHOS (1)' and t.over_group='CORTESIA' ");
            query.append(" group by t.sales_location,t.over_group ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	
	public List<SalesArticleRVC> detalleCOSTotalFromRVCMenusLogicos(String fecha){//ok
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (  ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, "); 
            query.append(" dbo.getOutlet(s.no_product) outlet     ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0     ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t    ");
            query.append(" where t.sales_location='RVC CAFET. DELPHOS (1)' and t.over_group='CORTESIA' ");
            query.append(" order by t.product ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            	
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	
	public SalesArticleRVC getCOSTotalBebidaFromRVCSanisBar(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (   ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");  
            query.append(" dbo.getOutlet(s.no_product) outlet   ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0  ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t  ");
            query.append(" where t.sales_location='RVC SANIS BAR (6)' AND t.over_group ='BEBIDA' and t.outlet='ROOM SERVICE' "); 
            query.append(" group by t.sales_location,t.over_group,t.outlet   ");
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalBebidaFromRVCSanisBar(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (   ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");  
            query.append(" dbo.getOutlet(s.no_product) outlet   ");
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0  ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t  ");
            query.append(" where t.sales_location='RVC SANIS BAR (6)' AND t.over_group ='BEBIDA' and t.outlet='ROOM SERVICE' "); 
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            	
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	
	public SalesArticleRVC getCOSTotalBebidaFromRVCOcean(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (    ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");   
            query.append(" dbo.getOutlet(s.no_product) outlet    ");
            query.append(" from dbo.sales_article_statistics s ");  
            query.append(" where s.qty>0   ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t   ");
            query.append(" where t.sales_location='RVC OCEANUS LOUNGE (5)' AND t.over_group ='BEBIDA' and t.outlet='ROOM SERVICE' ");  
            query.append(" group by t.sales_location,t.over_group,t.outlet    ");
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalBebidaFromRVCOcean(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (    ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");   
            query.append(" dbo.getOutlet(s.no_product) outlet    ");
            query.append(" from dbo.sales_article_statistics s ");  
            query.append(" where s.qty>0   ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t   ");
            query.append(" where t.sales_location='RVC OCEANUS LOUNGE (5)' AND t.over_group ='BEBIDA' and t.outlet='ROOM SERVICE' ");  
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            	
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	
	public SalesArticleRVC getCOSTotalBebidaFromRVCOceanCortesia(String fecha){
		SalesArticleRVC article = new SalesArticleRVC(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (    ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");   
            query.append(" dbo.getOutlet(s.no_product) outlet    ");
            query.append(" from dbo.sales_article_statistics s ");  
            query.append(" where s.qty>0   ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t   ");
            query.append(" where t.sales_location='RVC OCEANUS LOUNGE (5)' and t.over_group='CORTESIA' and t.outlet='ROOM SERVICE' ");  
            query.append(" group by t.sales_location,t.over_group,t.outlet    ");
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setVenTotal(rs.getDouble("ven_total"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return article;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalBebidaFromRVCOceanCortesia(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,t.outlet from (    ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");   
            query.append(" dbo.getOutlet(s.no_product) outlet    ");
            query.append(" from dbo.sales_article_statistics s ");  
            query.append(" where s.qty>0   ");
            query.append(" and s.date_rvc=? ");
            query.append(" ) t   ");
            query.append(" where t.sales_location='RVC OCEANUS LOUNGE (5)' and t.over_group='CORTESIA' and t.outlet='ROOM SERVICE' ");  
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            	
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}
	
	public SalesArticleRVC getCOSTotalBebidaFromRVCFrigoBar(String fecha){//ok
	SalesArticleRVC article = new SalesArticleRVC(); 
	
	PreparedStatement ps=null;
	ResultSet rs=null;
	
	try {
		Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
	    
	    StringBuilder query = new StringBuilder();
	    query.append(" select t.sales_location,t.over_group,t.outlet,SUM(ISNULL(t.cos_total,0)) cos_total,SUM(ISNULL(t.qty,0)*ISNULL(t.s_price,0)) ven_total from (    ");
	    query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
	    query.append(" dbo.getOverGroup(s.no_product) over_group, ");
	    query.append(" dbo.getOutlet(s.no_product) outlet    ");
	    query.append(" from dbo.sales_article_statistics s "); 
	    query.append(" where s.qty>0   ");
	    query.append(" and s.date_rvc=? ");
	    query.append(" ) t   ");
	    query.append(" where t.sales_location='RVC ROOM SERVICE (3)' and t.over_group='BEBIDA' and t.outlet='FRIGOBAR' ");
	    query.append(" group by t.sales_location,t.over_group,t.outlet ");
	    
	    ps = conn.prepareStatement(query.toString());
	    ps.setString(1, fecha);
	    
	    rs = ps.executeQuery();
	    
	    if(rs.next()){
	    	article.setOverGroup(rs.getString("over_group"));
	    	article.setOutlet(rs.getString("outlet"));
	    	article.setSalesLocation(rs.getString("sales_location"));
	    	article.setCosTotal(rs.getDouble("cos_total"));
	    	article.setVenTotal(rs.getDouble("ven_total"));
	        }
	        
	    } catch (SQLException e) {
	        throw new RuntimeException(e);
	    } finally {
	    	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
	        if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
	    }
	    
	    return article;
	}
	
	public List<SalesArticleRVC> detalleCOSTotalBebidaFromRVCFrigoBar(String fecha){//ok
	List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
	
	PreparedStatement ps=null;
	ResultSet rs=null;
	
	try {
		Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
	    
	    StringBuilder query = new StringBuilder();
	    query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu,t.over_group,outlet from (    ");
	    query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
	    query.append(" dbo.getOverGroup(s.no_product) over_group, "); 
	    query.append(" dbo.getOutlet(s.no_product) outlet    ");
	    query.append(" from dbo.sales_article_statistics s "); 
	    query.append(" where s.qty>0   ");
	    query.append(" and s.date_rvc=? ");
	    query.append(" ) t   ");
	    query.append(" where t.sales_location='RVC ROOM SERVICE (3)' and t.over_group='BEBIDA' and t.outlet='FRIGOBAR' ");
	    query.append(" order by t.product ");
	    
	    ps = conn.prepareStatement(query.toString());
	    ps.setString(1, fecha);
	    
	    rs = ps.executeQuery();
	    
	    while(rs.next()){
	    	
	    	SalesArticleRVC article=new SalesArticleRVC();
	    	article.setSalesLocation(rs.getString("sales_location"));
	    	article.setNoProduct(rs.getString("no_product"));
	    	article.setProduct(rs.getString("product"));
	    	article.setDateRvc(rs.getString("date_rvc"));
	    	article.setQty(rs.getDouble("qty"));
	    	article.setPrice(rs.getDouble("s_price"));
	    	article.setNetTotal(rs.getDouble("net_total"));
	    	article.setGrossTotal(rs.getDouble("gross_total"));
	    	article.setCosUni(rs.getDouble("cos_uni"));
	    	article.setCosTotal(rs.getDouble("cos_total"));
	    	article.setCosPorc(rs.getDouble("cos_porc"));
	    	article.setCm(rs.getDouble("cm"));
	    	article.setCmTotal(rs.getDouble("cm_total"));
	    	article.setMu(rs.getDouble("mu"));
	    	article.setPotMu(rs.getDouble("pot_mu"));
	    	article.setOverGroup(rs.getString("over_group"));
	    	article.setOutlet(rs.getString("outlet"));
	        	larticle.add(article);
	        	
	        }
	        
	    } catch (SQLException e) {
	        throw new RuntimeException(e);
	    } finally {
	    	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
	        if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
	    }
	    
	    return larticle;
	}
	
	public Double getCostoTransferenciaFromGuiaBanquetes(String fecha,String concepto){
		Double costo = 0.0; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select SUM(c.lbw_total) lbw_total "); 
            query.append(" from dbo.guia_transf_costo c ");
            query.append(" where c.lbw_date=? ");
            query.append(" and c.lbw_info LIKE '").append(concepto).append("' ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	costo=rs.getDouble("lbw_total");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return costo;
	}
	
	public List<GuiaTransfCosto> detalleCostoTransferenciaFromGuiaBanquetes(String fecha,String concepto){
		List<GuiaTransfCosto> lGuia=new LinkedList<GuiaTransfCosto>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT c.lbw_date,c.kst_id,c.kst_name,c.lbw_name,c.lbw_total,c.lbw_info ");
            query.append(" FROM dbo.guia_transf_costo c "); 
            query.append(" WHERE c.lbw_date=? ");
            query.append(" and c.lbw_info LIKE '").append(concepto).append("' ");
            query.append(" ORDER BY c.kst_name,c.lbw_name,c.lbw_info ASC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	GuiaTransfCosto guia=new GuiaTransfCosto();
            	guia.setLbwDate(rs.getString("lbw_date"));
            	guia.setKstId(rs.getInt("kst_id"));
            	guia.setKstName(rs.getString("kst_name"));
            	guia.setLbwName(rs.getString("lbw_name"));
            	guia.setLbwTotal(rs.getDouble("lbw_total"));
            	guia.setLbwInfo(rs.getString("lbw_info"));
            	lGuia.add(guia);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lGuia;
	}

	public void deleteDailyFoodAlimentos(String fecha){
		PreparedStatement ps=null;
        try {
        	
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.daily_food_alimentos WHERE trx_date=?");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	public void deleteDailyFoodBebidas(String fecha){
		PreparedStatement ps=null;
        try {
        	
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.daily_food_bebidas WHERE trx_date=?");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public Double getCostoTotalFromDailyFoodAlimentos(String fecha){
		Double costo=new Double(0.0); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT ISNULL(SUM(Total_Receiving),0) costo  FROM dbo.daily_food_alimentos WHERE trx_date=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	costo=rs.getDouble("costo");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return costo;
	}
	
	public Double getCostoTotalFromDailyFoodBebidas(String fecha){
		Double costo=new Double(0.0); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT ISNULL(SUM(Total_Receiving),0) costo  FROM dbo.daily_food_bebidas WHERE trx_date=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	costo=rs.getDouble("costo");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return costo;
	}
	
	public List<DailyFood> detalleFromDailyFoodAlimentos(String fecha){
		List<DailyFood> lGuia=new LinkedList<DailyFood>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT trx_date,Gross_Revenue,Net_Revenue,Consumption,ACT_COS,Other_Usage,Inv_Diff,POT_COS,Total_Receiving,Purchase,Transfers "); 
            query.append(" FROM dbo.daily_food_alimentos where trx_date=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	DailyFood da=new DailyFood();
            	da.setTrxDate(rs.getString("trx_date"));
            	da.setGrossRevenue(rs.getDouble("Gross_Revenue"));
            	da.setNetRevenue(rs.getDouble("Net_Revenue"));
            	da.setConsumption(rs.getDouble("Consumption"));
            	da.setActcos(rs.getDouble("ACT_COS"));
            	da.setOtherUsage(rs.getDouble("Other_Usage"));
            	da.setInvDiff(rs.getDouble("Inv_Diff"));
            	da.setPotcos(rs.getDouble("POT_COS"));
            	da.setTotalReceiving(rs.getDouble("Total_Receiving"));
            	da.setPurchase(rs.getDouble("Purchase"));
            	da.setTransfers(rs.getDouble("Transfers"));
            	lGuia.add(da);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lGuia;
	}
	
	public List<DailyFood> detalleFromDailyFoodBebidas(String fecha){
		List<DailyFood> lGuia=new LinkedList<DailyFood>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT trx_date,Gross_Revenue,Net_Revenue,Consumption,ACT_COS,Other_Usage,Inv_Diff,POT_COS,Total_Receiving,Purchase,Transfers "); 
            query.append(" FROM dbo.daily_food_bebidas where trx_date=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	DailyFood da=new DailyFood();
            	da.setTrxDate(rs.getString("trx_date"));
            	da.setGrossRevenue(rs.getDouble("Gross_Revenue"));
            	da.setNetRevenue(rs.getDouble("Net_Revenue"));
            	da.setConsumption(rs.getDouble("Consumption"));
            	da.setActcos(rs.getDouble("ACT_COS"));
            	da.setOtherUsage(rs.getDouble("Other_Usage"));
            	da.setInvDiff(rs.getDouble("Inv_Diff"));
            	da.setPotcos(rs.getDouble("POT_COS"));
            	da.setTotalReceiving(rs.getDouble("Total_Receiving"));
            	da.setPurchase(rs.getDouble("Purchase"));
            	da.setTransfers(rs.getDouble("Transfers"));
            	lGuia.add(da);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lGuia;
	}
	
	
																					public void insertarGuiasTransferencia(String insertValues){
																						PreparedStatement ps=null;
																				        try {
																				        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
																				        	StringBuilder query = new StringBuilder();
																					        query.append("INSERT INTO dbo.guia_transf(lbw_date,kst_id,kst_name,lbw_name,lbw_info,kst_name_transfer_to,kst_id_to,lbw_total,BST_NAME,art_name,sgr_name)VALUES ");
																					        query.append(insertValues);
																				            ps = conn.prepareStatement(query.toString());
																				            Integer ins=ps.executeUpdate();
																				            System.out.println("insert dbo.guia_transf_costo..."+ins);
																				        } catch (SQLException e) {
																				            throw new RuntimeException(e);
																				        } catch (Exception e) {
																				            throw new RuntimeException(e);
																				        }finally {
																				        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
																				        }
																					}
	
	public void deleteGuiasTransferencia(String fecha){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.guia_transf WHERE lbw_date=? ");
	        ps = conn.prepareStatement(query.toString());
	        ps.setString(1, fecha);
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}

	/******
	 * 
	 * 
	 */
	public List<GuiaTransfCosto> detalleGuiaTransferencia(String fecha){
		List<GuiaTransfCosto> lGuia=new LinkedList<GuiaTransfCosto>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT lbw_date ");
            query.append(" ,kst_id ");
            query.append(" ,kst_name ");
            query.append(" ,lbw_name ");
            query.append(" ,lbw_total ");
            query.append(" ,kst_name_transfer_to ");
            query.append(" ,lbw_info ");
            query.append(" ,BST_NAME ");
            query.append(" FROM dbo.guia_transf where lbw_date=? order by kst_id,kst_name_transfer_to ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	GuiaTransfCosto guia=new GuiaTransfCosto();
            	guia.setLbwDate(rs.getString("lbw_date"));
            	guia.setKstId(rs.getInt("kst_id"));
            	guia.setKstName(rs.getString("kst_name"));
            	guia.setLbwName(rs.getString("lbw_name"));
            	guia.setLbwTotal(rs.getDouble("lbw_total"));
            	guia.setLbwInfo(rs.getString("lbw_info"));
            	guia.setKstNameTransferTo(rs.getString("kst_name_transfer_to"));
            	guia.setBstName(rs.getString("BST_NAME"));
            	lGuia.add(guia);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lGuia;
	}
	
	public List<GuiaMerma> detalleGuiaMerma(String fecha){
		List<GuiaMerma> lGuia=new LinkedList<GuiaMerma>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT verbr_date ");
            query.append(" ,kst_id ");
            query.append(" ,kst_name ");
            query.append(" ,verbr_total ");
            query.append(" ,vbr_info ");
            query.append(" ,vbr_name FROM dbo.guia_merma_gasto where verbr_date=? order by kst_id,vbr_name ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	GuiaMerma guia=new GuiaMerma();
            	guia.setVerbrDate(rs.getString("verbr_date"));
            	guia.setKstId(rs.getInt("kst_id"));
            	guia.setKstName(rs.getString("kst_name"));
            	guia.setVerbrTotal(rs.getDouble("verbr_total"));
            	guia.setVbrInfo(rs.getString("vbr_info"));
            	guia.setVbrName(rs.getString("vbr_name"));
            	lGuia.add(guia);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lGuia;
	}
	
	public List<SalesArticleRVC> detalleFromRVCAll(String fecha){
		List<SalesArticleRVC> larticle = new LinkedList<SalesArticleRVC>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select t.sales_location,t.no_product,t.product,t.date_rvc,t.qty,t.s_price,t.net_total,t.gross_total,t.cos_uni,t.cos_total,t.cos_porc,t.cm,t.cm_total,t.mu,t.pot_mu, t.over_group,t.outlet from ( ");
            query.append(" select s.sales_location,s.no_product,s.product,s.date_rvc,s.qty,s.s_price,s.net_total,s.gross_total,s.cos_uni,s.cos_total,s.cos_porc,s.cm,s.cm_total,s.mu,s.pot_mu, "); 
            query.append(" dbo.getOverGroup(s.no_product) over_group, ");  
            query.append(" dbo.getOutlet(s.no_product) outlet      "); 
            query.append(" from dbo.sales_article_statistics s "); 
            query.append(" where s.qty>0  ");
            query.append(" and s.date_rvc=? and no_product<>10013 ");//-- se excluye anticipos
            query.append(" ) t where t.over_group!='SUMINISTRO'  ");//-- solo alimentos y bebidas
            query.append(" order by t.sales_location,t.over_group,t.outlet ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	SalesArticleRVC article=new SalesArticleRVC();
            	article.setSalesLocation(rs.getString("sales_location"));
            	article.setNoProduct(rs.getString("no_product"));
            	article.setProduct(rs.getString("product"));
            	article.setDateRvc(rs.getString("date_rvc"));
            	article.setQty(rs.getDouble("qty"));
            	article.setPrice(rs.getDouble("s_price"));
            	article.setNetTotal(rs.getDouble("net_total"));
            	article.setGrossTotal(rs.getDouble("gross_total"));
            	article.setCosUni(rs.getDouble("cos_uni"));
            	article.setCosTotal(rs.getDouble("cos_total"));
            	article.setCosPorc(rs.getDouble("cos_porc"));
            	article.setCm(rs.getDouble("cm"));
            	article.setCmTotal(rs.getDouble("cm_total"));
            	article.setMu(rs.getDouble("mu"));
            	article.setPotMu(rs.getDouble("pot_mu"));
            	article.setOverGroup(rs.getString("over_group"));
            	article.setOutlet(rs.getString("outlet"));
            	larticle.add(article);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}

	
	/***
	 * CHECK MICROS
	 */
	public void insertarCheckMicros(String insertValues){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("INSERT INTO dbo.checks_micros(CHECKID,cf_cnumser,cf_cnumdoc,cf_dfecdoc,cf_dfecven,cf_ccodcli,cf_cnombre,cf_ccodmon,cf_ntipcam,cf_nprecio,cf_nigv,others,cf_nimport,descuento)VALUES ");
	        query.append(insertValues);
            ps = conn.prepareStatement(query.toString());
            Integer ins=ps.executeUpdate();
            System.out.println("insert dbo.checks_micros..."+ins);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void deleteCheckMicros(String fecha){
		PreparedStatement ps=null;
        try {
        	
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.checks_micros WHERE cf_dfecdoc=?");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public List<ChecksMicros> detalleFromChecksMicros(String fecha){
		List<ChecksMicros> larticle = new LinkedList<ChecksMicros>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT CHECKID,cf_cnumser,cf_cnumdoc,cf_dfecdoc,cf_dfecven,cf_ccodcli,cf_cnombre,cf_ccodmon,cf_ntipcam,cf_nprecio,cf_nigv,others,cf_nimport,descuento "); 
            query.append(" FROM dbo.checks_micros ");
            query.append(" WHERE cf_dfecdoc=? ");
            query.append(" ORDER BY CHECKID ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	ChecksMicros cm=new ChecksMicros();
            	cm.setCheckId(rs.getString("CHECKID"));
            	cm.setCfCnumser(rs.getString("cf_cnumser"));
            	cm.setCfCnumdoc(rs.getString("cf_cnumdoc"));
            	cm.setCfDfecdoc(rs.getString("cf_dfecdoc"));
            	cm.setCfDfecven(rs.getString("cf_dfecven"));
            	cm.setCfCcodcli(rs.getString("cf_ccodcli"));
            	cm.setCfCnombre(rs.getString("cf_cnombre"));
            	cm.setCfCcodmon(rs.getString("cf_ccodmon"));
            	cm.setCfNtipcam(rs.getDouble("cf_ntipcam"));
            	cm.setCfNprecio(rs.getDouble("cf_nprecio"));
            	cm.setCfNigv(rs.getDouble("cf_nigv"));
            	cm.setOthers(rs.getDouble("others"));
            	cm.setCfNimport(rs.getDouble("cf_nimport"));
            	cm.setDescuento(rs.getDouble("descuento"));
            	larticle.add(cm);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return larticle;
	}

	public void loadXlsxOutHjtrb160(){
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryCostos160.getInstance().getConnection();
            
    		CallableStatement callableStatement = conn.prepareCall("{call dbo.SP_LOAD_XLSX_OUT_HJTRB()}");

    		callableStatement.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void insertSqlOutlHjTrb(Integer aa,Integer mm,Integer dd){
		CallableStatement cs = null;
		try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ call dbo.SP_INSERT_OUT_HJTRB(?,?,?) }");
            
            cs = conn.prepareCall(query.toString());
            cs.setInt(1, aa);
            cs.setInt(2, mm);
            cs.setInt(3, dd);  
            //--
            cs.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
	}
	
	public Integer createResumenCostos(Integer aa,Integer mm,Integer dd,String fechaCosto){
		CallableStatement cs = null;
		Integer idResumen=0;
		try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ call dbo.SP_CALCULO_RESUMEN(?,?,?,?,?) }");
            
            cs = conn.prepareCall(query.toString());
            cs.setInt(1, aa);
            cs.setInt(2, mm);
            cs.setInt(3, dd);  
            cs.setString(4, fechaCosto);
            cs.registerOutParameter(5, java.sql.Types.INTEGER);
            //--
            cs.execute();
            idResumen=cs.getInt(5);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return idResumen;
	}
	
	
	public Resumen getResumenCosto(String fecha){
		Resumen resumen = new Resumen(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT r.id_resumen ");
            query.append(" ,convert(varchar(10),r.fecha_resumen, 103) fecha_resumen ");
            query.append(" ,r.total_venta_aud ");
            query.append(" ,r.total_venta_rvc ");
            query.append(" ,r.total_descuento_check ");
            query.append(" ,r.total_venta ");
            query.append(" ,r.total_costo_rvc ");
            query.append(" ,r.total_costo_transf_abierta ");
            query.append(" ,r.total_costo ");
            query.append(" ,r.porc_costo_venta ");
            query.append(" FROM dbo.resumen r WHERE convert(varchar(10),r.fecha_resumen, 103)=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	resumen.setFechaCosto(rs.getString("fecha_resumen"));
            	resumen.setTotalVentaAud(rs.getDouble("total_venta_aud"));
            	resumen.setTotalVentaRvc(rs.getDouble("total_venta_rvc"));
            	resumen.setTotalDescCheck(rs.getDouble("total_descuento_check"));
            	resumen.setTotalVenta(rs.getDouble("total_venta"));
            	resumen.setTotalCostoRvc(rs.getDouble("total_costo_rvc"));
            	resumen.setTotalCostoAbiertoTransf(rs.getDouble("total_costo_transf_abierta"));
            	resumen.setTotalCosto(rs.getDouble("total_costo"));
            	resumen.setPorcCostoVenta(rs.getDouble("porc_costo_venta"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return resumen;
	}

	
	/*
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * a CSV
	 */
	
	public List<String> listarResumen(Integer idResumen){
		List<String> lista = new LinkedList<String>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT CONCAT('id_resumen',';','fecha_resumen',';','total_venta_aud',';','total_venta_rvc',';','total_descuento_check',';','total_venta',';','total_costo_rvc',';','total_costo_transf_abierta',';','total_costo',';','porc_costo_venta') ");
            query.append(" UNION ALL ");
            query.append(" SELECT CONCAT([id_resumen],';',[fecha_resumen],';',[total_venta_aud],';',[total_venta_rvc],';',[total_descuento_check],';',[total_venta],';',[total_costo_rvc],';',[total_costo_transf_abierta],';',[total_costo],';',[porc_costo_venta]) ");
            query.append(" FROM [db_costos].[dbo].[resumen] WHERE id_resumen=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idResumen);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	String registro=rs.getString(1);
            	lista.add(registro);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<String> listarResumenAuditoria(Integer idResumen){
		List<String> lista = new LinkedList<String>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT CONCAT('fechaAuditoria',';','CRoom_Service',';','BRoom_Service',';','CKnossos',';','BKnossos',';','CLobby_Bar',';','BLobby_Bar',';','COceanus',';','BOceanus',';','CDelphos',';','BDelphos',';','CknoEvt',';','BknoEvt',';', ");
            query.append(" 'CBanquetes',';','BBanquetes',';','CExecut_Floor',';','CbCasino',';','HDesay_Incluido',';','BServibar',';','fecha_resumen',';','tipo_resumen',';','id_resumen',';','rvc_Desay_Inc_Buff_102017') ");
            query.append(" UNION ALL ");
            query.append(" SELECT CONCAT(fechaAuditoria,';',CRoom_Service,';',BRoom_Service,';',CKnossos,';',BKnossos,';',CLobby_Bar,';',BLobby_Bar,';',COceanus,';',BOceanus,';',CDelphos,';',BDelphos,';',CknoEvt,';',BknoEvt,';', ");
            query.append(" CBanquetes,';',BBanquetes,';',CExecut_Floor,';',CbCasino,';',HDesay_Incluido,';',BServibar,';',fecha_resumen,';',tipo_resumen,';',id_resumen,';',rvc_Desay_Inc_Buff_102017) ");
            query.append(" FROM db_costos.dbo.resumen_auditoria WHERE id_resumen=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idResumen);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	String registro=rs.getString(1);
            	lista.add(registro);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<String> listarResumenCheck(Integer idResumen){
		List<String> lista = new LinkedList<String>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT CONCAT('CHECKID',';','cf_cnumser',';','cf_cnumdoc',';','cf_dfecdoc',';','cf_dfecven',';','cf_ccodcli',';','cf_cnombre',';','cf_ccodmon',';' ");
            query.append(" ,'cf_ntipcam',';','cf_nprecio',';','cf_nigv',';','others',';','cf_nimport',';','descuento',';','fecha_resumen',';','tipo_resumen',';','id_resumen') ");
            query.append(" UNION ALL ");
            query.append(" SELECT CONCAT(CHECKID,';',cf_cnumser,';',cf_cnumdoc,';',cf_dfecdoc,';',cf_dfecven,';',cf_ccodcli,';',cf_cnombre,';',cf_ccodmon,';', ");
            query.append(" cf_ntipcam,';',cf_nprecio,';',cf_nigv,';',others,';',cf_nimport,';',descuento,';',fecha_resumen,';',tipo_resumen,';',id_resumen) ");
            query.append(" FROM dbo.resumen_check WHERE id_resumen=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idResumen);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	String registro=rs.getString(1);
            	lista.add(registro);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<String> listarResumenMerma(Integer idResumen){
		List<String> lista = new LinkedList<String>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT CONCAT('verbr_date',';','kst_id',';','kst_name',';','verbr_total',';','vbr_info',';','vbr_name',';','fecha_resumen',';','tipo_resumen',';','id_resumen',';','clasificacion') ");
            query.append(" UNION ALL ");
            query.append(" SELECT CONCAT(verbr_date,';',kst_id,';',kst_name,';',verbr_total,';',vbr_info,';',vbr_name,';',fecha_resumen,';',tipo_resumen,';',id_resumen,';',clasificacion) FROM db_costos.dbo.resumen_merma WHERE id_resumen=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idResumen);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	String registro=rs.getString(1);
            	lista.add(registro);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<String> listarResumenRvc(Integer idResumen){
		List<String> lista = new LinkedList<String>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT CONCAT('sales_location',';','no_product',';','product',';','date_rvc',';','qty',';','s_price',';','net_total',';','gross_total',';','cos_uni',';', ");
            query.append(" 'cos_total',';','cos_porc',';','cm',';','cm_total',';','mu',';','pot_mu',';','fecha_resumen',';','tipo_resumen',';','id_resumen',';','sgr_name') ");
            query.append(" UNION ALL ");
            query.append(" SELECT CONCAT(sales_location,';',no_product,';',product,';',date_rvc,';',qty,';',s_price,';',net_total,';',gross_total,';',cos_uni,';', ");
            query.append(" cos_total,';',cos_porc,';',cm,';',cm_total,';',mu,';',pot_mu,';',fecha_resumen,';',tipo_resumen,';',id_resumen,';',sgr_name) ");
            query.append(" FROM db_costos.dbo.resumen_rvc WHERE id_resumen=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idResumen);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	String registro=rs.getString(1);
            	lista.add(registro);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<String> listarResumenTransferencia(Integer idResumen){
		List<String> lista = new LinkedList<String>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT CONCAT('lbw_date',';','kst_id',';','kst_name',';','lbw_name',';','lbw_total',';','kst_name_transfer_to',';','sales_location',';', ");
            query.append(" 'lbw_info',';','BST_NAME',';','fecha_resumen',';','tipo_resumen',';','id_resumen',';','clasificacion',';','art_name',';','sgr_name') ");
            query.append(" UNION ALL ");
            query.append(" SELECT CONCAT(lbw_date,';',kst_id,';',kst_name,';',lbw_name,';',lbw_total,';',kst_name_transfer_to,';',rvc_name,';', ");
            query.append(" lbw_info,';',BST_NAME,';',fecha_resumen,';',tipo_resumen,';',id_resumen,';',clasificacion,';',art_name,';',sgr_name) ");
            query.append(" FROM dbo.resumen_transferencia WHERE id_resumen=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idResumen);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	String registro=rs.getString(1);
            	lista.add(registro);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}

	
	/**
	 * delete
	 */
	
	public void deleteSparte(){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.sparte");
	        ps = conn.prepareStatement(query.toString());
            ps.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void deleteSparteGr(){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.spartegr");
	        ps = conn.prepareStatement(query.toString());
            ps.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void deleteProdukt(){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryCostos.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("DELETE FROM dbo.produkt");
	        ps = conn.prepareStatement(query.toString());
            ps.execute();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
}

