package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import com.delfines.dao.ConnectionFactoryMaterial;
import com.delfines.dao.ConnectionFactoryOpera;
import com.delfines.dao.ConnectionFactoryCostos;

public class MaterialBo {
	
	public String getInsertSqlSParte(){
		StringBuffer sql=new StringBuffer();  
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryMaterial.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select p.spa_id,p.spa_name,p.sgr_id from MCDATA.SPARTE p ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	sql.append("(");
            	sql.append(rs.getString("spa_id")).append(",");
            	sql.append("'").append(rs.getString("spa_name")).append("',");
            	sql.append(rs.getString("sgr_id"));
            	sql.append("),");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return sql.toString().substring(0, sql.toString().length()-1);
	}
	
	public String getInsertSqlSParteGR(){
		StringBuffer sql=new StringBuffer();  
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryMaterial.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select p.sgr_id,p.sgr_name from MCDATA.SPARTEGR p ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	sql.append("(");
            	sql.append(rs.getString("sgr_id")).append(",");
            	sql.append("'").append(rs.getString("sgr_name")).append("'");
            	sql.append("),");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return sql.toString().substring(0, sql.toString().length()-1);
	}
	
	
	public void getInsertSqlProdukt(){
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryMaterial.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select p.PRO_PLU,P.PRO_NAME,p.pro_id,p.kst_id,p.kst_id2,p.spa_id,p.pro_preis1 from mcdata.produkt p ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            CostosBo costos =new CostosBo();
            while(rs.next()){
            	StringBuffer sql=new StringBuffer();  
            	sql.append("(");
            	sql.append(rs.getString("PRO_PLU")).append(",");
            	sql.append("'").append(rs.getString("PRO_NAME")).append("',");
            	sql.append(rs.getString("pro_id")).append(",");
            	sql.append(rs.getString("kst_id")).append(",");
            	sql.append(rs.getString("kst_id2")).append(",");
            	sql.append(rs.getString("spa_id")).append(",");
            	sql.append(rs.getString("pro_preis1"));
            	sql.append(")");
            	
            	costos.insertarProdukt(sql.toString());
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	
	public String getInsertSqlGuiasTransferenciaCosto(String fecha){
		PreparedStatement ps=null;
		ResultSet rs=null;
		StringBuffer sql=new StringBuffer();  
        try {
        	Connection conn = ConnectionFactoryMaterial.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT ? FECHA,K.KST_ID,K.KST_NAME,HL.LBW_NAME,hl.lbw_info,SUM(I.WES_MENGE*I.WES_ESP) total_guia ");
            query.append(" FROM MCDATA.INVWES I ");
            query.append(" INNER JOIN MCDATA.HIS_LAGERBEW HL ON (I.WES_ID1 = HL.LBW_ID) ");
            query.append(" INNER JOIN MCDATA.KOSTST K ON (K.KST_ID=HL.KST_ID) ");
            query.append(" WHERE ((HL.LBW_DATUM >= TO_DATE(?||'00:00:00', 'DD/MM/YYYY HH24:MI:SS')) ");
            query.append(" AND (HL.LBW_DATUM <= TO_DATE(?||'23:59:59', 'DD/MM/YYYY HH24:MI:SS'))) ");
            query.append(" AND hl.kst_id1 IN ( ");
            query.append(" SELECT KST_ID FROM MCDATA.kostst WHERE KST_NAME LIKE 'LOG%' ");
            query.append(" ) ");
            query.append(" AND I.WES_TYP=2 ");
            query.append(" GROUP BY K.KST_ID,K.KST_NAME,HL.LBW_NAME,hl.lbw_info ");
            query.append(" ORDER BY hl.lbw_info DESC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, fecha);
            ps.setString(3, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	sql.append("(");
            	sql.append("'").append(rs.getString("FECHA")).append("',");
            	sql.append(rs.getString("KST_ID")).append(",");
            	sql.append("'").append(rs.getString("KST_NAME")).append("',");
            	sql.append("'").append(rs.getString("LBW_NAME")).append("',");
            	sql.append("'").append(rs.getString("lbw_info")).append("',");
            	sql.append(rs.getString("TOTAL_GUIA"));
            	sql.append("),");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        if(sql.toString().trim().length()>0)
        	return sql.toString().substring(0, sql.toString().length()-1);
        else
        	return null;
	}
	
	
	public String getInsertSqlGuiasTransferenciaGasto(String fecha){
		PreparedStatement ps=null;
		ResultSet rs=null;
		StringBuffer sql=new StringBuffer();  
        try {
        	Connection conn = ConnectionFactoryMaterial.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT ? FECHA,K.KST_ID,K.KST_NAME,HL.LBW_NAME,hl.lbw_info,SUM(I.WES_MENGE*I.WES_ESP) total_guia ");
            query.append(" FROM MCDATA.INVWES I ");
            query.append(" INNER JOIN MCDATA.HIS_LAGERBEW HL ON (I.WES_ID1 = HL.LBW_ID) ");
            query.append(" INNER JOIN MCDATA.KOSTST K ON (K.KST_ID=HL.KST_ID) ");
            query.append(" WHERE ((HL.LBW_DATUM >= TO_DATE(?||'00:00:00', 'DD/MM/YYYY HH24:MI:SS')) ");
            query.append(" AND (HL.LBW_DATUM <= TO_DATE(?||'23:59:59', 'DD/MM/YYYY HH24:MI:SS'))) ");
            query.append(" AND hl.kst_id1 IN ( ");
            query.append(" SELECT KST_ID FROM MCDATA.kostst WHERE KST_NAME LIKE 'CC%' ");
            query.append(" ) ");
            query.append(" AND I.WES_TYP=2 ");
            query.append(" GROUP BY K.KST_ID,K.KST_NAME,HL.LBW_NAME,hl.lbw_info ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, fecha);
            ps.setString(3, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	sql.append("(");
            	sql.append("'").append(rs.getString("FECHA")).append("',");
            	sql.append(rs.getString("KST_ID")).append(",");
            	sql.append("'").append(rs.getString("KST_NAME")).append("',");
            	sql.append("'").append(rs.getString("LBW_NAME")).append("',");
            	sql.append("'").append(rs.getString("lbw_info")).append("',");
            	sql.append(rs.getString("TOTAL_GUIA"));
            	sql.append("),");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        if(sql.toString().trim().length()>0)
        	return sql.toString().substring(0, sql.toString().length()-1);
        else
        	return null;
	}
	
	
	public String getInsertSqlGuiasMermaGasto(String fecha){
		PreparedStatement ps=null;
		ResultSet rs=null;
		StringBuffer sql=new StringBuffer();  
        try {
        	Connection conn = ConnectionFactoryMaterial.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT ? FECHA,k.kst_id,k.kst_name,SUM(I.WES_MENGE*I.WES_ESP*-1) monto_total,HV.VBR_INFO,HV.VBR_NAME ");
            query.append(" FROM MCDATA.INVWES I,  ");
            query.append(" MCDATA.kostst K,  ");
            query.append(" MCDATA.HIS_VERBRAUCH HV  ");
            query.append(" WHERE ( I.WES_TYP IN (30,31) ) ");
            query.append(" AND ( I.WES_ID1 = HV.VBR_ID ) "); 
            query.append(" AND ( K.KST_ID=I.kst_id)  ");
            query.append(" AND ( (HV.VBR_DATUM >= TO_DATE(?||'00:00:00', 'DD/MM/YYYY HH24:MI:SS')) ");
            query.append(" AND (HV.VBR_DATUM <= TO_DATE(?||'23:59:59', 'DD/MM/YYYY HH24:MI:SS')) ) ");
            query.append(" GROUP BY HV.VBR_ID,k.kst_id,k.kst_name,HV.VBR_INFO,HV.VBR_NAME ");
            query.append(" ORDER BY HV.VBR_NAME ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, fecha);
            ps.setString(3, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	sql.append("(");
            	sql.append("'").append(rs.getString("FECHA")).append("',");
            	sql.append(rs.getString("KST_ID")).append(",");
            	sql.append("'").append(rs.getString("KST_NAME")).append("',");
            	sql.append(rs.getString("monto_total")).append(",");
            	sql.append("'").append(rs.getString("VBR_INFO")).append("',");
            	sql.append("'").append(rs.getString("VBR_NAME")).append("'");
            	sql.append("),");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        if(sql.toString().trim().length()>0)
        	return sql.toString().substring(0, sql.toString().length()-1);
        else
        	return null;
	}
	
	
	public String getInsertSqlGuiasTransferencia(String fecha){
		PreparedStatement ps=null;
		ResultSet rs=null;
		StringBuffer sql=new StringBuffer();  
        try {
        	Connection conn = ConnectionFactoryMaterial.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            /*query.append(" SELECT ? FECHA,K.KST_ID,K.KST_NAME,HL.LBW_NAME,K_TO.KST_NAME KST_NAME_TRANSFER_TO,K_TO.KST_ID KST_ID_TO,NVL(hl.lbw_info,'-')lbw_info,SUM(I.WES_MENGE*I.WES_ESP) total_guia,OW.BST_NAME "); 
            query.append(" FROM MCDATA.INVWES I  ");
            query.append(" INNER JOIN MCDATA.HIS_LAGERBEW HL ON (I.WES_ID1 = HL.LBW_ID) ");
            query.append(" LEFT JOIN MCDATA.BESTELLER OW ON (OW.BST_ID=HL.LBW_OWNER) ");
            query.append(" INNER JOIN MCDATA.KOSTST K ON (K.KST_ID=HL.KST_ID)  ");
            query.append(" INNER JOIN MCDATA.KOSTST K_TO ON (K_TO.KST_ID=HL.KST_ID1)  ");
            query.append(" WHERE ((HL.LBW_DATUM >= TO_DATE(?||'00:00:00', 'DD/MM/YYYY HH24:MI:SS'))  ");
            query.append(" AND (HL.LBW_DATUM <= TO_DATE(?||'23:59:59', 'DD/MM/YYYY HH24:MI:SS'))) "); 
            query.append(" AND I.WES_TYP=2  ");
            query.append(" GROUP BY K.KST_ID,K.KST_NAME,K_TO.KST_NAME,K_TO.KST_ID,HL.LBW_NAME,hl.lbw_info,OW.BST_NAME ");
            query.append(" ORDER BY hl.lbw_info DESC ");*/
            
            query.append(" SELECT ? FECHA,K.KST_ID,K.KST_NAME,HL.LBW_NAME,K_TO.KST_NAME KST_NAME_TRANSFER_TO,K_TO.KST_ID KST_ID_TO,NVL(hl.lbw_info,'-')lbw_info, ");
            query.append(" (I.WES_MENGE*I.WES_ESP) total_guia ");
            query.append(" ,OW.BST_NAME  ");
            query.append(" ,ar.art_name ");
            query.append(" ,SPG.SGR_NAME ");
            query.append(" FROM MCDATA.INVWES I ");  
            query.append(" INNER JOIN MCDATA.HIS_LAGERBEW HL ON (I.WES_ID1 = HL.LBW_ID) "); 
            query.append(" LEFT JOIN MCDATA.BESTELLER OW ON (OW.BST_ID=HL.LBW_OWNER)  ");
            query.append(" INNER JOIN MCDATA.KOSTST K ON (K.KST_ID=HL.KST_ID)   ");
            query.append(" INNER JOIN MCDATA.KOSTST K_TO ON (K_TO.KST_ID=HL.KST_ID1) ");  
            query.append(" INNER JOIN MCDATA.artikel AR ON (AR.ART_ID=I.ART_ID) ");
            query.append(" INNER JOIN MCDATA.warengruppe WG ON (wg.wgr_id=ar.wgr_id) ");
            query.append(" INNER JOIN MCDATA.sparte SP ON (SP.SPA_ID=wg.spa_id) ");
            query.append(" INNER JOIN MCDATA.spartegr SPG ON (spg.sgr_id=sp.sgr_id) ");
            query.append(" WHERE ((HL.LBW_DATUM >= TO_DATE(?||'00:00:00', 'DD/MM/YYYY HH24:MI:SS')) ");  
            query.append(" AND (HL.LBW_DATUM <= TO_DATE(?||'23:59:59', 'DD/MM/YYYY HH24:MI:SS')))   ");
            query.append(" AND I.WES_TYP=2   ");
            query.append(" ORDER BY hl.lbw_info DESC ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, fecha);
            ps.setString(3, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	sql.append("(");
            	sql.append("'").append(rs.getString("FECHA")).append("',");
            	sql.append(rs.getString("KST_ID")).append(",");
            	sql.append("'").append(rs.getString("KST_NAME")).append("',");
            	sql.append("'").append(rs.getString("LBW_NAME")).append("',");
            	sql.append("'").append(rs.getString("lbw_info")).append("',");
            	sql.append("'").append(rs.getString("KST_NAME_TRANSFER_TO")).append("',");
            	sql.append(rs.getString("KST_ID_TO")).append(",");
            	sql.append(rs.getString("TOTAL_GUIA")).append(",");
            	sql.append("'").append(rs.getString("BST_NAME")).append("',");
            	sql.append("'").append(rs.getString("art_name").replaceAll("'","")).append("',");
            	sql.append("'").append(rs.getString("SGR_NAME")).append("'");
            	sql.append("),");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        if(sql.toString().trim().length()>0)
        	return sql.toString().substring(0, sql.toString().length()-1);
        else
        	return null;
	}
	
}
