package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import com.delfines.dao.ConnectionFactoryOpera;
import com.delfines.dao.ConnectionFactoryCostos;

public class OperaBo {
	
	public String getInsertSqlFinJrnlArticles(String date){
		StringBuffer sql=new StringBuffer();  
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" SELECT TO_CHAR(ft.trx_date,'DD/MM/RRRR') trx_date,ft.quantity,ft.room,ft.article_id,ac.article_code,ac.description,ft.guest_account_debit,ft.guest_account_credit,ft.cashier_id,ft.cashier_name "); 
            query.append(" FROM financial_transactions_view ft, ");
            query.append(" article$_codes ac ");
            query.append(" WHERE ft.resort = 'DELFINES' ");
            query.append(" AND ft.trx_date between TO_DATE(?,'DD/MM/RRRR') and TO_DATE(?,'DD/MM/RRRR') ");
            query.append(" AND ft.trx_type <> 'PACKAGE'  ");
            query.append(" AND ft.is_internal_yn = 'N' ");
            query.append(" AND ft.article_id is not null ");
            query.append(" AND ft.article_id=ac.article_id(+) ");
            query.append(" AND ft.resort=ac.resort(+) ");
            query.append(" AND ft.trx_code=2420 ");
            query.append(" AND ft.posted_amount>0 ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, date);
            ps.setString(2, date);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	sql.append("(");
            	sql.append(rs.getString("quantity")).append(",");
            	sql.append("'").append(rs.getString("room")).append("',");
            	sql.append(rs.getString("article_id")).append(",");
            	sql.append("'").append(rs.getString("article_code")).append("',");
            	sql.append("'").append(rs.getString("description")).append("',");
            	sql.append(rs.getString("guest_account_debit")).append(",");
            	sql.append(rs.getString("guest_account_credit")).append(",");
            	sql.append(rs.getString("cashier_id")).append(",");
            	sql.append("'").append(rs.getString("cashier_name")).append("',");
            	sql.append("'").append(rs.getString("trx_date")).append("'");
            	sql.append("),");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        if(sql.toString().trim().length()>0)
        	return sql.toString().substring(0, sql.toString().length()-1);
        else
        	return null;
	}
	
	
	
	
	
}