package com.delfines.business;

import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

public class Util {
	
	public static Double stringToDouble(String numeric){
		Double number=0.0; 
		try{
			number=new Double(numeric);	
		}catch(Exception e){
			
		}
		return number;
	}
	
	public static java.sql.Date stringToDate(String date){
		java.sql.Date sqlDate=null; 
		try{
			SimpleDateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy"); 
	        sqlDate = new java.sql.Date(dateFormat.parse(date).getTime());	
		}catch(Exception e){
			e.printStackTrace();
		}
		return sqlDate;
	}
	
	public static String format(Double number){
		String value="0.00"; 
		try{
			NumberFormat nf = NumberFormat.getNumberInstance(new Locale("en", "US"));
			nf.setMaximumFractionDigits(2);
			nf.setMinimumFractionDigits(2);
		    value = nf.format(number);
		}catch(Exception e){
			e.printStackTrace();
		}
		return value;
	}

	public static String dateToString(Date date){
		String value="";
		try{
			SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
			value = sdf.format(date);
		}catch(Exception e){
			e.printStackTrace();
		}
		return value;
	}
	
	public static boolean isValidDate(String inDate) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy");
        dateFormat.setLenient(false);
        try {
            dateFormat.parse(inDate.trim());
        } catch (ParseException pe) {
            return false;
        }
        return true;
    }
	
}
