package com.delfines.dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public final class ConnectionFactoryOpera {
	
	public static final String URL = "jdbc:oracle:thin:opera/opera@10.0.0.185:1521:opera";
	
	private static ConnectionFactoryOpera instance;
    private Connection connection;

    private ConnectionFactoryOpera() {
        this.connect();
    }
	
	public static ConnectionFactoryOpera getInstance() {
        if (ConnectionFactoryOpera.instance == null) {
        	ConnectionFactoryOpera.instance = new ConnectionFactoryOpera();
        }
        return ConnectionFactoryOpera.instance;
    }
	
	private void connect() {
        try {
        	Class.forName("oracle.jdbc.driver.OracleDriver");  
			this.connection=DriverManager.getConnection(URL);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
	
	public Connection getConnection() {
		try {
			this.connection=DriverManager.getConnection(URL);
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return this.connection;
    }
   
    public static void main(String[] args) {
    	String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select sysdate as hoy from dual ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            System.out.println(fecha);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
    }
	
	
}
