package read;

import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.activation.DataSource;
import javax.mail.util.ByteArrayDataSource;

import org.apache.poi.hssf.usermodel.HSSFDataFormat;
import org.apache.poi.ss.usermodel.BorderStyle;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.DataFormat;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import com.delfines.business.CostosBo;
import com.delfines.business.MaterialBo;
import com.delfines.business.Util;
import com.delfines.sendmail.SendEmail;

import vo.ChecksMicros;
import vo.DailyFood;
import vo.FinJrnlArticles;
import vo.GuiaMerma;
import vo.GuiaTransfCosto;
import vo.OutlHjTrb;
import vo.Resumen;
import vo.SalesArticleRVC;

public class CostoDiario {

	private String rutaArchivo=null;
	
	private String fechaCosto=null;
	private Double tipoCambio=null;
	
	private String archivoxls=null;
	private XSSFWorkbook libro= null;
	
//	public static void main(String[] args) {
//		/**Se ejecuta en la BD de 10.0.0.160**/
//		try{
//			ReadFinJrnlArticles r =new ReadFinJrnlArticles();
//			r.insertSparteGR();//ok
//			r.insertSparte();//ok
//			r.insertProdukt();//ok
//		}catch(Exception e){
//			e.printStackTrace();
//		}
//		
//		try{
//			CostoDiario costo=new CostoDiario();
//	        costo.copyLoadXlsxOutlHjTrb160();//ok
//		}catch(Exception e){
//			System.out.println(e.getMessage());
//		}
//		
//	}
	
	public static void main(String[] args) {
		if(args.length>0&&Util.isValidDate(args[0])){
			String fecha =args[0];
			System.out.println("===>opt "+fecha);
			try{
				Calendar cal = Calendar.getInstance();
				cal.setTime(Util.stringToDate(fecha));
				
		    	String date=Util.dateToString(cal.getTime());
		    	
		    	System.out.println("Inicia proceso Calculo Costo Diario "+date);
		        
	        	String sDate=date.replaceAll("/", "");
	        	CostoDiario costo=new CostoDiario(date,3.5,"\\\\10.0.0.11\\De Paso\\COSTOS\\Diario\\"+sDate+"\\");
	        	
	        	costo.readExcelAuditoriaAll();//ok
				costo.readGuiasTransferAll();//ok (fecha)
				costo.readChecksMicrosAll();//ok (fecha)
				Integer idResumen=costo.createResumenCostos();//ok (fecha)
				costo.createCSVCostosAll(idResumen);//ok (fecha)
		        
		        System.out.println("Termina proceso Calculo Costo Diario "+date+" - "+idResumen);
		        
			}catch(Exception e){
				System.out.println(e.getMessage());
			}
		}
		
	}
	
	public void createCSVCostosAll(Integer idResumen){
		try{
			String fechasingle=fechaCosto.replaceAll("/", "");
			String path="";
			File file = null;
			FileWriter fw =null;
			BufferedWriter bw =null;
					
			CostosBo costo=new CostosBo();
			List<String> lResumen=costo.listarResumen(idResumen);
			List<String> lResumenAuditoria=costo.listarResumenAuditoria(idResumen);
			List<String> lResumenCheck=costo.listarResumenCheck(idResumen);
			List<String> lResumenMerma=costo.listarResumenMerma(idResumen);
				List<String> lResumenRvc=costo.listarResumenRvc(idResumen);
				List<String> lResumenTransferencia=costo.listarResumenTransferencia(idResumen);
			
			//Lista Resumen
			path=this.rutaArchivo+"\\"+"resumen_"+fechasingle+".csv";
			file = new File(path);
			if (!file.exists()) {
	             file.createNewFile();
	        }
			fw = new FileWriter(file.getAbsoluteFile());
	        bw = new BufferedWriter(fw);
	        
	        for (String detalle : lResumen) {
	        	bw.write(detalle+"\n");
	        }
	        bw.close();
	        
	        //Lista Resumen Auditoria
			path=this.rutaArchivo+"\\"+"resumen_auditoria_"+fechasingle+".csv";
			file = new File(path);
			if (!file.exists()) {
	             file.createNewFile();
	        }
			fw = new FileWriter(file.getAbsoluteFile());
	        bw = new BufferedWriter(fw);
	        
	        for (String detalle : lResumenAuditoria) {
	        	bw.write(detalle+"\n");
	        }
	        bw.close();
	        
	        //Lista Resumen Check
			path=this.rutaArchivo+"\\"+"resumen_check_"+fechasingle+".csv";
			file = new File(path);
			if (!file.exists()) {
	             file.createNewFile();
	        }
			fw = new FileWriter(file.getAbsoluteFile());
	        bw = new BufferedWriter(fw);
	        
	        for (String detalle : lResumenCheck) {
	        	bw.write(detalle+"\n");
	        }
	        bw.close();
	        
	        //Lista Resumen Merma
			path=this.rutaArchivo+"\\"+"resumen_merma_"+fechasingle+".csv";
			file = new File(path);
			if (!file.exists()) {
	             file.createNewFile();
	        }
			fw = new FileWriter(file.getAbsoluteFile());
	        bw = new BufferedWriter(fw);
	        
	        for (String detalle : lResumenMerma) {
	        	bw.write(detalle+"\n");
	        }
	        bw.close();
	        
	        //Lista Resumen Rvc
			path=this.rutaArchivo+"\\"+"resumen_rvc_"+fechasingle+".csv";
			file = new File(path);
			if (!file.exists()) {
	             file.createNewFile();
	        }
			fw = new FileWriter(file.getAbsoluteFile());
	        bw = new BufferedWriter(fw);
	        
	        for (String detalle : lResumenRvc) {
	        	bw.write(detalle+"\n");
	        }
	        bw.close();
	        
	        //Lista Resumen Guia Transferencia
			path=this.rutaArchivo+"\\"+"resumen_guia_"+fechasingle+".csv";
			file = new File(path);
			if (!file.exists()) {
	             file.createNewFile();
	        }
			fw = new FileWriter(file.getAbsoluteFile());
	        bw = new BufferedWriter(fw);
	        
	        for (String detalle : lResumenTransferencia) {
	        	bw.write(detalle+"\n");
	        }
	        bw.close();
	        
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public CostoDiario(){
		
	}
	
	public void sendMail(){
		/***
         * Envio por correo electronico                 * 
         */
		try{
			ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
			this.libro.write(outputStream); //
			
			DataSource aAttachment =  new ByteArrayDataSource(outputStream.toByteArray(), "application/vnd.ms-excel");
			
            String subject="Costo Diario - "+this.fechaCosto;
	   		String text="Mediante el presente adjuntamos el costo diario correspondiente a "+this.fechaCosto+".\n\nAtentamente,\nhttps://www.losdelfineshotel.com/";
	   		String toList="cchaucca@losdelfineshotel.com.pe";
	   		String ccList="jpolar@losdelfineshotel.com.pe";
	   		SendEmail.sendEmailLead(toList, ccList, subject, text,aAttachment,"Costo_Diario_"+this.fechaCosto+".xlsx");
		   		
	   		outputStream.close();
	   	    
		}catch(Exception e){
			e.printStackTrace();
		}
   		/***
         * Envio por correo electronico                 * 
         */
	}
	
	public CostoDiario(String fechaCosto,Double tipoCambio,String rutaCostos){
		if(fechaCosto!=null&&tipoCambio!=null){
			this.fechaCosto=fechaCosto;
			this.tipoCambio=tipoCambio;
			
			String fechasingle=fechaCosto.replaceAll("/", "");
			
			this.rutaArchivo= rutaCostos+"\\";
			
			this.libro=new XSSFWorkbook();
			
			this.archivoxls=this.rutaArchivo+"Costo_Diario_"+fechasingle+".xlsx";
		}
	}
	
	public void copyLoadXlsxOutlHjTrb160()throws RuntimeException{
		try{
			ReadExcelAuditoria excel=new ReadExcelAuditoria();
			excel.copyLoadXlsxOutlHjTrb160();
		}catch(Exception e){
			throw new RuntimeException(e);
		}
	}
	
	public void readExcelAuditoriaAll()throws RuntimeException{
		try{
			ReadExcelAuditoria excel=new ReadExcelAuditoria(this.rutaArchivo);
			excel.insertSqlOutlHjTrb(this.fechaCosto);//ok
			excel.insertSqlSalesArticleStatistics(this.fechaCosto);//ok
		}catch(Exception e){
			throw new RuntimeException(e);
		}
	}
	
	public void readExcelAuditoria()throws RuntimeException{
		try{
			ReadExcelAuditoria excel=new ReadExcelAuditoria(this.rutaArchivo);
			/*excel.insertSqlOutlHjTrb(LasRow);*/
			excel.insertSqlSalesArticleStatistics(this.fechaCosto);
			excel.insertSqlDailyFoodAlimentos(this.fechaCosto);
			excel.insertSqlDailyFoodBebidas(this.fechaCosto);
		}catch(Exception e){
			throw new RuntimeException(e);
		}
	}
	
	public void readGuiasTransferAll(){
		ReadFinJrnlArticles obj=new ReadFinJrnlArticles();
		obj.insertFinJrnlArticles(this.fechaCosto);
			obj.insertGuiasTransferencia(this.fechaCosto); //ALL
			obj.insertGuiasMermaGasto(this.fechaCosto); //ALL
	}
	
	public  void readChecksMicrosAll() {
		ReadFinJrnlArticles obj=new ReadFinJrnlArticles();
		obj.insertChecksMicros(this.fechaCosto);
	}
	
	
	public  Integer createResumenCostos() {
		Integer idResumen=0;
		CostosBo bo=new CostosBo();
		
		Date fecha=Util.stringToDate(this.fechaCosto);
		
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(fecha);
				
		Integer aa=calendar.get(Calendar.YEAR);
		Integer mm=calendar.get(Calendar.MONTH)+1;
		Integer dd=calendar.get(Calendar.DAY_OF_MONTH);
		
		idResumen=bo.createResumenCostos(aa,mm,dd,this.fechaCosto);
		
		return idResumen;
	}
	
	public void readGuiasTransfer(){
		ReadFinJrnlArticles obj=new ReadFinJrnlArticles();
		obj.insertFinJrnlArticles(this.fechaCosto);
			obj.insertGuiasTransferenciaCosto(this.fechaCosto);
			obj.insertGuiasTransferenciaGasto(this.fechaCosto);
			obj.insertGuiasMermaGasto(this.fechaCosto);
	}
	
	public void createExcelCostosAll(){
		try{
			CellStyle style=libro.createCellStyle();
			DataFormat format = libro.createDataFormat();
			style.setDataFormat(format.getFormat("###,###.00;[Red]-###,###.00")); // custom number format
			  
			CellStyle pstyle=libro.createCellStyle();
			pstyle.setDataFormat(HSSFDataFormat.getBuiltinFormat("0.00%"));
			pstyle.setBorderBottom(BorderStyle.THIN);
			
			CellStyle sstyle=libro.createCellStyle();
			sstyle.setDataFormat(format.getFormat("###,###.00;[Red]-###,###.00")); // custom number format
			sstyle.setBorderTop(BorderStyle.DOUBLE);
			
			CellStyle bstyle=libro.createCellStyle();
			bstyle.setDataFormat(format.getFormat("###,###.00;[Red]-###,###.00")); // custom number format
			bstyle.setBorderBottom(BorderStyle.DOUBLE);
			
			Integer fila=0;
			
			CostosBo bo=new CostosBo();
			
			XSSFSheet hoja0 = libro.createSheet("Resumen");
			getCell(hoja0,0,++fila).setCellValue(fechaCosto);
			
			Resumen resumen=bo.getResumenCosto(fechaCosto);/******************************************************VENTAS AUDITORIA**********************************************************************/
			
			getCell(hoja0,0,++fila).setCellValue("Total Venta x Aud");
				XSSFCell cell=getCell(hoja0,1,fila);
				cell.setCellValue(resumen.getTotalVentaAud());
				cell.setCellStyle(bstyle);
				
			++fila;
			getCell(hoja0,0,++fila).setCellValue("Total Venta x Rvc");
				XSSFCell cell1=getCell(hoja0,1,fila);
				cell1.setCellValue(resumen.getTotalVentaRvc());
				cell1.setCellStyle(style);
				
			getCell(hoja0,0,++fila).setCellValue("Total Desc. x Check");
				XSSFCell cell2=getCell(hoja0,1,fila);
				cell2.setCellValue(resumen.getTotalDescCheck());
				cell2.setCellStyle(style);
			
			getCell(hoja0,0,++fila).setCellValue("Total Venta");
				XSSFCell cell3=getCell(hoja0,1,fila);
				cell3.setCellValue(resumen.getTotalVenta());
				cell3.setCellStyle(sstyle);
			++fila;
			getCell(hoja0,0,++fila).setCellValue("Total Costo x Rvc");
				XSSFCell cell4=getCell(hoja0,1,fila);
				cell4.setCellValue(resumen.getTotalCostoRvc());
				cell4.setCellStyle(style);
			
			getCell(hoja0,0,++fila).setCellValue("Total Costo Abierto x Transf");
				XSSFCell cell5=getCell(hoja0,1,fila);
				cell5.setCellValue(resumen.getTotalCostoAbiertoTransf());
				cell5.setCellStyle(style);
			
			getCell(hoja0,0,++fila).setCellValue("Total Costo");
				XSSFCell cell6=getCell(hoja0,1,fila);
				cell6.setCellValue(resumen.getTotalCosto());
				cell6.setCellStyle(sstyle);
			
			++fila;
			getCell(hoja0,0,++fila).setCellValue("Porc. Costo / Venta");
				XSSFCell cell7=getCell(hoja0,1,fila);
				cell7.setCellValue(resumen.getPorcCostoVenta());
				cell7.setCellStyle(pstyle);
			
			hoja0.autoSizeColumn(0);
			hoja0.autoSizeColumn(1);
			/**
			 */
			XSSFSheet hoja1 = libro.createSheet("Ventas");
			fila=0;
			getCell(hoja1,0,++fila).setCellValue(fechaCosto);
				
			getCell(hoja1,0,++fila).setCellValue("Alimentos");getCell(hoja1,1,fila).setCellValue("Ventas");
				
				//Alimentos - Room Serv
				Double venta=getAlimentosVentasRoomServ();
				getCell(hoja1,0,++fila).setCellValue("Room Serv");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Alimentos - Rest Ocea
				venta=getAlimentosVentasRestaurant();
				getCell(hoja1,0,++fila).setCellValue("Rest Ocea");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Alimentos - Delphos Carta
				venta=getAlimentosVentasDelphosCafeteriaTotal();
				getCell(hoja1,0,++fila).setCellValue("Delphos Carta");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Alimentos - Delphos Buff.		
				venta=getAlimentosVentasDelphosBuffetTotal();
				getCell(hoja1,0,++fila).setCellValue("Delphos Buff");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Alimentos - Sanis Bar
				venta=getAlimentosVentasSanisBar();
				getCell(hoja1,0,++fila).setCellValue("Sanis Bar");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Alimentos - Bar Ocean
				venta=getAlimentosVentasBarOcean();
				getCell(hoja1,0,++fila).setCellValue("Bar Ocean");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Alimentos - Frigobar
				venta=getAlimentosVentaFrigoBarOpera();
				getCell(hoja1,0,++fila).setCellValue("Friobar");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Alimentos - Banquetes
				venta=getAlimentosVentasBanquetes();
				getCell(hoja1,0,++fila).setCellValue("Banquetes");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Desayuno Incluido
				venta=getAlimentosDesayunoIncluido();
				getCell(hoja1,0,++fila).setCellValue("DESAYUNO INCL.");getCell(hoja1,1,fila).setCellValue(venta);
				
				++fila;
			
				getCell(hoja1,0,++fila).setCellValue("Bebidas");getCell(hoja1,1,fila).setCellValue("Ventas");
			
				//Bebidas - Room Serv
				venta=getBebidasVentasRoomServ();
				getCell(hoja1,0,++fila).setCellValue("Room Serv");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Bebidas - Rest Ocea
				venta=getBebidasVentasRestOcea();
				getCell(hoja1,0,++fila).setCellValue("Rest Ocea");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Bebidas - Delphos Carta
				venta=getBebidasVentasDelphosCafeteriaTotal();
				getCell(hoja1,0,++fila).setCellValue("Delphos");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Bebidas - Sanis Bar
				venta=getBebidasVentasSanisBar();
				
				//Bebidas - Bar Ocean
				venta=getBebidasVentasBarOcean();
				getCell(hoja1,0,++fila).setCellValue("Bar Ocean");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Bebidas - Frigobar
				venta=getBebidasVentaFrigoBarOpera();
				getCell(hoja1,0,++fila).setCellValue("Friobar");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Bebidas - Banquetes
				venta=getBebidasVentasBanquetes();
				getCell(hoja1,0,++fila).setCellValue("Banquetes");getCell(hoja1,1,fila).setCellValue(venta);
				
				//Bebidas - Servi Bar
				venta=getBebidasVentasServiBar();
				getCell(hoja1,0,++fila).setCellValue("ServiBar");getCell(hoja1,1,fila).setCellValue(venta);
				
				hoja1.autoSizeColumn(0);
				hoja1.autoSizeColumn(1);
				/****
				 * 	
				 */
				fila=0;
				
				XSSFSheet hoja2 = libro.createSheet("Transferencias");
				getCell(hoja2,0,++fila).setCellValue("Guias");
				
				List<GuiaTransfCosto> lista=bo.detalleGuiaTransferencia(fechaCosto);/******************************************************GUIA COSTOS TRANSFERENCIA**********************************************************************/
				
				++fila;
				getCell(hoja2,0,fila).setCellValue("Date");
				getCell(hoja2,1,fila).setCellValue("CostCenter Id");
				getCell(hoja2,2,fila).setCellValue("CostCenter Name");
				getCell(hoja2,3,fila).setCellValue("Documento");
				getCell(hoja2,4,fila).setCellValue("Total");
				getCell(hoja2,5,fila).setCellValue("Transfer To");
				getCell(hoja2,6,fila).setCellValue("Informacion");
				getCell(hoja2,7,fila).setCellValue("Usuario");
				
				Iterator<GuiaTransfCosto> it = lista.iterator();

				while (it.hasNext()) {
					GuiaTransfCosto guia= it.next();
					getCell(hoja2,0,++fila).setCellValue(guia.getLbwDate());
					getCell(hoja2,1,fila).setCellValue(guia.getKstId());	
					getCell(hoja2,2,fila).setCellValue(guia.getKstName());
					getCell(hoja2,3,fila).setCellValue(guia.getLbwName());
					getCell(hoja2,4,fila).setCellValue(guia.getLbwTotal());
					getCell(hoja2,5,fila).setCellValue(guia.getKstNameTransferTo());
					getCell(hoja2,6,fila).setCellValue(guia.getLbwInfo());
					getCell(hoja2,7,fila).setCellValue(guia.getBstName());
				}
				
				++fila;
				
				getCell(hoja2,0,++fila).setCellValue("Mermas");
				
				List<GuiaMerma> listaMerma=bo.detalleGuiaMerma(fechaCosto);/******************************************************GUIA GASTOS**********************************************************************/
				
				++fila;
				getCell(hoja2,0,fila).setCellValue("Date");
				getCell(hoja2,1,fila).setCellValue("CostCenter Id");
				getCell(hoja2,2,fila).setCellValue("CostCenter Name");
				getCell(hoja2,3,fila).setCellValue("Total");
				getCell(hoja2,4,fila).setCellValue("Informacion");
				getCell(hoja2,5,fila).setCellValue("Documento");
				
				Iterator<GuiaMerma> it2 = listaMerma.iterator();

				while (it2.hasNext()) {
					GuiaMerma guia= it2.next();
					getCell(hoja2,0,++fila).setCellValue(guia.getVerbrDate());
					getCell(hoja2,1,fila).setCellValue(guia.getKstId());	
					getCell(hoja2,2,fila).setCellValue(guia.getKstName());
					getCell(hoja2,3,fila).setCellValue(guia.getVerbrTotal());
					getCell(hoja2,4,fila).setCellValue(guia.getVbrInfo());
					getCell(hoja2,5,fila).setCellValue(guia.getVbrName());
				}
				
				hoja2.autoSizeColumn(0);
				hoja2.autoSizeColumn(1);
				hoja2.autoSizeColumn(2);
				hoja2.autoSizeColumn(3);
				hoja2.autoSizeColumn(4);
				hoja2.autoSizeColumn(5);
				hoja2.autoSizeColumn(6);
				hoja2.autoSizeColumn(7);
				hoja2.autoSizeColumn(8);
				
				/****
				 * 	
				 */
				fila=0;
				
				XSSFSheet hoja3 = libro.createSheet("Rvc");
				getCell(hoja3,0,++fila).setCellValue("RVC");
					
				List<SalesArticleRVC> listaRvc=bo.detalleFromRVCAll(fechaCosto);/******************************************************RVC **********************************************************************/
				
				++fila;
				getCell(hoja3,0,fila).setCellValue("Sales Location");
				getCell(hoja3,1,fila).setCellValue("No Product");
				getCell(hoja3,2,fila).setCellValue("Product");
				getCell(hoja3,3,fila).setCellValue("Date Rvc");
				getCell(hoja3,4,fila).setCellValue("Qty");
				getCell(hoja3,5,fila).setCellValue("S Price");
				getCell(hoja3,6,fila).setCellValue("Net Total");
				getCell(hoja3,7,fila).setCellValue("Gross Total");
				getCell(hoja3,8,fila).setCellValue("Cos Uni");
				getCell(hoja3,9,fila).setCellValue("Cos Total");
				getCell(hoja3,10,fila).setCellValue("Cos Porc");
				getCell(hoja3,11,fila).setCellValue("Cm");
				getCell(hoja3,12,fila).setCellValue("Cm Total");
				getCell(hoja3,13,fila).setCellValue("Mu");
				getCell(hoja3,14,fila).setCellValue("Pot Mu");
				getCell(hoja3,15,fila).setCellValue("Over Group");
				getCell(hoja3,16,fila).setCellValue("Outlet");
				
				Iterator<SalesArticleRVC> itr = listaRvc.iterator();
			    
			    while(itr.hasNext()) {
			    	++fila;
			    	SalesArticleRVC sales= itr.next();
			    	getCell(hoja3,0,fila).setCellValue(sales.getSalesLocation());
			    	getCell(hoja3,1,fila).setCellValue(sales.getNoProduct());
			    	getCell(hoja3,2,fila).setCellValue(sales.getProduct());
			    	getCell(hoja3,3,fila).setCellValue(sales.getDateRvc());
			    	getCell(hoja3,4,fila).setCellValue(sales.getQty());
			    	getCell(hoja3,5,fila).setCellValue(sales.getPrice());
			    	getCell(hoja3,6,fila).setCellValue(sales.getNetTotal());
			    	getCell(hoja3,7,fila).setCellValue(sales.getGrossTotal());
			    	getCell(hoja3,8,fila).setCellValue(sales.getCosUni());
			    	getCell(hoja3,9,fila).setCellValue(sales.getCosTotal());
			    	getCell(hoja3,10,fila).setCellValue(sales.getCosPorc());
			    	getCell(hoja3,11,fila).setCellValue(sales.getCm());
			    	getCell(hoja3,12,fila).setCellValue(sales.getCmTotal());
			    	getCell(hoja3,13,fila).setCellValue(sales.getMu());
			    	getCell(hoja3,14,fila).setCellValue(sales.getPotMu());
			    	getCell(hoja3,15,fila).setCellValue(sales.getOverGroup());
			    	getCell(hoja3,16,fila).setCellValue(sales.getOutlet());
			    }
				
			    hoja3.autoSizeColumn(0);
			    hoja3.autoSizeColumn(1);
			    hoja3.autoSizeColumn(2);
			    hoja3.autoSizeColumn(3);
			    hoja3.autoSizeColumn(4);
			    hoja3.autoSizeColumn(5);
			    hoja3.autoSizeColumn(6);
			    hoja3.autoSizeColumn(7);
			    hoja3.autoSizeColumn(8);
			    hoja3.autoSizeColumn(9);
			    hoja3.autoSizeColumn(10);
			    hoja3.autoSizeColumn(11);
			    hoja3.autoSizeColumn(12);
			    hoja3.autoSizeColumn(13);
			    hoja3.autoSizeColumn(14);
			    hoja3.autoSizeColumn(15);
			    hoja3.autoSizeColumn(16);
			    hoja3.autoSizeColumn(17);
			    
			    /****
				 * 	
				 */
				fila=0;
				
				XSSFSheet hoja4 = libro.createSheet("Check");
				getCell(hoja4,0,++fila).setCellValue("Check MICROS");
					
				List<ChecksMicros> listaCheck=bo.detalleFromChecksMicros(fechaCosto);/******************************************************CHECKS**********************************************************************/
				
				++fila;
				getCell(hoja4,0,fila).setCellValue("CHECKID");
				getCell(hoja4,1,fila).setCellValue("cf_cnumser");
				getCell(hoja4,2,fila).setCellValue("cf_cnumdoc");
				getCell(hoja4,3,fila).setCellValue("cf_dfecdoc");
				getCell(hoja4,4,fila).setCellValue("cf_dfecven");
				getCell(hoja4,5,fila).setCellValue("cf_ccodcli");
				getCell(hoja4,6,fila).setCellValue("cf_cnombre");
				getCell(hoja4,7,fila).setCellValue("cf_ccodmon");
				getCell(hoja4,8,fila).setCellValue("cf_ntipcam");
				getCell(hoja4,9,fila).setCellValue("cf_nprecio");
				getCell(hoja4,10,fila).setCellValue("cf_nigv");
				getCell(hoja4,11,fila).setCellValue("others");
				getCell(hoja4,12,fila).setCellValue("cf_nimport");
				getCell(hoja4,13,fila).setCellValue("descuento");
				
				Iterator<ChecksMicros> itr4 = listaCheck.iterator();
			    
			    while(itr4.hasNext()) {
			    	++fila;
			    	ChecksMicros sales= itr4.next();
			    	getCell(hoja4,0,fila).setCellValue(sales.getCheckId());
			    	getCell(hoja4,1,fila).setCellValue(sales.getCfCnumser());
			    	getCell(hoja4,2,fila).setCellValue(sales.getCfCnumdoc());
			    	getCell(hoja4,3,fila).setCellValue(sales.getCfDfecdoc());
			    	getCell(hoja4,4,fila).setCellValue(sales.getCfDfecven());
			    	getCell(hoja4,5,fila).setCellValue(sales.getCfCcodcli());
			    	getCell(hoja4,6,fila).setCellValue(sales.getCfCnombre());
			    	getCell(hoja4,7,fila).setCellValue(sales.getCfCcodmon());
			    	getCell(hoja4,8,fila).setCellValue(sales.getCfNtipcam());
			    	getCell(hoja4,9,fila).setCellValue(sales.getCfNprecio());
			    	getCell(hoja4,10,fila).setCellValue(sales.getCfNigv());
			    	getCell(hoja4,11,fila).setCellValue(sales.getOthers());
			    	getCell(hoja4,12,fila).setCellValue(sales.getCfNimport());
			    	getCell(hoja4,13,fila).setCellValue(sales.getDescuento());
			    }
			    
			    hoja4.autoSizeColumn(0);
			    hoja4.autoSizeColumn(1);
			    hoja4.autoSizeColumn(2);
			    hoja4.autoSizeColumn(3);
			    hoja4.autoSizeColumn(4);
			    hoja4.autoSizeColumn(5);
			    hoja4.autoSizeColumn(6);
			    hoja4.autoSizeColumn(7);
			    hoja4.autoSizeColumn(8);
			    hoja4.autoSizeColumn(9);
			    hoja4.autoSizeColumn(10);
			    hoja4.autoSizeColumn(11);
			    hoja4.autoSizeColumn(12);
			    hoja4.autoSizeColumn(13);
			    hoja4.autoSizeColumn(14);
			    hoja4.autoSizeColumn(15);
			    hoja4.autoSizeColumn(16);
			    hoja4.autoSizeColumn(17);
			    hoja4.autoSizeColumn(18);
			    
			File file;
			file = new File(this.archivoxls);
			try (FileOutputStream fileOuS = new FileOutputStream(file)){
				if (file.exists()) {// si el archivo existe se elimina
					file.delete();
				}
				libro.write(fileOuS);
				fileOuS.flush();
				fileOuS.close();
				System.out.println("Archivo Creado "+this.archivoxls);
				
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}catch (IOException e) {
				e.printStackTrace();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/*
	public void createExcelCostos(){
			Integer fila=0;
			
			XSSFSheet hoja1 = libro.createSheet("resumen");
			getCell(hoja1,0,++fila).setCellValue(fechaCosto);
				
			getCell(hoja1,0,++fila).setCellValue("Alimentos");getCell(hoja1,1,fila).setCellValue("Ventas");getCell(hoja1,2,fila).setCellValue("Costos");
				
				//Alimentos - Room Serv
				Double venta=getAlimentosVentasRoomServ();
				Double costo=getAlimentosCostoRoomServ();
				getCell(hoja1,0,++fila).setCellValue("Room Serv");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleAlimentosRoomServ();
				
				//Alimentos - Rest Ocea
				venta=getAlimentosVentasRestaurant();
				costo=getAlimentosCostoRestaurant();
				getCell(hoja1,0,++fila).setCellValue("Rest Ocea");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleAlimentosRestaurant();
				
				//Alimentos - Delphos Carta
				venta=getAlimentosVentasDelphosCafeteriaTotal();
				costo=getAlimentosCostoDelphosCarta();
				getCell(hoja1,0,++fila).setCellValue("Delphos Carta");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleAlimentosDelphosCarta();
				
				//Alimentos - Delphos Buff.		
				venta=getAlimentosVentasDelphosBuffetTotal();
				costo=getAlimentosCostoDelphosBuffets();
				getCell(hoja1,0,++fila).setCellValue("Delphos Buff");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleAlimentosDelphosBuffet();
				
				//Alimentos - Sanis Bar
				venta=getAlimentosVentasSanisBar();
				costo=getAlimentosCostoSanisBar();
				getCell(hoja1,0,++fila).setCellValue("Sanis Bar");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleAlimentosSanisBar();
			
				//Alimentos - Bar Ocean
				venta=getAlimentosVentasBarOcean();
				costo=getAlimentosCostoBarOcean();
				getCell(hoja1,0,++fila).setCellValue("Bar Ocean");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleAlimentosBarOcean();
				
				//Alimentos - Frigobar
				venta=getAlimentosVentaFrigoBarTotal();
				costo=getAlimentosCostoFrigoBar();
				getCell(hoja1,0,++fila).setCellValue("Friobar");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleAlimentosFrigoBar();
	
				//Alimentos - Banquetes
				venta=getAlimentosVentasBanquetes();
				costo=getAlimentosCostoBanquetes();
				getCell(hoja1,0,++fila).setCellValue("Banquetes");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleAlimentosVentasBanquetes();
				
				++fila;
			
				getCell(hoja1,0,++fila).setCellValue("Bebidas");getCell(hoja1,1,fila).setCellValue("Ventas");getCell(hoja1,2,fila).setCellValue("Costos");
			
				//Bebidas - Room Serv
				venta=getBebidasVentasRoomServ();
				costo=getBebidasCostoRoomServ();
				getCell(hoja1,0,++fila).setCellValue("Room Serv");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleBebidasRoomServ();
			
				//Bebidas - Rest Ocea
				venta=getBebidasVentasRestOcea();
				costo=getBebidasCosotRestOcea();
				getCell(hoja1,0,++fila).setCellValue("Rest Ocea");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleBebidasRestOcea();
			
				//Bebidas - Delphos Carta
				venta=getBebidasVentasDelphosCafeteriaTotal();
				costo=getBebidasCostoDelphosCarta();
				getCell(hoja1,0,++fila).setCellValue("Delphos");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleBebidasDelphosCafeteria();
			
				//Bebidas - Sanis Bar
				venta=getBebidasVentasSanisBar();
				costo=getBebidasCostoSanisBar();
				getCell(hoja1,0,++fila).setCellValue("Sanis Bar");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleBebidasSanisBar();
			
				//Bebidas - Bar Ocean
				venta=getBebidasVentasBarOcean();
				costo=getBebidasCostoBarOcean();
				getCell(hoja1,0,++fila).setCellValue("Bar Ocean");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleBebidasBarOcean();
			
				//Bebidas - Frigobar
				venta=getBebidasVentaFrigoBarTotal();
				costo=getBebidasCostoFrigoBarTotal();
				getCell(hoja1,0,++fila).setCellValue("Friobar");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleBebidasFrigoBar();
			
				//Bebidas - Banquetes
				venta=getBebidasVentasBanquetes();
				costo=getBebidasCostoBanquetes();
				getCell(hoja1,0,++fila).setCellValue("Banquetes");getCell(hoja1,1,fila).setCellValue(venta);getCell(hoja1,2,fila).setCellValue(costo);
				detalleBebidasBanquetes();
				

		File file;
		file = new File(this.archivoxls);
		try (FileOutputStream fileOuS = new FileOutputStream(file)){
			if (file.exists()) {// si el archivo existe se elimina
				file.delete();
			}
			libro.write(fileOuS);
			fileOuS.flush();
			fileOuS.close();
			System.out.println("Archivo Creado "+this.archivoxls);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}catch (IOException e) {
			e.printStackTrace();
		}
	}
	*/
	
	public XSSFCell getCell(XSSFSheet sheet, int icol, int irow) {
		  // try to get row
		  XSSFRow row = sheet.getRow(irow);
		  // if not exist: create row
		  if (row == null)
		    row = sheet.createRow(irow);
		  // get cell
		  return row.createCell(icol);
	}
	
	public Double getBebidasCostoBanquetes(){//ok
		CostosBo costo=new CostosBo(); 
		Double c1=costo.getCostoTransferenciaFromGuiaBanquetes(fechaCosto,Constante.GUIA_CONCEPTO_EVENTO_BEBIDAS);
		return c1;
	}
	
	public Double getBebidasVentasBanquetes(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbBanquetes();
		venta=venta*tipoCambio;
		return venta;
	}
	
	public Double getBebidasVentasServiBar(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbServiBar();
		venta=venta*tipoCambio;
		return venta;
	}
	
	public void detalleBebidasBanquetes(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbBanquetes();
		venta=venta*tipoCambio;
		
		Integer fila=0;
		fila=setLine("B Banquetes","VENTAS",fila++);
		fila=setDataFromOutlHjTrb("BBanquetes",venta,"B Banquetes",fila++);
		
			//COSTOS
			fila=setLine("B Banquetes","COSTOS",fila++);
			List<GuiaTransfCosto> lGuia=costo.detalleCostoTransferenciaFromGuiaBanquetes(fechaCosto,Constante.GUIA_CONCEPTO_EVENTO_BEBIDAS);
			fila=setDataCostoTransferenciaFromGuia(lGuia,"B Banquetes",fila++);
	}
				
	
	public Double getBebidasCostoFrigoBarTotal(){//ok
		CostosBo costo=new CostosBo();
		SalesArticleRVC sales=costo.getCOSTotalBebidaFromRVCFrigoBar(fechaCosto);
		Double v1=sales.getCosTotal();
		
		Double v2=costo.getCostoTotalFromDailyFoodBebidas(this.fechaCosto);
		
		return v1+v2;
	}
	
	
	
	public Integer setDataDailyFood(List<DailyFood> ldaily,String grupo,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Daily Food "+grupo);
		
		++fila;//Date	Gross Revenue	Net Revenue	Consumption	ACT COS	Other Usage	Inv_Diff_	POT COS	Total Receiving	Purchase	Transfers
		getCell(hoja1,0,fila).setCellValue("Date");
		getCell(hoja1,1,fila).setCellValue("Gross Revenue");
		getCell(hoja1,2,fila).setCellValue("Net Revenue");
		getCell(hoja1,3,fila).setCellValue("Consumption");
		getCell(hoja1,4,fila).setCellValue("ACT COS");
		getCell(hoja1,5,fila).setCellValue("Other Usage");
		getCell(hoja1,6,fila).setCellValue("Inv_Diff_");
		getCell(hoja1,7,fila).setCellValue("POT COS");
		getCell(hoja1,8,fila).setCellValue("Total Receiving");
		getCell(hoja1,9,fila).setCellValue("Purchase");
		getCell(hoja1,10,fila).setCellValue("Transfers");
		
		Iterator<DailyFood> itr = ldaily.iterator();
	    
	    while(itr.hasNext()) {
	    	++fila;
	    	DailyFood sales= itr.next();
	    	getCell(hoja1,0,fila).setCellValue(sales.getTrxDate());
	    	getCell(hoja1,1,fila).setCellValue(sales.getGrossRevenue());
	    	getCell(hoja1,2,fila).setCellValue(sales.getNetRevenue());
	    	getCell(hoja1,3,fila).setCellValue(sales.getConsumption());
	    	getCell(hoja1,4,fila).setCellValue(sales.getActcos());
	    	getCell(hoja1,5,fila).setCellValue(sales.getOtherUsage());
	    	getCell(hoja1,6,fila).setCellValue(sales.getInvDiff());
	    	getCell(hoja1,7,fila).setCellValue(sales.getPotcos());
	    	getCell(hoja1,8,fila).setCellValue(sales.getTotalReceiving());
	    	getCell(hoja1,9,fila).setCellValue(sales.getPurchase());
	    	getCell(hoja1,10,fila).setCellValue(sales.getTransfers());
	    }
	    
	    return ++fila;
	    
	}
	
	public Double getBebidasVentaFrigoBarTotal(){//ok
		CostosBo costo=new CostosBo();
		SalesArticleRVC sales=costo.getCOSTotalBebidaFromRVCFrigoBar(fechaCosto);
		Double v1=sales.getVenTotal();
		Double v2=getBebidasVentaFrigoBarOpera();
		return v1+v2;
	}

	public void detalleBebidasFrigoBar(){//ok
		CostosBo costo=new CostosBo();
		List<SalesArticleRVC> lsales=costo.detalleCOSTotalBebidaFromRVCFrigoBar(fechaCosto);
		Integer fila=0;
		
		fila=setLine("B FrioBar","VENTAS",fila++);
		fila=setDataCOSTotalFromRVC(lsales,"B FrioBar",fila++);
		
		fila++;
		List<FinJrnlArticles> larticle=costo.detalleVentaTotalFromFrigobar(fechaCosto, Constante.FRIGOBAR_BEBIDAS);
		fila=setDataFromFinJrnlArticles(larticle,"B FrioBar",fila++);
		
			//COSTOS
			fila=setLine("B FrioBar","COSTOS",fila++);
			List<SalesArticleRVC> lsales2=costo.detalleCOSTotalBebidaFromRVCFrigoBar(fechaCosto);
			fila=setDataCOSTotalFromRVC(lsales2,"B FrioBar",fila++);
			
			fila++;
			List<DailyFood> ldaily=costo.detalleFromDailyFoodBebidas(fechaCosto);
			fila=setDataDailyFood(ldaily,"Bebidas","B FrioBar",fila++);
	}

	public Integer setDataFromFinJrnlArticles(List<FinJrnlArticles> larticle,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Journal by Cashier and Article Code");
		
		++fila;
		getCell(hoja1,0,fila).setCellValue("quantity");
		getCell(hoja1,1,fila).setCellValue("room");
		getCell(hoja1,2,fila).setCellValue("article_id");
		getCell(hoja1,3,fila).setCellValue("article_code");
		getCell(hoja1,4,fila).setCellValue("description");
		getCell(hoja1,5,fila).setCellValue("guest_account_debit");
		getCell(hoja1,6,fila).setCellValue("guest_account_credit");
		getCell(hoja1,7,fila).setCellValue("cashier_id");
		getCell(hoja1,8,fila).setCellValue("cashier_name");
		getCell(hoja1,9,fila).setCellValue("trx_date");
		
		Iterator<FinJrnlArticles> itr = larticle.iterator();
	    
	    while(itr.hasNext()) {
	    	++fila;
	    	FinJrnlArticles sales= itr.next();
	    	getCell(hoja1,0,fila).setCellValue(sales.getQuantity());
	    	getCell(hoja1,1,fila).setCellValue(sales.getRoom());
	    	getCell(hoja1,2,fila).setCellValue(sales.getArticleId());
	    	getCell(hoja1,3,fila).setCellValue(sales.getArticleCode());
	    	getCell(hoja1,4,fila).setCellValue(sales.getDescription());
	    	getCell(hoja1,5,fila).setCellValue(sales.getGuestAccountDebit());
	    	getCell(hoja1,6,fila).setCellValue(sales.getGuestAccountCredit());
	    	getCell(hoja1,7,fila).setCellValue(sales.getCashierId());
	    	getCell(hoja1,8,fila).setCellValue(sales.getCashierName());
	    	getCell(hoja1,9,fila).setCellValue(sales.getTrxDate());
	    }
	    
	    return ++fila;
	}
	
	public Double getBebidasCostoBarOcean(){//ok
		CostosBo costo=new CostosBo();
		SalesArticleRVC sales=costo.getCOSTotalBebidaFromRVCOcean(fechaCosto);
		Double c1=sales.getCosTotal();
		
		Double c2=costo.getCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_OCEANUS_LOUNGE_BEBIDAS_ABIERTO);
		
		SalesArticleRVC sales3=costo.getCOSTotalBebidaFromRVCOceanCortesia(fechaCosto);
		Double c3=sales3.getCosTotal();
		
		return c1+c2+c3;
	}
	
	
	
	public Double getBebidasVentasBarOcean(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbOceanus();
		venta=venta*tipoCambio;
		return venta;
	}
	
	public void detalleBebidasBarOcean(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbOceanus();
		venta=venta*tipoCambio;
		
		Integer fila=0;
		
		fila=setLine("B Bar Ocean","VENTAS",fila++);
		fila=setDataFromOutlHjTrb("BOceanus",venta,"B Bar Ocean",fila++);
			//costos
			fila=setLine("B Bar Ocean","COSTOS",fila++);
			List<SalesArticleRVC> lsales=costo.detalleCOSTotalBebidaFromRVCOcean(fechaCosto);
			fila=setDataCOSTotalFromRVC(lsales,"B Bar Ocean",fila++);
			fila++;
			List<GuiaTransfCosto> lGuia=costo.detalleCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_OCEANUS_LOUNGE_BEBIDAS_ABIERTO);
			fila=setDataCostoTransferenciaFromGuia(lGuia,"B Bar Ocean",fila++);
			fila++;
			List<SalesArticleRVC> lsales3=costo.detalleCOSTotalBebidaFromRVCOceanCortesia(fechaCosto);
			fila=setDataCOSTotalFromRVC(lsales3,"B Bar Ocean",fila++);
	}
	
	
	public Double getBebidasCostoSanisBar(){//OK
		CostosBo costo=new CostosBo();
		SalesArticleRVC sales=costo.getCOSTotalBebidaFromRVCSanisBar(fechaCosto);
		Double c1=sales.getCosTotal();
		Double c2=costo.getCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_SANIS_BEBIDAS_ABIERTO);
		return c1+c2;
	}
	
	public Double getBebidasVentasSanisBar(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbLobbyBar();
		venta=venta*tipoCambio;
		return venta;
	}
	
	public void detalleBebidasSanisBar(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbLobbyBar();
		venta=venta*tipoCambio;
		
		Integer fila=0;
		fila=setLine("B Sanir Bar","VENTAS",fila++);
		fila=setDataFromOutlHjTrb("BLobbyBar",venta,"B Sanir Bar",fila++);
		
			//COSTOS
			fila=setLine("B Sanir Bar","COSTOS",fila++);
			List<SalesArticleRVC> lsales=costo.detalleCOSTotalBebidaFromRVCSanisBar(fechaCosto);
			fila=setDataCOSTotalFromRVC(lsales,"B Sanir Bar",fila++);
			fila++;
			List<GuiaTransfCosto> lGuia=costo.detalleCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_SANIS_BEBIDAS_ABIERTO);
			fila=setDataCostoTransferenciaFromGuia(lGuia,"B Sanir Bar",fila++);
	}
				
				
				
	
	public Double getBebidasCostoDelphosCarta(){//OK
		CostosBo costo=new CostosBo();
		SalesArticleRVC sales=costo.getCOSTotalFromRVCDelphos(fechaCosto);
		Double c1=sales.getCosTotal();
		
		SalesArticleRVC sales2=costo.getCOSTotalFromRVCMenusLogicos(fechaCosto);
		Double c2=sales2.getCosTotal();
		
		return c1+c2;
	}
	
	public Double getBebidasVentasDelphosCafeteriaTotal(){//ok
		Double c1=getBebidasVentasDelphosCafeteria(); //626.5
		Double c2=getBebidasVentasDelphosEventos();//0
		Double c3=getBebidasVentasDelphosPaquetes();//164.5	
		Double c4=getBebidasVentasDelphosWelcomeDrink();//101.15
		Double c5=getBebidasVentasDelphosDesayAlmCenaIncluido();//0
		return c1+c2+c3+c4+c5;
	}

	public void detalleBebidasDelphosCafeteria(){
		CostosBo costo=new CostosBo();
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbDelphos();
		venta=venta*tipoCambio;
		
		Integer fila=0;
		fila=setLine("B Delphos","VENTAS",fila++);
		fila=setDataFromOutlHjTrb("BDelphos",venta,"B Delphos",fila++);
		
		fila++;
		obj=costo.getOutlHjTrb(fechaCosto);
		venta=obj.getbKnoEvt();
		venta=venta*tipoCambio;
		fila=setDataFromOutlHjTrb("BKnoEvt",venta,"B Delphos",fila++);
		
		fila++;
		List<SalesArticleRVC> larticle=costo.detalleCOSTotalFromRVCWelcomeDrink(fechaCosto);
		fila=setDataCOSTotalFromRVC(larticle,"B Delphos",fila++);
		
			//COSTOS
			fila=setLine("B Delphos","COSTOS",fila++);
			List<SalesArticleRVC> lsales=costo.detalleCOSTotalFromRVCDelphos(fechaCosto);
			fila=setDataCOSTotalFromRVC(lsales,"B Delphos",fila++);
			fila++;
			List<SalesArticleRVC> lsales2=costo.detalleCOSTotalFromRVCMenusLogicos(fechaCosto);
			fila=setDataCOSTotalFromRVC(lsales2,"B Delphos",fila++);
	}
				
	public Double getBebidasCosotRestOcea(){//ok
		CostosBo costo=new CostosBo();
		SalesArticleRVC article=costo.getCOSTotalFromRVCRestOcea(fechaCosto);
		return article.getCosTotal();
	}
	
	
	public Double getBebidasVentasRestOcea(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbKnossos();
		venta=venta*tipoCambio;
		return venta;
	}
	public void detalleBebidasRestOcea(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbKnossos();
		venta=venta*tipoCambio;
		
		Integer fila=0;
		fila=setLine("B Rest Ocea","VENTAS",fila++);
		fila=setDataFromOutlHjTrb("BKnossos",venta,"B Rest Ocea",fila++);
		
			//COSTOS
			fila=setLine("B Rest Ocea","COSTOS",fila++);
			List<SalesArticleRVC> larticle=costo.detalleCOSTotalFromRVCRestOcea(fechaCosto);
			fila=setDataCOSTotalFromRVC(larticle,"B Rest Ocea",fila++);
	}
			
	
	public Double getBebidasCostoRoomServ(){//ok
		CostosBo costo=new CostosBo();
		SalesArticleRVC article=costo.getCOSTotalFromRVCRoomServ(fechaCosto);
		return article.getCosTotal();
	}
	
	public Double getBebidasVentasRoomServ(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double bRoomService=obj.getbRoomService();
		bRoomService=bRoomService*tipoCambio;
		return bRoomService;
	}
	
	public void detalleBebidasRoomServ(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double bRoomService=obj.getbRoomService();
		bRoomService=bRoomService*tipoCambio;
		
		Integer fila=0;
		fila=setLine("B Room Serv","VENTAS",fila++);
		fila=setDataFromOutlHjTrb("BRoomService",bRoomService,"B Room Serv",fila++);
		
			//costos
			fila=setLine("B Room Serv","COSTOS",fila++);
			List<SalesArticleRVC> lsales=costo.detalleCOSTotalFromRVCRoomServ(fechaCosto);
			fila=setDataCOSTotalFromRVC(lsales,"B Room Serv",fila++);
	}

	public Double getAlimentosDesayunoIncluido(){
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.gethDesayIncluido();
		venta=venta*tipoCambio;
		return venta;
	}


	public Double getAlimentosVentasBanquetes(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getcBanquetes();
		venta=venta*tipoCambio;
		return venta;
	}
	
	
	public Double getAlimentosCostoBanquetes(){//ok
		CostosBo costo=new CostosBo(); 
		Double c1=costo.getCostoTransferenciaFromGuiaBanquetes(fechaCosto,Constante.GUIA_CONCEPTO_EVENTO_ALIMENTOS);
		/**Teclas de Eventos ESTOS DEBEN ESTAR ENLAZADOS*/
		SalesArticleRVC sales=costo.getCOSTotalAlimentoFromRVCEventos(fechaCosto);
		Double c2=sales.getCosTotal();
		return c1+c2;
	}
	public void detalleAlimentosVentasBanquetes(){//ok
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getcBanquetes();
		venta=venta*tipoCambio;
		
		Integer fila=0;
		fila=setLine("Banquetes","VENTAS",fila++);
		fila=setDataFromOutlHjTrb("CBanquetes",venta,"Banquetes",fila++);
			//COSTOS
			fila=setLine("Banquetes","COSTOS",fila++);
			List<GuiaTransfCosto> lGuia=costo.detalleCostoTransferenciaFromGuiaBanquetes(fechaCosto,Constante.GUIA_CONCEPTO_EVENTO_ALIMENTOS);
			fila=setDataCostoTransferenciaFromGuia(lGuia,"Banquetes",fila++);
			/**Teclas de Eventos ESTOS DEBEN ESTAR ENLAZADOS*/
			fila++;
			List<SalesArticleRVC> lsales=costo.detalleCOSTotalAlimentoFromRVCEventos(fechaCosto);
			fila=setDataCOSTotalFromRVC(lsales,"Banquetes",fila++);
	}
								
	public Double getAlimentosCostoFrigoBar(){
		CostosBo costo=new CostosBo();	
		SalesArticleRVC sales=costo.getVentaTotalFromRVCFrigobar(this.fechaCosto);
		Double c1=sales.getCosTotal();
		
		Double c2=costo.getCostoTotalFromDailyFoodAlimentos(this.fechaCosto);
		
		return c1+c2;
	}
	
	
	
	
	public Double getAlimentosVentaFrigoBarTotal(){//OK
		Double v1=getAlimentosVentaFrigoBarOpera();
		v1=v1*tipoCambio;
		Double v2=getAlimentosVentaFrigobarRVC();
		return v1+v2;
	}
	
	public void detalleAlimentosFrigoBar(){//OK
		CostosBo costo=new CostosBo();
		Double value=costo.getVentaTotalFromFrigobar(fechaCosto, Constante.FRIGOBAR_ALIMENTOS);
		value=value*tipoCambio;
		Integer fila=0;
		fila=setLine("Frio Bar","VENTAS",fila++);
		fila=setDataFromOutlHjTrb("Opera Guest Account Debit",value,"Frio Bar",fila++);
		
		fila++;
		List<SalesArticleRVC> larticle=costo.detalleVentaTotalFromRVCFrigobar(fechaCosto);
		fila=setDataCOSTotalFromRVC(larticle,"Frio Bar",fila++);
		
			//costos
			fila=setLine("Frio Bar","COSTOS",fila++);
			List<SalesArticleRVC> lsales=costo.detalleVentaTotalFromRVCFrigobar(fechaCosto);
			fila=setDataCOSTotalFromRVC(lsales,"Frio Bar",fila++);
			fila++;
			List<DailyFood> ldaily=costo.detalleFromDailyFoodAlimentos(fechaCosto);
			fila=setDataDailyFood(ldaily,"Alimentos","Frio Bar",fila++);
	}
	
	public Double getAlimentosCostoSanisBar(){
		CostosBo costo=new CostosBo();
		SalesArticleRVC sales=costo.getCOSTotalAlimentoFromRVCSanisBar(fechaCosto);
		Double c1=sales.getCosTotal();
		Double c2=costo.getCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_SANIS_ALIMENTO_ABIERTO);
		return c1+c2;
	}
	
	public Double getAlimentosVentasSanisBar(){//OK
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getcLobbyBar();
		venta=venta*tipoCambio;
		return venta;
	}
	
	
	public Double getAlimentosVentasBarOcean(){//OK
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getcOceanus();
		venta=venta*tipoCambio;
		return venta;
	}
	
	public Double getAlimentosCostoBarOcean(){
		CostosBo costo=new CostosBo(); 
		SalesArticleRVC sales=costo.getVentaTotalFromRVCBarOcean(fechaCosto);
		return sales.getCosTotal();
	}

	public void detalleAlimentosBarOcean(){
		CostosBo costo=new CostosBo();
		
		Double ventas=getAlimentosVentasBarOcean();
		Integer fila=0;
		fila=setLine("Bar Ocean","VENTAS",fila++);
		fila=setDataFromValue("COceanus",ventas,"Bar Ocean",fila++);
		
			fila=setLine("Bar Ocean","COSTOS",fila++);
			List<SalesArticleRVC> larticle=costo.detalleCOSTotalAlimentoFromRVCBarOcean(fechaCosto);
			fila=setDataCOSTotalFromRVC(larticle,"Bar Ocean",fila++);
	}
	
	public void detalleAlimentosSanisBar(){
		CostosBo costo=new CostosBo();
		Integer fila=0;
		fila=setLine("Sanis Bar","VENTAS",fila++);
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		
		Double value=obj.getcLobbyBar();
		value=value*tipoCambio;
		
		fila=setDataFromOutlHjTrb("CLobbyBar",value,"Sanis Bar",fila);
		
			///costo
			fila=setLine("Sanis Bar","COSTOS",fila++);
			List<SalesArticleRVC> larticle=costo.detalleCOSTotalAlimentoFromRVCSanisBar(fechaCosto);
			fila=setDataCOSTotalFromRVC(larticle,"Sanis Bar",fila);
			fila++;
			List<GuiaTransfCosto> lGuia=costo.detalleCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_SANIS_ALIMENTO_ABIERTO);
			fila=setDataCostoTransferenciaFromGuia(lGuia,"Sanis Bar",fila);
	}
	
	public Double getAlimentosCostoDelphosBuffets(){
		CostosBo costo=new CostosBo();
		Double c1=costo.getCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_DESAYUNO);
		Double c2=costo.getCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_BUFFET);
		Double c3=costo.getCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_TEA_TIME);
		return c1+c2+c3;
	}
	
	public Double getAlimentosVentasRestaurant(){
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getcKnossos();
		venta=venta*tipoCambio;
		return venta;
	}
	
	public void detalleAlimentosRestaurant(){
		//detalleAlimentosVentasRoomServ();
		//esto se muestra en la hoja "Ventas Room Serv"
		
		CostosBo costo=new CostosBo();
		
		Integer fila=0;
		fila=setLine("Rest Ocea","VENTAS",fila++);
		
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		
		Double venta=obj.getcKnossos();
		venta=venta*tipoCambio;
		fila=setDataFromOutlHjTrb("CKnossos",venta,"Rest Ocea",fila++);
		
			fila=setLine("Rest Ocea","COSTOS",fila++);
			
			List<SalesArticleRVC> larticle=costo.detalleCOSTotalFromRVC(fechaCosto, Constante.OVERGROUP_ALIMENTO, Constante.OUTLET_ROOMSERVICE,Constante.AREAVENTA_RVC_REST_OCEANUS);
			fila=setDataCOSTotalFromRVC(larticle,"Rest Ocea",fila++);
			fila++;
			List<GuiaTransfCosto> lGuia=costo.detalleCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_RESTAURANT_OW_ALIMENTO_ABIERTO);
			fila=setDataCostoTransferenciaFromGuia(lGuia,"Rest Ocea",fila++);
	}
	
	public Double getAlimentosVentasDelphosBuffet(){
		CostosBo costo=new CostosBo(); 
		SalesArticleRVC sales=costo.getVentaTotalFromRVCDelphosBuffet(fechaCosto);
		return sales.getVenTotal();
	}
	
	public Double getAlimentosVentasDelphosBuffetTotal(){
		CostosBo costo=new CostosBo(); 
		SalesArticleRVC sales=costo.getVentaTotalFromRVCDelphosBuffet(fechaCosto);//939.03
		
		Integer qty=costo.getQtyVentaTotalFromRVCDelphosDesayAlmCenaIncluido(fechaCosto);
		Double valorBuff=qty*Constante.COSTO_DESAYUNO_UNI*tipoCambio;
		
		Double result=sales.getVenTotal()+valorBuff;
		return result;
	}
	
	public void detalleAlimentosDelphosBuffet(){//ok
		
		CostosBo costo=new CostosBo(); 
		List<SalesArticleRVC> larticle=costo.detalleVentaTotalFromRVCDelphosBuffet(fechaCosto);
		Integer fila=0;
		fila=setLine("Delphos Buff","VENTAS",fila++);
		fila=setDataCOSTotalFromRVC(larticle,"Delphos Buff",fila++);
		
		Integer qty=costo.getQtyVentaTotalFromRVCDelphosDesayAlmCenaIncluido(fechaCosto);
		Double valorBuff=qty*Constante.COSTO_DESAYUNO_UNI*tipoCambio;
		fila++;
		fila=setDataQtyAlimentosVentasDelphosDesayAlmCenaIncluido("Desay Inc_Buff (102017)",valorBuff,"Delphos Buff",fila++);
		
			fila=setLine("Delphos Buff","COSTOS",fila++);
			
			List<GuiaTransfCosto> lGuia=costo.detalleCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_DESAYUNO);
			fila=setDataCostoTransferenciaFromGuia(lGuia,"Delphos Buff",fila++);
			fila++;
			List<GuiaTransfCosto> lGuia2=costo.detalleCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_BUFFET);
			fila=setDataCostoTransferenciaFromGuia(lGuia2,"Delphos Buff",fila++);
			fila++;
			List<GuiaTransfCosto> lGuia3=costo.detalleCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_TEA_TIME);
			fila=setDataCostoTransferenciaFromGuia(lGuia3,"Delphos Buff",fila++);
	}
												
												
												
	public Integer setDataAlimentosVentasDelphosBuffetTotal(List<SalesArticleRVC> larticle,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Rvc");
		
		++fila;
		getCell(hoja1,0,fila).setCellValue("Sales Location");
		getCell(hoja1,1,fila).setCellValue("No Product");
		getCell(hoja1,2,fila).setCellValue("Product");
		getCell(hoja1,3,fila).setCellValue("Date Rvc");
		getCell(hoja1,4,fila).setCellValue("Qty");
		getCell(hoja1,5,fila).setCellValue("S Price");
		getCell(hoja1,6,fila).setCellValue("Net Total");
		getCell(hoja1,7,fila).setCellValue("Gross Total");
		getCell(hoja1,8,fila).setCellValue("Cos Uni");
		getCell(hoja1,9,fila).setCellValue("Cos Total");
		getCell(hoja1,10,fila).setCellValue("Cos Porc");
		getCell(hoja1,11,fila).setCellValue("Cm");
		getCell(hoja1,12,fila).setCellValue("Cm Total");
		getCell(hoja1,13,fila).setCellValue("Mu");
		getCell(hoja1,14,fila).setCellValue("Pot Mu");
		getCell(hoja1,15,fila).setCellValue("Over Group");
		getCell(hoja1,16,fila).setCellValue("Outlet");
		
		Iterator<SalesArticleRVC> itr = larticle.iterator();
	    
	    while(itr.hasNext()) {
	    	++fila;
	    	SalesArticleRVC sales= itr.next();
	    	getCell(hoja1,0,fila).setCellValue(sales.getSalesLocation());
	    	getCell(hoja1,1,fila).setCellValue(sales.getNoProduct());
	    	getCell(hoja1,2,fila).setCellValue(sales.getProduct());
	    	getCell(hoja1,3,fila).setCellValue(sales.getDateRvc());
	    	getCell(hoja1,4,fila).setCellValue(sales.getQty());
	    	getCell(hoja1,5,fila).setCellValue(sales.getPrice());
	    	getCell(hoja1,6,fila).setCellValue(sales.getNetTotal());
	    	getCell(hoja1,7,fila).setCellValue(sales.getGrossTotal());
	    	getCell(hoja1,8,fila).setCellValue(sales.getCosUni());
	    	getCell(hoja1,9,fila).setCellValue(sales.getCosTotal());
	    	getCell(hoja1,10,fila).setCellValue(sales.getCosPorc());
	    	getCell(hoja1,11,fila).setCellValue(sales.getCm());
	    	getCell(hoja1,12,fila).setCellValue(sales.getCmTotal());
	    	getCell(hoja1,13,fila).setCellValue(sales.getMu());
	    	getCell(hoja1,14,fila).setCellValue(sales.getPotMu());
	    	getCell(hoja1,15,fila).setCellValue(sales.getOverGroup());
	    	getCell(hoja1,16,fila).setCellValue(sales.getOutlet());
	    }
	    
	    return ++fila;
	    
	}
	
	public Integer setDataFromValue(String etiqueta,Double value,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Venta");
		getCell(hoja1,0,++fila).setCellValue(etiqueta);getCell(hoja1,1,fila).setCellValue(value);
	    return ++fila;
	}
	
	public Integer setDataFromOutlHjTrb(String etiqueta,Double value,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Venta");
		
		getCell(hoja1,0,++fila).setCellValue(etiqueta);getCell(hoja1,1,fila).setCellValue(value);
	    return ++fila;
	}
	
	public Integer setDataQtyAlimentosVentasDelphosDesayAlmCenaIncluido(String etiqueta,Double venta,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Venta");
		
		getCell(hoja1,0,++fila).setCellValue(etiqueta);getCell(hoja1,1,fila).setCellValue(venta);
	    return ++fila;
	}
	
	
	public Integer setDataAlimentosVentasDelphosPaquetes(OutlHjTrb obj,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Venta");
		
		Double venta=obj.getcKnoEvt();
		venta=venta*tipoCambio;
		
		getCell(hoja1,0,++fila).setCellValue("CKnoEvt");getCell(hoja1,1,fila).setCellValue(venta);
	    return ++fila;
	}
	
	public Integer setDataAlimentosVentasDelphosCafeteria(OutlHjTrb obj,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Venta");
		
		Double venta=obj.getcDelphos();
		venta=venta*tipoCambio;
		
		getCell(hoja1,0,++fila).setCellValue("CDelphos");getCell(hoja1,1,fila).setCellValue(venta);
	    return ++fila;
	}
	
	
	public Integer setDataCostoTransferenciaFromGuia(List<GuiaTransfCosto> lGuia,String sheetName,Integer fila){
		
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Guia");
		
		++fila;
		getCell(hoja1,0,fila).setCellValue("Lbw_Date");
		getCell(hoja1,1,fila).setCellValue("Kst_Id");
		getCell(hoja1,2,fila).setCellValue("Kst_Name");
		getCell(hoja1,3,fila).setCellValue("Lbw_Name");
		getCell(hoja1,4,fila).setCellValue("Lbw_Total");
		getCell(hoja1,5,fila).setCellValue("Lbw_Info");
		
		Iterator<GuiaTransfCosto> itr = lGuia.iterator();
	    
	    while(itr.hasNext()) {
	    	++fila;
	    	GuiaTransfCosto sales= itr.next();
	    	getCell(hoja1,0,fila).setCellValue(sales.getLbwDate());
	    	getCell(hoja1,1,fila).setCellValue(sales.getKstId());
	    	getCell(hoja1,2,fila).setCellValue(sales.getKstName());
	    	getCell(hoja1,3,fila).setCellValue(sales.getLbwName());
	    	getCell(hoja1,4,fila).setCellValue(sales.getLbwTotal());
	    	getCell(hoja1,5,fila).setCellValue(sales.getLbwInfo());
	    }
	    
	    return ++fila;
	}
	
	public Integer setDataCOSTotalFromRVC(List<SalesArticleRVC> larticle,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Rvc");
		
		++fila;
		getCell(hoja1,0,fila).setCellValue("Sales Location");
		getCell(hoja1,1,fila).setCellValue("No Product");
		getCell(hoja1,2,fila).setCellValue("Product");
		getCell(hoja1,3,fila).setCellValue("Date Rvc");
		getCell(hoja1,4,fila).setCellValue("Qty");
		getCell(hoja1,5,fila).setCellValue("S Price");
		getCell(hoja1,6,fila).setCellValue("Net Total");
		getCell(hoja1,7,fila).setCellValue("Gross Total");
		getCell(hoja1,8,fila).setCellValue("Cos Uni");
		getCell(hoja1,9,fila).setCellValue("Cos Total");
		getCell(hoja1,10,fila).setCellValue("Cos Porc");
		getCell(hoja1,11,fila).setCellValue("Cm");
		getCell(hoja1,12,fila).setCellValue("Cm Total");
		getCell(hoja1,13,fila).setCellValue("Mu");
		getCell(hoja1,14,fila).setCellValue("Pot Mu");
		getCell(hoja1,15,fila).setCellValue("Over Group");
		getCell(hoja1,16,fila).setCellValue("Outlet");
		
		Iterator<SalesArticleRVC> itr = larticle.iterator();
	    
	    while(itr.hasNext()) {
	    	++fila;
	    	SalesArticleRVC sales= itr.next();
	    	getCell(hoja1,0,fila).setCellValue(sales.getSalesLocation());
	    	getCell(hoja1,1,fila).setCellValue(sales.getNoProduct());
	    	getCell(hoja1,2,fila).setCellValue(sales.getProduct());
	    	getCell(hoja1,3,fila).setCellValue(sales.getDateRvc());
	    	getCell(hoja1,4,fila).setCellValue(sales.getQty());
	    	getCell(hoja1,5,fila).setCellValue(sales.getPrice());
	    	getCell(hoja1,6,fila).setCellValue(sales.getNetTotal());
	    	getCell(hoja1,7,fila).setCellValue(sales.getGrossTotal());
	    	getCell(hoja1,8,fila).setCellValue(sales.getCosUni());
	    	getCell(hoja1,9,fila).setCellValue(sales.getCosTotal());
	    	getCell(hoja1,10,fila).setCellValue(sales.getCosPorc());
	    	getCell(hoja1,11,fila).setCellValue(sales.getCm());
	    	getCell(hoja1,12,fila).setCellValue(sales.getCmTotal());
	    	getCell(hoja1,13,fila).setCellValue(sales.getMu());
	    	getCell(hoja1,14,fila).setCellValue(sales.getPotMu());
	    	getCell(hoja1,15,fila).setCellValue(sales.getOverGroup());
	    	getCell(hoja1,16,fila).setCellValue(sales.getOutlet());
	    }
	    
	    return ++fila;
	}
	
	
	public Integer setDataAlimentosVentasRoomServ(OutlHjTrb obj,String sheetName,Integer fila){
		XSSFSheet hoja1 = this.libro.getSheet(sheetName);
		if(hoja1==null)
			hoja1 = this.libro.createSheet(sheetName);
		
		getCell(hoja1,0,fila).setCellValue("Venta");
		
		getCell(hoja1,0,++fila).setCellValue("CRoomService");getCell(hoja1,1,fila).setCellValue(obj.getcRoomService()*tipoCambio);
		
		return ++fila;
	}
	
	public Double getAlimentosCostoRoomServ(){
		CostosBo costo=new CostosBo();
		SalesArticleRVC article=costo.getCOSTotalFromRVCOutlet(fechaCosto);
		return article.getCosTotal();
	}
	
		public void detalleAlimentosRoomServ(){
			CostosBo costo=new CostosBo(); 
			OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
			
			Integer fila=0;
			fila=setLine("Room Serv","VENTAS",fila++);
			fila=setDataAlimentosVentasRoomServ(obj,"Room Serv",fila++);
			
				List<SalesArticleRVC> larticle=costo.detalleCOSTotalFromRVCOutlet(fechaCosto);
				fila=setLine("Room Serv","COSTOS",fila++);
				fila=setDataCOSTotalFromRVC(larticle,"Room Serv",fila++);
		}
	
		public Integer setLine(String sheetName,String title,Integer fila){
			XSSFSheet hoja1 = this.libro.getSheet(sheetName);
			if(hoja1==null)
				hoja1 = this.libro.createSheet(sheetName);
			
			fila=fila+1;
			getCell(hoja1,0,fila).setCellValue("XXXXXXXXXX");
			getCell(hoja1,1,fila).setCellValue(title.toUpperCase());
			getCell(hoja1,2,fila).setCellValue("XXXXXXXXXX");
			
			return ++fila;
		}
		
	public Double getAlimentosVentaFrigoBarOpera(){//ok
		CostosBo costo=new CostosBo();
		Double venta=costo.getVentaTotalFromFrigobar(fechaCosto, Constante.FRIGOBAR_ALIMENTOS);
		return venta;
	}
	
	public Double getBebidasVentaFrigoBarOpera(){//ok
		CostosBo costo=new CostosBo();
		Double venta=costo.getVentaTotalFromFrigobar(fechaCosto, Constante.FRIGOBAR_BEBIDAS);
		venta=venta*tipoCambio;
		return venta;
	}
	
	/**********************/
	public Double getAlimentosVentasRoomServ(){
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getcRoomService();
		venta=venta*tipoCambio;
		return venta;
	}
	
	
	public Double getAlimentosCostoRestaurant(){
		CostosBo costo=new CostosBo();
		SalesArticleRVC article=costo.getCOSTotalFromRVC(fechaCosto, Constante.OVERGROUP_ALIMENTO, Constante.OUTLET_ROOMSERVICE,Constante.AREAVENTA_RVC_REST_OCEANUS);
		
		Double costoGuia=getCostoTransferenciaFromGuia(Constante.GUIA_CONCEPTO_RESTAURANT_OW_ALIMENTO_ABIERTO);
		return article.getCosTotal()+costoGuia;
	}
	
	
	
	public Double getCostoTransferenciaFromGuia(String concepto){
		CostosBo costo=new CostosBo();
		Double costoGuia=costo.getCostoTransferenciaFromGuia(fechaCosto, concepto);
		return costoGuia;
	}
	
	
	
	public Double getAlimentosVentasDelphosCafeteriaTotal(){
		Double c1=getAlimentosVentasDelphosCafeteria();//--Delphos Cafeteria 
		Double c2=getAlimentosVentasDelphosEventos();//--Delphos Eventos
		Double c3=getAlimentosVentasDelphosPaquetes();//--Paquetes y promociones
		Double c4=getQtyAlimentosVentasDelphosDesayAlmCenaIncluido();//Desay/Alm/Cena Incluida
		
		Double ventas_delphos_buffet=getAlimentosVentasDelphosBuffetTotal(); // ESPECIAL
		
		return c1+c2+c3+c4-ventas_delphos_buffet;
	}
	
	
	
	public void detalleAlimentosDelphosCarta(){
			CostosBo costo=new CostosBo(); 
			OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
					
			Integer fila=0;
			fila=setLine("Delphos Carta","VENTAS",fila++);
			fila=setDataAlimentosVentasDelphosCafeteria(obj,"Delphos Carta",fila++);
			
			fila++;
			Double value=obj.getDelphosEventos();
			value=value*tipoCambio;
			fila=setDataFromOutlHjTrb("DelphosEventos",value,"Delphos Carta",fila++);
			
			fila++;
			fila=setDataAlimentosVentasDelphosPaquetes(obj,"Delphos Carta",fila++);

			/****NO SE INCLUYE EN LA SUMA DEL RESULTADO
			Double c4=getQtyAlimentosVentasDelphosDesayAlmCenaIncluido();
			fila=setDataFromValue("Desay/Alm/Cena Incluida",c4,"Delphos Carta",fila++);
			*/
			fila++;
			List<SalesArticleRVC> larticle=costo.detalleVentaTotalFromRVCDelphosBuffet(fechaCosto);
			fila=setDataAlimentosVentasDelphosBuffetTotal(larticle,"Delphos Carta",fila++);
			
			
				fila=setLine("Delphos Carta","COSTOS",fila++);
				
				List<SalesArticleRVC> lsales=costo.detalleCOSTotalFromRVCDelphosCarta(fechaCosto);
				fila=setDataCOSTotalFromRVC(lsales,"Delphos Carta",fila++);
				fila++;
				
				List<GuiaTransfCosto> lGuia=costo.detalleCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_PAN_COVER);
				fila=setDataCostoTransferenciaFromGuia(lGuia,"Delphos Carta",fila++);
				
				fila++;
				List<GuiaTransfCosto> lGuia2=costo.detalleCostoTransferenciaFromGuiaMenusLogicos(fechaCosto);
				fila=setDataCostoTransferenciaFromGuia(lGuia2,"Delphos Carta",fila++);	
		}
		
		
		public Double getAlimentosCostoDelphosCarta(){
			CostosBo costo=new CostosBo();
			SalesArticleRVC sales=costo.getCOSTotalFromRVCDelphosCarta(fechaCosto);
			Double c1=sales.getCosTotal();
			Double c2=costo.getCostoTransferenciaFromGuia(fechaCosto,Constante.GUIA_CONCEPTO_PAN_COVER);
			Double c3=costo.getCostoTransferenciaFromGuiaMenusLogicos(fechaCosto);
			return c1+c2+c3;
		}
		
	
	//Delphos Cafeteria -alimentos
	public Double getAlimentosVentasDelphosCafeteria(){
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getcDelphos();
		venta=venta*tipoCambio;
		return venta;
	}
	
	//Delphos Cafeteria -bebidas
	public Double getBebidasVentasDelphosCafeteria(){
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getbDelphos();
		venta=venta*tipoCambio;
		return venta;
	}
	
	//Paquetes y promociones -alimentos
	public Double getAlimentosVentasDelphosPaquetes(){
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getcKnoEvt();
		venta=venta*tipoCambio;
		return venta;
	}
	
	public Double getBebidasVentasDelphosPaquetes(){
			CostosBo costo=new CostosBo(); 
			OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
			Double venta=obj.getbKnoEvt();
			venta=venta*tipoCambio;
			return venta;
	}
		
	public Double getAlimentosVentasDelphosEventos(){
		CostosBo costo=new CostosBo(); 
		OutlHjTrb obj=costo.getOutlHjTrb(fechaCosto);
		Double venta=obj.getDelphosEventos();
		venta=venta*tipoCambio;
		return venta;
	}
	
	public Double getBebidasVentasDelphosEventos(){
		return 0.0;
	}
		
	public Double getAlimentosVentasDelphosWelcomeDrink(){
		return 0.0;
	}
	
	public Double getBebidasVentasDelphosWelcomeDrink(){
		CostosBo costo=new CostosBo();
		Integer qtyWd=costo.getCOSTotalFromRVCWelcomeDrink(fechaCosto);
		Double c1=qtyWd*Constante.COSTO_WDRINK_UNI*tipoCambio;
		return c1;
	}
	
	public Double getQtyAlimentosVentasDelphosDesayAlmCenaIncluido(){
		CostosBo costo=new CostosBo();
		Integer qty=costo.getQtyVentaTotalFromRVCDelphosDesayAlmCenaIncluido(fechaCosto);
		Double c1=qty*Constante.COSTO_DESAYUNO_UNI*tipoCambio;
		
		return c1;
	}
	
	public Double getBebidasVentasDelphosDesayAlmCenaIncluido(){
		return 0.0;
	}
	
	public Double getAlimentosVentaFrigobarRVC(){//ok
		CostosBo costo=new CostosBo();
		SalesArticleRVC article=costo.getVentaTotalFromRVCFrigobar(fechaCosto);
		return article.getVenTotal();
	}
	
}
