package read;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;

import org.apache.poi.openxml4j.util.ZipSecureFile;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import com.delfines.business.CostosBo;
import com.delfines.business.Util;

public class ReadExcelAuditoria {

	private String rutaCosto=null;
	
	private String fileSalesArticleStatistics="Sales_Article_Statistics";
	private String fileDailyFoodA="Daily_Food_A";
	private String fileDailyFoodB="Daily_Food_B";
	
	public ReadExcelAuditoria(){
		
	}
	
	public ReadExcelAuditoria(String rutaCosto){
		this.rutaCosto=rutaCosto;
	}
	
	public void insertSqlOutlHjTrb(String fechaCosto) throws RuntimeException {
		try {
			CostosBo costos = new CostosBo();
			Date fecha=Util.stringToDate(fechaCosto);
			
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(fecha);
					
			Integer aa=calendar.get(Calendar.YEAR);
			Integer mm=calendar.get(Calendar.MONTH)+1;
			Integer dd=calendar.get(Calendar.DAY_OF_MONTH);

			costos.insertSqlOutlHjTrb(aa, mm, dd);
			System.out.println("Termina insertSqlOutlHjTrb "+fechaCosto);
		}catch(Exception e){
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	} 
	
//	public void insertSqlOutlHjTrb(Integer LastRow) throws RuntimeException {
//		try {
//			CostosBo costos = new CostosBo();
//			
//			String file=this.fileOutlHjTrb;
//			File excelFile = new File(file);
//			FileInputStream fis = new FileInputStream(excelFile);
//			ZipSecureFile.setMinInflateRatio(-1.0d);
//			// we create an XSSF Workbook object for our XLSX Excel File
//			Workbook workbook = new XSSFWorkbook(fis);
//			// we get first sheet
//			Sheet sheet = workbook.getSheet("Datos");
//
//			Integer TamColumn = 125;
//
//			Row lastRow = sheet.getRow((LastRow-1));
//
//			StringBuffer sql = new StringBuffer();
//			sql.append("INSERT INTO dbo.outl_hjtrb(Fecha,AA,MM,DD,HRack,HCorporativo,HTours_Travel,HCongreso,HAerolineas,HPromociones,HSummit,H,HOtros_ingresos,HDesay_Incluido,CRoom_Service,CKnossos,CknoEvt,CDelphos,CExecut_Floor,CLobby_Bar,COceanus,CCasino,CBanquetes,COtros_Ingresos,BRoom_Service,BKnossos,BknoEvt,BDelphos,Miscelaneo,BLobby_Bar,BOceanus,BCasino,BBanquetes,BServibar,MTelefonia,MLavanderia,MValet,MEstacionamiento,Mctro_Negocios,OAlquileres,OConcesiones,OCasino,OMerchandising,OGimnasio,EDisp,EOcup,EHuesp,ECompl,ERack,ECorporativo,ETours_Travel,TrpVtDph,EAerolineas,EPromociones,EVentas_Intern,CbRoom_Serv,CbKnossos,CbDelphos,Momentos,CbLobby_Bar,CbOceanus,CbCasino,CbBanquetes,OIngresos,PHRack,PHCorporativo,PHTour_Travel,PHCongresos,PHAerolineas,PHPromociones,PHVentas_Intern,Phblank,PHOtros_ingresos,PCRoomServ,PCKnossos,PCDelphos,PCExeFloor,PCLobbyBar,PCOceanus,PCCasino,PCBanquetes,PCOtrIng,PBRoomServ,PBKnossos,PBDelphos,PBExeFloor,PBLobbyBar,PBOceanus,PBCasino,PBBanquetes,PBServibar,PMTelefonia,PMLavanderia,PMTv_Premium,PMEstacionamiento,PMCtroNegocios,PMAlquileres_de_Tiendas,PMLavand_Externa,PMCasino,PMMerchandising,PMGimnasio_y_Varios,PMDisp,PEOcup,PEHuesp,PECompl,PHORack,PHOCorporativo,PHOTours_Travel,PHOCongreso,PHOAerolineas,PHOPromociones,PHOVentas_Intern,PDesayInc,Pcover,PACInc,DMesPr,PCbRoomServ,PCbKnossos,PCbDelphos,PCbExecFloor,PCbLobbyBar,PCbOceanus,PCbCasino,PCbBanquetes,POIngresos,lastrow)");
//			sql.append("VALUES(");
//			// iterate on cells for the current row
//			Iterator<Cell> cellIterator = lastRow.cellIterator();
//
//			Cell cell0 = lastRow.getCell(0);
//			
//			if(cell0!=null&&cell0.toString().trim().length()>0){
//				int c = 0;
//				while (cellIterator.hasNext() && c++ < TamColumn) {
//					Cell cell = cellIterator.next();
//					if(c==1){
//						sql.append("'");
//						sql.append(Util.dateToString(cell.getDateCellValue()));
//						sql.append("'");
//						sql.append(",");
//		            }else{
//						sql.append(cell.toString().trim().length()==0?"0.0":cell.toString());
//						sql.append(",");
//		            }
//				}
//				sql.append(LastRow + ");");
//
//				costos.deleteOutlHjtrb(LastRow);
//				costos.insertarOutlHjtrb(sql.toString());
//				costos.updateLastRow();
//				System.out.println("add line ..."+LastRow);
//			}else{
//				System.out.println("empty line..."+LastRow);
//			}
//			
//		} catch (Exception e) {
//			e.printStackTrace();
//			throw new RuntimeException(e);
//		}
//	}

	public void insertSqlSalesArticleStatistics(String fechaCosto)throws RuntimeException {
		StringBuffer sql = new StringBuffer();
		try {
			CostosBo costos = new CostosBo();
			costos.deleteSalesArticleStatistics(fechaCosto);
			// produccion//analisis de ventas //estadisticas de venta de
			// articulos
			String extfile="_"+fechaCosto.replaceAll("/", "")+".xls";
			
			String file=rutaCosto+fileSalesArticleStatistics+extfile;
			File excelFile = new File(file);
			FileInputStream fis = new FileInputStream(excelFile);
			ZipSecureFile.setMinInflateRatio(-1.0d);
			// we create an XSSF Workbook object for our XLSX Excel File
			Workbook workbook = WorkbookFactory.create(fis);
			// we get first sheet
			Sheet sheet = workbook.getSheet("Data");

			// iterate on cells for the current row

			// Get iterator to all the rows in current sheet
			Iterator<Row> rowIterator = sheet.iterator();

			// Row Header
			if (rowIterator.hasNext()) {
				rowIterator.next();
			}

			
			// Traversing over each row of XLSX file
			while (rowIterator.hasNext()) {
				Row row = rowIterator.next();
				if(row.getCell(4)!=null&&Util.stringToDouble(row.getCell(4).toString())>0){	
					sql = new StringBuffer();
					sql.append(
							"INSERT INTO dbo.sales_article_statistics(sales_location,no_product,product,date_rvc,qty,s_price,net_total,gross_total,cos_uni,cos_total,cos_porc,cm,cm_total,mu,pot_mu,grouped_by)VALUES(");
					// For each row, iterate through each columns
					//Iterator<Cell> cellIterator = row.cellIterator();
					//Integer col = 1;
					//while (cellIterator.hasNext()) {
					for(int col=0;col<=15;col++){
						//Cell cell = cellIterator.next();
						Cell cell = row.getCell(col);
	
						if(cell!=null){
							if (col == 0 || col == 2|| col == 15) {
								sql.append("'").append(cell.toString()).append("'");
							}else if(col == 3){
								String date_rvc=Util.dateToString(cell.getDateCellValue());
								sql.append("'").append(date_rvc).append("'");
							}else {
								sql.append(cell.toString());
							}
						}else{
							sql.append("NULL");
						}
	
						if (col < 15)
							sql.append(",");
					}
					sql.append(");");
	
					/// Insert into database
					costos.insertarSalesArticleStatistics(sql.toString());
				}
				
			}
			System.out.println("Termina insertSqlSalesArticleStatistics "+fechaCosto);
		} catch (Exception e) {
			System.out.println(sql.toString());
			e.printStackTrace();
			throw new RuntimeException(e);
		}

	}

	
	public void insertSqlDailyFoodAlimentos(String fechaCosto)throws RuntimeException {
		try {
			CostosBo costos = new CostosBo();
			costos.deleteDailyFoodAlimentos(fechaCosto);
			// produccion//analisis de ventas //estadisticas de venta de
			// articulos
			String extfile="_"+fechaCosto.replaceAll("/", "")+".xls";
			String file=rutaCosto+fileDailyFoodA+extfile;
			File excelFile = new File(file);
			FileInputStream fis = new FileInputStream(excelFile);
			ZipSecureFile.setMinInflateRatio(-1.0d);
			// we create an XSSF Workbook object for our XLSX Excel File
			Workbook workbook = WorkbookFactory.create(fis);
			// we get first sheet
			Sheet sheet = workbook.getSheet("Data");

			// iterate on cells for the current row

			// Get iterator to all the rows in current sheet
			Iterator<Row> rowIterator = sheet.iterator();

			// Row Header
			if (rowIterator.hasNext()) {
				rowIterator.next();
			}

			// Traversing over each row of XLSX file
			while (rowIterator.hasNext()) {
				Row row = rowIterator.next();

				StringBuffer sql = new StringBuffer();
				sql.append(
						"INSERT INTO dbo.daily_food_alimentos(trx_date,Gross_Revenue,Net_Revenue,Consumption,ACT_COS,Other_Usage,Inv_Diff,POT_COS,Total_Receiving,Purchase,Transfers)VALUES(");
				// For each row, iterate through each columns
				Iterator<Cell> cellIterator = row.cellIterator();
				Integer col = 1;
				while (cellIterator.hasNext()) {
					Cell cell = cellIterator.next();

					if (col == 1 ) {
						String date_rvc=Util.dateToString(cell.getDateCellValue());
						sql.append("'").append(date_rvc).append("'");
					}else {
						sql.append(cell.toString());
					}

					if (col < 11)
						sql.append(",");
					col++;
					
				}
				sql.append(");");

				/// Insert into database
				costos.insertarSalesArticleStatistics(sql.toString());
			}
			System.out.println("load daily_food_alimentos");
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}

	}
	
	public void insertSqlDailyFoodBebidas(String fechaCosto)throws RuntimeException {
		try {
			CostosBo costos = new CostosBo();
			costos.deleteDailyFoodBebidas(fechaCosto);
			// produccion//analisis de ventas //estadisticas de venta de
			// articulos
			String extfile="_"+fechaCosto.replaceAll("/", "")+".xls";
			String file=rutaCosto+fileDailyFoodB+extfile;
			File excelFile = new File(file);
			FileInputStream fis = new FileInputStream(excelFile);
			ZipSecureFile.setMinInflateRatio(-1.0d);
			// we create an XSSF Workbook object for our XLSX Excel File
			Workbook workbook = WorkbookFactory.create(fis);
			// we get first sheet
			Sheet sheet = workbook.getSheet("Data");

			// iterate on cells for the current row

			// Get iterator to all the rows in current sheet
			Iterator<Row> rowIterator = sheet.iterator();

			// Row Header
			if (rowIterator.hasNext()) {
				rowIterator.next();
			}

			// Traversing over each row of XLSX file
			while (rowIterator.hasNext()) {
				Row row = rowIterator.next();

				StringBuffer sql = new StringBuffer();
				sql.append(
						"INSERT INTO dbo.daily_food_bebidas(trx_date,Gross_Revenue,Net_Revenue,Consumption,ACT_COS,Other_Usage,Inv_Diff,POT_COS,Total_Receiving,Purchase,Transfers)VALUES(");
				// For each row, iterate through each columns
				Iterator<Cell> cellIterator = row.cellIterator();
				Integer col = 1;
				while (cellIterator.hasNext()) {
					Cell cell = cellIterator.next();

					if (col == 1 ) {
						String date_rvc=Util.dateToString(cell.getDateCellValue());
						sql.append("'").append(date_rvc).append("'");
					}else {
						sql.append(cell.toString());
					}

					if (col < 11)
						sql.append(",");
					col++;
					
				}
				sql.append(");");

				/// Insert into database
				costos.insertarSalesArticleStatistics(sql.toString());
			}
			System.out.println("load daily_food_bebidas");
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}

	}
	
	public void copyLoadXlsxOutlHjTrb160(){
		try{
			moveFile("\\\\10.0.0.11\\siih\\FO\\DBF\\Outl_HjTrb.xlsx", "\\\\10.0.0.160\\Costos\\Outl_HjTrb.xlsx");
			CostosBo costos = new CostosBo();
			costos.loadXlsxOutHjtrb160();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private static void moveFile(String src, String dest ) {
	      Path result = null;
	      try {
	    	 File toFile = new File(dest);
	    	 if (toFile.exists()) {
	    	     // rename file
	    	     toFile.renameTo(new File(dest+".bak"));
	    	     Files.deleteIfExists(Paths.get(dest));
	    	 } else {
	    	     // do something if file does NOT exist
	    	 }
	         result = Files.copy(Paths.get(src), Paths.get(dest));
	      } catch (IOException e) {
	         System.out.println("Exception while moving file: " + e.getMessage());
	      }
	      if(result != null) {
	         System.out.println("File copy successfully.");
	      }else{
	         System.out.println("File movement failed.");
	      }
	 }
	
}
