$(document).ready(function() {
	
	var baseURL=$('#contextPathHolder').attr('data-contextPath');
	
	$("#chEstadoEntrega").change(function(){
		var txtComentarioEntrega=$("#txtComentarioEntrega").val().trim().toUpperCase();
		txtComentarioEntrega=normalize(txtComentarioEntrega);
		var txtIdGuia=$("#hIdGuia").val();
		
		var chEstadoEntrega = $("#chEstadoEntrega").is(':checked');
        var selEstadoEntrega=(chEstadoEntrega?1:0);
        
        var intIdGuia = parseInt(txtIdGuia);
        if(intIdGuia>0){
			$.ajax({
				url : baseURL + "/guardar-estado-entrega",
				data : {
					idGuia:txtIdGuia,
					comentarioEntrega: txtComentarioEntrega,
					estadoEntrega:selEstadoEntrega
				},
				async:false,
				type : "get",
				contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
				dataType : 'json',
				success : function(estado) {
					if(estado.estado==1){//entregado
						$("#txtFechaEntrega").val(estado.fecha);
						$("#txtComentarioEntrega").val(estado.comentario);
						
						$("#txtComentarioEntrega").prop("disabled", true);
						$("#chEstadoEntrega").prop("checked", true);
						$("#chEstadoEntrega").prop("disabled", true);			
					}
				}
			});
        }else{
        	alert("Seleccione un número de guia válido!");
        }
    });	
	
	$("#cmdBuscarGuia").click(function(){
		var txtNumeroGuiaBuscar=$("#txtNumeroGuiaBuscar").val();
		
		if(isInt(txtNumeroGuiaBuscar)&&txtNumeroGuiaBuscar>0){
		
			$.ajax({
				url : baseURL + "/buscar-guia",
				data : {
					numeroGuia: txtNumeroGuiaBuscar	
				},
				async:false,
				type : "get",
				contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
				dataType : 'json',
				success : function(guia) {
					$("#txtFechaOrden").val(guia.fechaGuia);
					
					$("#hIdGuia").val(guia.idGuia);
					$("#txtNroGuia").val(guia.numeroGuia);
					
					$("#hIdCliente").val(guia.idCliente);
					$("#txtIdCliente").val(guia.denominacionCliente);
					
					//--
					$("#txtDescCliente").val(guia.descripcionCliente);
					//--
					
					$("#hIdListaPrecio").val(guia.idListaPrecio);
					$("#txtIdListaPrecio").val(guia.denominacionListaPrecio);
					
					$("#hIdPrioridad").val(guia.idPrioridad);
					$("#txtIdPrioridad").val(guia.denominacionPrioridad);
					
					$("#selIdDescuento").val(guia.idDescuento);
					
					$("#txtComentario").val(guia.comentario);
					
					//--
					$("#hIdComprobante").val(guia.idComprobante);
					$("#hIdPago").val(guia.idPago);
					//--
					$("#hEstado").val(guia.estado);
					
					$("#hIdGuiaBuscar").val(guia.idGuia);
					
					$("#txtComentarioEntrega").val(guia.comentarioEntrega);
					$("#txtFechaEntrega").val(guia.fechaEntrega);
					
					if(guia.estadoEntrega==1){//entregado
						$("#txtComentarioEntrega").prop("disabled", true);
						$("#chEstadoEntrega").prop("checked", true);
						$("#chEstadoEntrega").prop("disabled", true);
					}else{
						$("#txtComentarioEntrega").prop("disabled", false);
						$("#chEstadoEntrega").prop("checked", false);
						$("#chEstadoEntrega").prop("disabled", false);
					}
					
					buscarGuiaDetalle();
					editable(guia.estado);
				},
				error: function(xhr, status, error) {
					alert("La guia nro: "+txtNumeroGuiaBuscar+" no se ecnuentra registrada.");
			    }
			});
			
		}else{
			alert('Ingrese un numero de guia válido!');
  			$("#txtNumeroGuiaBuscar").focus();
  			$("#txtNumeroGuiaBuscar").select();
		}
    });	
	
	
	function buscarGuiaDetalle(){
		var txtIdGuiaBuscar=$("#hIdGuiaBuscar").val();
		$.ajax({
			url : baseURL + "/buscar-guia-detalle",
			data : {
				idGuia: txtIdGuiaBuscar	
			},
			async:false,
			type : "get",
			success : function(response) {
				$("#subViewDiv").html( response );
			}
		});
	}
	
	
	function editable(estado){
		if(estado=='2'){//ESTADO_GUIDE_COMPLETO = "2";
			$("#txtIdCliente").prop("disabled", true);
			$("#txtIdListaPrecio").prop("disabled", true);
			$("#txtIdPrioridad").prop("disabled", true);
			$("#selIdDescuento").prop("disabled", true);
			$("#txtComentario").prop("disabled", true);
			$("#txtComentario").prop("disabled", true);
			$("#txtIdServicio").prop("disabled", true);
			$("#txtCantidad").prop("disabled", true);
			//$("#txtPrecio").prop("disabled", true);
			$("#txtDescripcion").prop("disabled", true);
			$("#cmdAgregarServicio").prop("disabled", true);
			$("#txtFechaComprometida").prop("disabled", true);
			
			$('#cmdCompletar').prop("disabled", true);
			$("#cmdCompletar span").text("Guardar [G]");
			
			$("#tablaGuiaDetalle").find("button").attr("disabled", true);
		}else{
			$("#txtIdCliente").prop("disabled", false);
			$("#txtIdListaPrecio").prop("disabled", false);
			$("#txtIdPrioridad").prop("disabled", false);
			$("#selIdDescuento").prop("disabled", false);	
			$("#txtComentario").prop("disabled", false);
			$("#txtIdServicio").prop("disabled", false);
			$("#txtCantidad").prop("disabled", false);
			//$("#txtPrecio").prop("disabled", false);
			$("#txtDescripcion").prop("disabled", false);
			$("#cmdAgregarServicio").prop("disabled", false);
			$("#txtFechaComprometida").prop("disabled", false);
			
			$('#cmdCompletar').prop("disabled", false);
			$("#cmdCompletar span").text("Guardar [G]");
			
			$("#tablaGuiaDetalle").find("button").attr("disabled", false);
		}
	}
	
    $("#cmdNuevoGuia").click(function(){
		$.ajax({
			url : baseURL + "/inicia-guia",
			async:false,
			type : "get",
			contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
			dataType : 'json',
			success : function(guia) {
				$("#txtFechaOrden").val(guia.fechaGuia);
					var fechaadd3=addDays(guia.fechaGuia,3);//15112019 add 3dias
				$("#txtFechaComprometida").val(fechaadd3);
				$("#hIdGuia").val(guia.idGuia);
					$("#hIdComprobante").val(0);//limpiar comprobante buscado
				$("#txtNroGuia").val(guia.numeroGuia);
				
				$("#txtComentarioEntrega").prop("disabled", false);
				$("#chEstadoEntrega").prop("checked", false);
				$("#chEstadoEntrega").prop("disabled", false);
				
				clearControls();
			}
		});
    });	
	
    init();
	
	function init(){
		$("#cmdNuevoGuia").trigger({ type: "click" });
	}
	
	$("#txtIdServicio").focusout(function(event){
		var hIdGuiaDetalle=$("#hIdGuiaDetalle").val();
		if(isEmpty(hIdGuiaDetalle)){
			hIdGuiaDetalle="0";
		}
		
		if(hIdGuiaDetalle=="0"){
			var txtIdListaPrecio=getIdListaPrecio($("#txtIdListaPrecio").val());
			var txtIdServicio=getIdServicio($("#txtIdServicio").val());
			
			if(txtIdListaPrecio>0 &&txtIdServicio>0){
				$.ajax({
					url : baseURL + "/obtener-detalle-servicio",
					data : {
						idListaPrecio: txtIdListaPrecio,	
						idServicio: txtIdServicio
					},
					async:false,
					type : "get",
					contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
					dataType : 'json',
					success : function(servicio) {
						if(servicio.idServicio>0){
							$("#txtPrecio").val(servicio.precioUnitario);
							$("#txtCantidad").val("");
							$("#txtDescripcion").val("");
							$("#hIdDetalleLista").val(servicio.idDetalleLista);
							$("#hIdGuiaDetalle").val("0");//FOR EDIT	
						}else{
							alert('Error en la obtención del servicio, revise los datos ingresados');
						}
					},
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.responseText);
						cancelBubble(event);
				    }
				});
			}	
		}else{
			cancelBubble(event);
		}
		
    });
	
	function cancelBubble(e) {
		 var evt = e ? e:window.event;
		 if (evt.stopPropagation)    evt.stopPropagation();
		 if (evt.cancelBubble!=null) evt.cancelBubble = true;
	}
	
	$("#txtIdListaPrecio").focusout(function(){
		var txtIdListaPrecio=getIdListaPrecio($("#txtIdListaPrecio").val());
		txtIdListaPrecio=parseInt(txtIdListaPrecio);
			
		if(txtIdListaPrecio>0){
			
			$.ajax({
				url : baseURL + "/obtener-servicios-lista",
				data : {
					idListaPrecio: txtIdListaPrecio
				},
				async:false,
				type : "get",
				contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
				dataType : 'json',
				success : function(data) {
					var dataList = $("#lServicios");
					dataList.empty();
					if(data.length) {
			          for(var i=0, len=data.length; i<len; i++) {
			        	  dataList.append("<option data-value='" + data[i]['id'] + "' value='" + data[i]['denominacion'] + "'>");
			          }
			        }
				}
			});
			
		}
		
    });
	
	
	$("#cmdAgregarServicio").click(function(){
		var txtIdGuia=$("#hIdGuia").val();
		var txtIdDetalleLista=$("#hIdDetalleLista").val();
			var txtIdServicio=getIdServicio($("#txtIdServicio").val());
	    var txtIdPrioridad=getIdPrioridad($("#txtIdPrioridad").val());
			var txtPrecio=$("#txtPrecio").val();
			var txtCantidad=$("#txtCantidad").val();
		var txtDescripcion=$("#txtDescripcion").val().trim().toUpperCase();
		txtDescripcion=normalize(txtDescripcion);
		var hIdGuiaDetalle=$("#hIdGuiaDetalle").val();//FOR EDIT
		var selIdDescuento=$("#selIdDescuento").val();
		
		//--
		if(validaAddServicio()){
			$.ajax({
				url : baseURL + "/add-item-guia",
				data : {
					idGuia:txtIdGuia,
					idDetalleLista:txtIdDetalleLista,
					idServicio: txtIdServicio,
					idPrioridad:txtIdPrioridad,
					idDescuento:selIdDescuento,
					precio:txtPrecio,
					cantidad:txtCantidad,
					descripcion:txtDescripcion,
					idGuiaDetalle:hIdGuiaDetalle
				},
				async:false,
				type : "get",
				success : function(response) {
					$("#subViewDiv").html( response );
					clearItemControls();
				}
			});
		}
    });
	
	
	$("#cmdDelAceptar").click(function(){
		var hIdGuiaDetalleDelete=$("#hIdGuiaDetalleDelete").val();
      	var hIdGuia=$("#hIdGuia").val();
      	
		$.ajax({
			url : baseURL + "/delete-item-guia",
			data : {
				idGuiaDetalle:hIdGuiaDetalleDelete,
				idGuia:hIdGuia
			},
			async:false,
			type : "get",
			success : function(response) {
				$("#subViewDiv").html( response );
			}
		});
		
    });
	
	function validaGetPrecio(){
		var txtIdServicio=getIdServicio("txtIdServicio");
		var txtPrecio=$("#txtPrecio").val();
		var txtCantidad=$("#txtCantidad").val();
  		
  		if(!(isInt(txtIdServicio)&&txtIdServicio>0)){
  			alert('Seleccione el servicio!');
  			$("#txtIdServicio").focus();
  			$("#txtIdServicio").select();
  			return false;
  		}
  		
  		if(!(isDouble(txtPrecio))){
  			alert('Ingrese un precio valido del servicio!');
  			$("#txtPrecio").focus();
  			$("#txtPrecio").select();
  			return false;
  		}
  		
  		if(!(isDouble(txtCantidad))){
  			alert('Ingrese una cantidad valida del servicio!');
  			$("#txtCantidad").focus();
  			$("#txtCantidad").select();
  			return false;
  		}
  		return true;
	}
	
	function validaAddServicio(){
		var txtIdServicio=getIdServicio($("#txtIdServicio").val());
		var txtPrecio=$("#txtPrecio").val();
		var txtCantidad=$("#txtCantidad").val();
		var txtIdListaPrecio=getIdListaPrecio($("#txtIdListaPrecio").val());
  		
  		if(!(isInt(txtIdListaPrecio)&&txtIdListaPrecio>0)){
  			alert('Seleccione la lista de precio!');
  			$("#txtIdListaPrecio").focus();
  			$("#txtIdListaPrecio").select();
  			return false;
  		}
  		
  		if(!(isInt(txtIdServicio)&&txtIdServicio>0)){
  			alert('Seleccione el servicio!');
  			$("#txtIdServicio").focus();
  			$("#txtIdServicio").select();
  			return false;
  		}
  		
  		if(!(isDouble(txtPrecio))){
  			alert('Ingrese un precio valido del servicio!');
  			$("#txtPrecio").focus();
  			$("#txtPrecio").select();
  			return false;
  		}
  		
  		if(!(isDouble(txtCantidad))){
  			alert('Ingrese una cantidad valida del servicio!');
  			$("#txtCantidad").focus();
  			$("#txtCantidad").select();
  			return false;
  		}
  		return true;
  		
	}
	
	function valida(){
		var hIdCliente=getIdCliente($("#txtIdCliente").val());
		var hIdListaPrecio=getIdListaPrecio($("#txtIdListaPrecio").val());
  		var hIdPrioridad=getIdPrioridad($("#txtIdPrioridad").val());
  		
  		var txtFechaComprometida=$("#txtFechaComprometida").val();
  		var selIdDescuento=$("#selIdDescuento").val();
  		var fTotalNeto=$("#fTotalNeto").val();
  		
  		if(!(isInt(hIdCliente)&&hIdCliente>0)){
  			alert('El campo Cliente es obligatorio!');
  			$("#txtIdCliente").focus();
  			$("#txtIdCliente").select();
  			return false;
  		}
  		
  		if(!(isInt(hIdListaPrecio)&&hIdListaPrecio>0)){
  			alert('El campo Lista de Precio es obligatorio!');
  			$("#txtIdListaPrecio").focus();
  			$("#txtIdListaPrecio").select();
  			return false;
  		}
  		
  		if(!(isInt(hIdPrioridad)&&hIdPrioridad>0)){
  			alert('El campo Prioridad es obligatorio!');
  			$("#txtIdPrioridad").focus();
  			$("#txtIdPrioridad").select();
  			return false;
  		}
  		
  		if(!(isInt(selIdDescuento)&&selIdDescuento>0)){
  			alert('El campo Descuento es obligatorio!');
  			$("#selIdDescuento").focus();
  			$("#selIdDescuento").select();
  			return false;
  		}
  		
  		if(isEmpty(txtFechaComprometida)){
  			alert('El campo Fecha Comprometida es obligatorio!');
  			$("#txtFechaComprometida").focus();
  			$("#txtFechaComprometida").select();
  			return false;
  		}
  		
  		if(!isDouble(fTotalNeto)){
  			alert('Se requiere registrar el detalle de la guia!');
  			$("#txtIdServicio").focus();
  			$("#txtIdServicio").select();
  			return false;
  		}
  		return true;
	}
	
	$("#cmdCompletar").click(function(){
		var hIdGuia=$("#hIdGuia").val();
			var txtFechaComprometida=$("#txtFechaComprometida").val();
			var hIdCliente=getIdCliente($("#txtIdCliente").val());
  			var hIdListaPrecio=getIdListaPrecio($("#txtIdListaPrecio").val());
	  		var hIdPrioridad=getIdPrioridad($("#txtIdPrioridad").val());
	  		var selIdDescuento=$("#selIdDescuento").val();
	  	var txtComentario=$("#txtComentario").val().trim().toUpperCase();
	  	txtComentario=normalize(txtComentario);
	  	
	  	var fTotalGeneral=$("#fTotalGeneral").val();
	  	var fTotalDescuento=$("#fTotalDescuento").val();
	  	var fTotalRecargo=$("#fTotalRecargo").val();
	  	var fTotalNeto=$("#fTotalNeto").val();
	  	var fTotalIgv=$("#fTotalIgv").val();

	  	if(valida()){
	  		
	  		$('#cmdCompletar').prop("disabled", true);
			$.ajax({
				url : baseURL + "/complete-guia",
				data : {
					idGuia:hIdGuia,
					idCliente:hIdCliente,
					fechaComprometida:txtFechaComprometida,
					idListaPrecio:hIdListaPrecio,
					idPrioridad:hIdPrioridad,
					idDescuento:selIdDescuento,
					comentario:txtComentario,
			    	totalDescuento:fTotalDescuento,
			    	totalRecargo:fTotalRecargo,
			    	totalGeneral:fTotalGeneral,
			    	totalNeto:fTotalNeto,
			    	totalIgv:fTotalIgv
				},
				async:false,
				type : "get",
				success : function(numeroGuia) {
					$('#cmdCompletar').prop("disabled", true);
					$("#cmdCompletar span").text("Guardar [G]");
					$("#txtNroGuia").val(numeroGuia);
					editable('2');//ESTADO_GUIDE_COMPLETO = "2";
					$("#hEstado").val(2);
				}
			});
	  	}
    });
	
	
	$("#cmdImprimir").click(function(){
		var hIdGuia=$("#hIdGuia").val();
		
		var estado=$("#hEstado").val();
		if(estado=='2'){//ESTADO_GUIDE_COMPLETO = "2";{}
			if(valida()){
		  		$.ajax({
					url : baseURL + "/print-guia",
					data : {
						idGuia:hIdGuia
					},
					async:false,
					type : "get",
					success : function(response) {
						window.open(baseURL+"/impresion-guia", "_blank", "toolbar=1, scrollbars=1, resizable=1, width=" + 1015 + ", height=" + 800);
					}
				});
			}
		}else{
			alert('Se requiere Guardar los datos presione ALT + G ');
		}
    });
	
	
	
	$("#cmdFacturar").click(function(){
		var hIdGuia=$("#hIdGuia").val();
		var hIdComprobante=$("#hIdComprobante").val();
		
		var estado=$("#hEstado").val();
		if(estado=='2'){//ESTADO_GUIDE_COMPLETO = "2";{}
			if(valida()){
				if(!isEmpty(hIdGuia)){
					$.ajax({
						url : baseURL + "/create-factura-desde-guia",
						data : {
							idGuia:hIdGuia,
							idComprobante:hIdComprobante
						},
						async:false,
						type : "get",
						success : function(response) {
							window.location.replace(baseURL+"/registro-factura");
						}
					});
				}else{
					alert("Ingrese Nro Guia Valida");
				}
			}
		}else{
			alert('Se requiere Guardar los datos presione ALT + G');
		}
    });
	
	
	$("#cmdFacturarGrupo").click(function(){
		var hIdGuias=$("#hIdGuias").val();
		
		if(!isEmpty(hIdGuias)){
			$.ajax({
				url : baseURL + "/create-factura-desde-lista-guia",
				data : {
					idListaGuia:hIdGuias
				},
				async:false,
				type : "get",
				success : function(response) {
					window.location.replace(baseURL+"/registro-factura");
				}
			});
		}
		
    });
	
	function clearItemControls(){
		$("#txtIdServicio").val("");
		$("#txtPrecio").val("");
		$("#txtCantidad").val("");
		$("#txtDescripcion").val("");
		$("#hIdGuiaDetalle").val("0");//FOR EDIT
		
		$("#txtIdServicio").focus();
		$("#txtIdServicio").select();
		
		$('#tablaGuiaDetalle tr').each(function (i, row) {
	        var $actualrow = $(row);
	        $a = $actualrow.find('a');
	        $a.bind('click', false);
	    });
	}
	
	function clearControls(){
		$("#txtIdCliente").val("");
		//$("#txtIdListaPrecio").val("");
		//$("#txtIdPrioridad").val("");
		$("#txtComentario").val("");
		$("#txtIdServicio").val("");
		$("#txtPrecio").val("");
		$("#txtCantidad").val("");
		$("#txtDescripcion").val("");
		$("#hIdGuiaDetalle").val("0");//FOR EDIT
		
		$("#txtfTotalGeneral").val("");
		$("#txtfTotalDescuento").val("");
		$("#txtfTotalNeto").val("");
		$("#txtfTotalCantidad").val("");
		
		$( "#tablaGuiaDetalle tbody tr" ).each( function(){
			  this.parentNode.removeChild( this ); 
		});
		
		$("#txtIdCliente").prop("disabled", false);
		$("#txtIdListaPrecio").prop("disabled", false);
		$("#txtIdPrioridad").prop("disabled", false);
		$("#selIdDescuento").prop("disabled", false);	
		$("#txtComentario").prop("disabled", false);
		$("#txtIdServicio").prop("disabled", false);
		$("#txtCantidad").prop("disabled", false);
		//$("#txtPrecio").prop("disabled", false);
		$("#txtDescripcion").prop("disabled", false);
		$("#cmdAgregarServicio").prop("disabled", false);
		$("#txtFechaComprometida").prop("disabled", false);
		$('#cmdCompletar').prop("disabled", false);
		
		$("#txtIdCliente").focus();
		$("#txtIdCliente").select();
		
		$("#hEstado").val(1);
	}
	
	function getIdPrioridad(str){
		var selectedOption = $("#lPrioridad option[value='" + str + "']");
	    var selectedId = parseInt(selectedOption.attr('data-value'));
	    if (selectedId) {
	    	return selectedId;
	    } else {
	    	return 0;
	    }
	}
	
	function getIdCliente(str){
		var selectedOption = $("#lClientes option[value='" + str + "']");
	    var selectedId = parseInt(selectedOption.attr('data-value'));
	    if (selectedId) {
	    	return selectedId;
	    } else {
	    	return 0;
	    }
	}
	
	function getIdListaPrecio(str){
		var selectedOption = $("#lListaPrecio option[value='" + str + "']");
	    var selectedId = parseInt(selectedOption.attr('data-value'));
	    if (selectedId) {
	    	return selectedId;
	    } else {
	    	return 0;
	    }
	}
	
	function getIdServicio(str){
		var selectedOption = $("#lServicios option[value='" + str + "']");
	    var selectedId = parseInt(selectedOption.attr('data-value'));
	    if (selectedId) {
	    	return selectedId;
	    } else {
	    	return 0;
	    }
	}
	
	
	function isEmpty(str){
        return !str.replace(/^\s+/g, '').length; // boolean (`true` if field is empty)
    }
	
	function isInt(str){
		return Number.isInteger(Number.parseInt(str));	
	}
	
	function isDouble(str){
		return $.isNumeric(str);	
	}
	
	
	function addDays(date, days) {
		var year=date.split("/")[2];
		var month=date.split("/")[1];
		var day=date.split("/")[0];
		
		var result = new Date(year,month-1,day);
		result.setDate(result.getDate() + days);
		
		year=result.getFullYear();
		month=result.getMonth();
		month=month+1;
		day=result.getDate();
		
		if (month < 9) {
			month = '0' + month;
		}
		if (day< 9) {
			day = '0' + day;
		}
		
		return day+"/"+month+"/"+year;
	}
	
	
	/**
	 * Mantenimiento de clientes
	 * 
	 */
	/*
	$("#txtRuc").focusout(function(){
		var txtRuc=$("#txtRuc").val();
		if(!isEmpty(txtRuc)){
			$.ajax({
				url : baseURL + "/valida-ruc-cliente",
				data : {
					ruc: txtRuc
				},
				async:false,
				type : "get",
				contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
				dataType : 'json',
				success : function(response) {
					if(!isEmpty(response.denominacion)){
						alert(response.denominacion);
					}
				}
			});
		}
    });
	
	$("#txtDni").focusout(function(){
		var txtDni=$("#txtDni").val();
		if(!isEmpty(txtDni)){
			$.ajax({
				url : baseURL + "/valida-dni-cliente",
				data : {
					dni:txtDni
				},
				async:false,
				type : "get",
				contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
				dataType : 'json',
				success : function(response) {
					if(!isEmpty(response.denominacion)){
						alert(response.denominacion);
					}
				}
			});
		}
    });
    */
	
	$("#cmdGuardar").click(function(){
		var selTipoPersona=$("#selTipoPersona").val();
		var intTipoPersona=parseInt(selTipoPersona);
		if(intTipoPersona==1){//Natural
			
			var hIdCliente=$("#hIdClienteEdit").val();
			
			var idTipoDocumento=1//DNI
			var txtApellidosNombres = $("#txtApellidosNombres").val().trim().toUpperCase();
			txtApellidosNombres=normalize(txtApellidosNombres);
			
	        var txtDni = $("#txtDni").val().trim().toUpperCase();
	        var txtTelefono = $("#txtTelefono").val().trim().toUpperCase();
	        var txtDireccion = $("#txtDireccion").val().trim().toUpperCase();
	        txtDireccion=normalize(txtDireccion);
	        
	        var txtEmail = $("#txtEmail").val().trim().toUpperCase();
	        
	        if(!isEmpty(txtApellidosNombres)){
	        	if(!isEmpty(txtDni)){
			        $.ajax({
						url : baseURL + "/registro-cliente-simple",
						data : {
							idCliente: hIdCliente,	
							idTipoCliente:selTipoPersona,
							idTipoDocumento:idTipoDocumento,
							denominacion:txtApellidosNombres,
							nrodocumento:txtDni,
							telefono:txtTelefono,
							direccion:txtDireccion,
							email:txtEmail
						},
						async:false,
						type : "get",
						success : function(cliente) {
							$("#hIdCliente").val(cliente.idCliente);
							$("#txtIdCliente").val(cliente.nroDocumento+" "+cliente.denominacion);
							reloadDataList();
							$("#txtIdCliente").focus();
							$("#txtIdCliente").select();
						}
					});
	        	}else{
	        		alert('Debe ingresar el número de DNI!');
	        	}
	        }else{
	        	alert('Debe ingresar los apellidos y nombres!');
	        }
		}else if(intTipoPersona==2){//Empresa
			var hIdCliente=$("#hIdClienteEdit").val();
			var idTipoDocumento=2//RUC
			var txtRazonSocial = $("#txtRazonSocial").val().trim().toUpperCase();
			txtRazonSocial=normalize(txtRazonSocial);
			
	        var txtRuc = $("#txtRuc").val().trim().toUpperCase();
			var txtTelefono = $("#txtTelefono").val().trim().toUpperCase();
	        var txtDireccion = $("#txtDireccion").val().trim().toUpperCase();
	        txtDireccion=normalize(txtDireccion);
	        
	        var txtEmail = $("#txtEmail").val().trim().toUpperCase();
	        
	        if(!isEmpty(txtRazonSocial)){
	        	if(!isEmpty(txtRuc)){
			        $.ajax({
						url : baseURL + "/registro-cliente-simple",
						data : {
							idCliente: hIdCliente,
							idTipoCliente:selTipoPersona,
							idTipoDocumento:idTipoDocumento,
							denominacion:txtRazonSocial,
							nrodocumento:txtRuc,
							telefono:txtTelefono,
							direccion:txtDireccion,
							email:txtEmail
						},
						async:false,
						type : "get",
						success : function(cliente) {
							$("#hIdCliente").val(cliente.idCliente);
							$("#txtIdCliente").val(cliente.nroDocumento+" "+cliente.denominacion);
							reloadDataList();
							$("#txtIdCliente").focus();
							$("#txtIdCliente").select();
						}
					});
	        	}else{
	        		alert('Debe ingresar el número de RUC!');
	        	}
	        }else{
	        	alert('Debe ingresar la razón social!');
	        }
		}
    });
	
	
	
	
	function reloadDataList(){
		$.ajax({
			url : baseURL + "/obtener-clientes-lista",
			async:false,
			type : "get",
			contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
			dataType : 'json',
			success : function(data) {
				var dataList = $("#lClientes");
				dataList.empty();
				if(data.length) {
		          for(var i=0, len=data.length; i<len; i++) {
		        	  dataList.append("<option data-value='" + data[i]['id'] + "' id='"+data[i]['descripcion']+"' value='" + data[i]['codigo']+' '+data[i]['denominacion']+ "'>");
		          }
		        }
			}
		});
	}
	
});


var normalize = (function() {
	  var from = "ÃÀÁÄÂÈÉËÊÌÍÏÎÒÓÖÔÙÚÜÛãàáäâèéëêìíïîòóöôùúüûÑñÇç", 
	      to   = "AAAAAEEEEIIIIOOOOUUUUaaaaaeeeeiiiioooouuuuNncc",
	      mapping = {};
	 
	  for(var i = 0, j = from.length; i < j; i++ )
	      mapping[ from.charAt( i ) ] = to.charAt( i );
	 
	  return function( str ) {
	      var ret = [];
	      for( var i = 0, j = str.length; i < j; i++ ) {
	          var c = str.charAt( i );
	          if( mapping.hasOwnProperty( str.charAt( i ) ) )
	              ret.push( mapping[ c ] );
	          else
	              ret.push( c );
	      }      
	      return ret.join( '' );
	  }
	 
	})();

function isEmpty(str){
	  return !str.replace(/^\s+/g, '').length; // boolean (`true` if field is empty)
	}