package com.delfines.business;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.Comprobante;
import com.delfines.vo.ComprobanteDetalle;
import com.delfines.vo.Guia;
import com.delfines.vo.GuiaDetalle;
import com.delfines.vo.Usuario;

public class RegistroPagoBo {
	
	public Integer registraPago(Integer idFormaPago,Integer idTipoMoneda,Double montoPago,Integer idTipoTarjeta,String numeroTarjeta,Integer idComprobante,
			Double totalNetoComprobante,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.pago(id_forma_pago,id_tipo_moneda,monto_pago,id_tipo_tarjeta,numero_tarjeta,id_comprobante,fechahora_pago,total_neto_comprobante,estado ");
            query.append(",audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
            query.append("VALUES(?,?,?,?,?,?,getdate(),?,? ");
            query.append(",?,getdate(),?,'1')  ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idFormaPago);
            ps.setInt(2, idTipoMoneda);
            ps.setDouble(3, montoPago);
            if(idFormaPago==2){//efectivo
            	ps.setInt(4, idTipoTarjeta);
	            ps.setString(5, numeroTarjeta);
            }else {
            	ps.setNull(4, java.sql.Types.INTEGER);
            	ps.setNull(5, java.sql.Types.NVARCHAR);
            }
            ps.setInt(6, idComprobante);
            ps.setDouble(7, totalNetoComprobante);
            ps.setString(8, String.valueOf(Constante.ESTADO_ACTIVO));
            ps.setInt(9, pUsuario.getUsuarioId());
            ps.setString(10, Constante.TERMINAL);
            //--
            pk=ps.executeUpdate();
            
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	public Integer actualizaPago(Integer idFormaPago,Integer idTipoTarjeta,String numeroTarjeta,Integer idTipoMoneda,Integer idComprobante,
			Integer idPago,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.pago ");
            query.append("SET id_forma_pago = ? ");
            query.append(",id_tipo_moneda = ? ");
            query.append(",id_tipo_tarjeta = ? ");
            query.append(",numero_tarjeta = ? ");
            query.append("WHERE id_pago=? and id_comprobante=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idFormaPago);
            ps.setInt(2, idTipoMoneda);
            if(idFormaPago==2){//tarjeta
            	ps.setInt(3, idTipoTarjeta);
	            ps.setString(4, numeroTarjeta);
            }else {
            	ps.setNull(3, java.sql.Types.INTEGER);
            	ps.setNull(4, java.sql.Types.NVARCHAR);
            }
            ps.setInt(5, idPago);
            ps.setInt(6, idComprobante);
            //--
            pk=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
}
