package com.delfines.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

import org.apache.tomcat.jdbc.pool.DataSource;
import org.apache.tomcat.jdbc.pool.PoolProperties;

import com.delfines.Constante;
import com.delfines.business.RegistroFacturaBo;
import com.delfines.business.ReportesBo;
import com.delfines.spring.controller.JavaGoSocketWrite;
import com.delfines.vo.Comprobante;
import com.delfines.vo.ComprobanteDetalle;

public final class ConnectionFactory {
	
	/**produccion**/
	//public static final String URL = "jdbc:sqlserver://10.0.0.160:1433;databaseName=db_lavanderia;user=sa;password=admin";
	public static final String URL = "jdbc:sqlserver://10.0.0.190:1433;databaseName=db_lavanderia;user=sa;password=20136957253";
	
	private static ConnectionFactory instance;
    private static DataSource dataSource = null;
    private Connection connection;

    private ConnectionFactory() {
        this.connect();
    }
	
	public static ConnectionFactory getInstance() {
        if (ConnectionFactory.instance == null) {
        	ConnectionFactory.instance = new ConnectionFactory();
        }
        return ConnectionFactory.instance;
    }
	
	private void connect() {
        Connection connection = null;
        if (this.dataSource == null) {
            try {
                //InitialContext initialContext = new InitialContext();
                //dataSource = (DataSource)initialContext.lookup(
                //        Constant.DEPLOYED ? Constant.PROD_JNDINAME : Constant.TEST_JNDINAME);
             System.out.println("create data source :: "+ZonedDateTime.now().format(DateTimeFormatter.RFC_1123_DATE_TIME));
              PoolProperties p = new PoolProperties();
  	          p.setUrl(URL);
  	          p.setDriverClassName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
  	          p.setJmxEnabled(true);
  	          p.setTestWhileIdle(false);
  	          p.setTestOnBorrow(true);
  	          p.setValidationQuery("SELECT 1");
  	          p.setTestOnReturn(false);
  	          p.setValidationInterval(30000);
  	          p.setTimeBetweenEvictionRunsMillis(30000);
  	          p.setMaxActive(100);
  	          p.setInitialSize(20);
  	          p.setMaxWait(10000);
  	          p.setRemoveAbandonedTimeout(60);
  	          p.setMinEvictableIdleTimeMillis(30000);
  	          p.setMinIdle(10);
  	          p.setLogAbandoned(false);
  	          p.setRemoveAbandoned(true);
  	          p.setJdbcInterceptors(
  	            "org.apache.tomcat.jdbc.pool.interceptor.ConnectionState;"+
  	            "org.apache.tomcat.jdbc.pool.interceptor.StatementFinalizer");
  	          this.dataSource = new org.apache.tomcat.jdbc.pool.DataSource();
  	          this.dataSource.setPoolProperties(p);
  	          
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        try {
        	System.out.println("get connection :: "+ZonedDateTime.now().format(DateTimeFormatter.RFC_1123_DATE_TIME));
            connection = this.dataSource.getConnection();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        this.connection = connection;
    }
	
	public Connection getConnection() {
		try {
			if(this.connection==null||this.connection.isClosed()){
				System.out.println("get connection :: "+ZonedDateTime.now().format(DateTimeFormatter.RFC_1123_DATE_TIME));
				this.connection = this.dataSource.getConnection();
			}
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return this.connection;
    }
    /**
     * Test Connection
     */
	
//    public static void main(String[] args) {
//    	try{
//	    	ReportesBo rbo=new ReportesBo();
//	    	
//    		List<Integer> lista=rbo.listarIdComprobante("22/10/2018","22/10/2018"); 
//    		
//    		for (Integer id : lista) {
//			   RegistroFacturaBo bo=new RegistroFacturaBo();
//			   Comprobante comprobante=bo.obtenerComprobante(id);
//			   List<ComprobanteDetalle> lDetalle=bo.obtenerComprobanteDetalleConsolidado(id); 
//			   
//			   JavaGoSocketWrite write=new JavaGoSocketWrite();
//			   if(comprobante.getIdTipoComprobante()==Constante.ID_TIPO_COMPROBANTE_FACTURA){
//				   write.createF013(comprobante, lDetalle);
//			   }else{
//				   write.createB013(comprobante, lDetalle);
//			   }
//    		}
//    		
//    		System.out.println("generated !");
//    	}catch(Exception e){
//    		e.printStackTrace();
//    	}
//    }
	
}
