package com.delfines.spring.controller;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardCopyOption;
import java.util.LinkedList;
import java.util.List;

import com.delfines.Constante;
import com.delfines.business.ClienteBo;
import com.delfines.business.RegistroFacturaBo;
import com.delfines.business.Util;
import com.delfines.vo.Comprobante;
import com.delfines.vo.ComprobanteDetalle;

public class JavaGoSocketWrite {
	
	private String folderName;
	
	
	public static void main(String[] args) {
    	try{
    		Integer idComprobante=22744;
    		
    		 RegistroFacturaBo bo=new RegistroFacturaBo();
    		 Comprobante cabecera=bo.obtenerComprobante(idComprobante);
			    List<ComprobanteDetalle> lDetalle=bo.obtenerComprobanteDetalleConsolidado(idComprobante); 
			   
			    JavaGoSocketWrite write=new JavaGoSocketWrite();
			    
			    if(cabecera.getIdTipoComprobante()==Constante.ID_TIPO_COMPROBANTE_FACTURA){
				   write.createF013(cabecera, lDetalle);
			    }else{
				   write.createB013(cabecera, lDetalle);
			    }
    		System.out.println("generated !");
    	}catch(Exception e){
    		e.printStackTrace();
    	}
    }
		
	public String getFolderName() {
		return folderName;
	}

	public void setFolderName(String folderName) {
		this.folderName = folderName;
	}

	public JavaGoSocketWrite(){
		try{
			setFolderName(Util.pathGOSOCKET);
		}catch(Exception e){
			e.printStackTrace();
			setFolderName(Util.pathGOSOCKET);
	    }
	}
	
	public void createB013(Comprobante comprobante,List<ComprobanteDetalle> lDetalle) {
		try{
			//TEMPLATE::INICIO
            StringBuilder qheader = new StringBuilder();
            qheader.append("E1|03|serie_boleta|numero_boleta|fecha_boleta").append("\n");
            qheader.append("E2|20136957253|CORPORACION EL GOLF S.A.|Cll. Los Eucaliptos 555|LIMA|LIMA|SAN ISIDRO|PE|150131").append("\n");
            qheader.append("E3|tipo_documento|numero_dni|apellidos_nombres|direccion_cliente|||||").append("\n");                                        
            qheader.append("T1|PEN|0.00|0.00|0.00|0.00|0.00|total_igv|0.00|total_general|total_en_letras_general|total_neto|0.00|0.00|0.00|0.00|1001|1002|1003|1004|2005|").append("\n");                                                            
            qheader.append("H1|1000|IGV||18.00|total_igv|total_neto").append("\n");
            
            StringBuilder qfooter = new StringBuilder();
            qfooter.append("P1||||usuario");
            
            StringBuilder qdetails = new StringBuilder();
			qdetails.append("D1|cantidad_d|INT|total_general_d|concepto_d|1|HUR|total_neto_d|total_general_d||||1000|10|18.00|total_neto_d|total_igv_d|total_neto_d|total_neto_d|total_neto_d|||").append("\n");
			//TEMPLATE::FIN
			
			String header=qheader.toString().replaceAll("numero_boleta",String.format("%08d",comprobante.getSeqComprobante())).
					replaceAll("serie_boleta",comprobante.getSerie()).
					replaceAll("fecha_boleta",comprobante.getFechaComprobanteTxt()).
					replaceAll("tipo_documento", comprobante.getTipoDocSunat()).
					replaceAll("numero_dni", comprobante.getNumeroDocumentoCliente()).
					replaceAll("apellidos_nombres", comprobante.getDenominacionCliente()).
					replaceAll("direccion_cliente", comprobante.getDireccionCliente()).
					replaceAll("total_igv", String.valueOf(comprobante.getTotalIgv())).
						replaceAll("total_general", String.valueOf(comprobante.getTotalGeneral())).
					replaceAll("total_en_letras_general", comprobante.getTotalNetoWord()).
						replaceAll("total_neto", String.valueOf(comprobante.getTotalNeto()));
            
			String footer=qfooter.toString().replaceAll("usuario", comprobante.getUsuario());
			
			Integer i=1;
			
			List<String> lista=new LinkedList<>();
			for( ComprobanteDetalle detalle:lDetalle ) {
				String item=qdetails.toString().replaceAll("cantidad_d", String.valueOf(detalle.getCantidad()))
						.replaceAll("total_general_d", String.valueOf(detalle.getSubTotalNeto()))
						.replaceAll("concepto_d", detalle.getDenominacionServicio())
						.replaceAll("total_neto_d", String.valueOf(detalle.getTotalLinea()))
						.replaceAll("total_igv_d", String.valueOf(detalle.getIgv()));
				lista.add(item);
			}
            
			// Create new file
			String txtname="03"+"_"+comprobante.getSerie()+"_"+String.format("%08d",comprobante.getSeqComprobante());
            String path=getFolderName()+txtname+".txt";
            File file = new File(path);
            
            // If file doesn't exists, then create it
            if (!file.exists()) {
                file.createNewFile();
            }

            FileWriter fw = new FileWriter(file.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);
            
            bw.write(header);
            for (String detalle : lista) {
            	bw.write(detalle);
            }
            bw.write(footer);
            // Close connection
            bw.close();
            
        }
        catch(Exception e){
            e.printStackTrace();
        }
    }
	
	public void createF013(Comprobante comprobante,List<ComprobanteDetalle> lDetalle) {
		try{
			// Write BOLETA
            StringBuilder qheader = new StringBuilder();
            qheader.append("E1|01|serie_factura|numero_factura|fecha_factura").append("\n");
            qheader.append("E2|20136957253|CORPORACION EL GOLF S.A.|Cll. Los Eucaliptos 555|LIMA|LIMA|SAN ISIDRO|PE|150131").append("\n");
            qheader.append("E3|tipo_documento|numero_ruc|razon_social|direccion_cliente|||||").append("\n");                                        
            qheader.append("T1|PEN|0.00|0.00|0.00|0.00|0.00|total_igv|0.00|total_general|total_en_letras_general|total_neto|0.00|0.00|0.00|0.00|1001|1002|1003|1004|2005|").append("\n");                                                            
            qheader.append("H1|1000|IGV||18.00|total_igv|total_neto").append("\n");
            
            StringBuilder qfooter = new StringBuilder();
            qfooter.append("P1||||usuario");
            
            StringBuilder qdetails = new StringBuilder();
			qdetails.append("D1|cantidad_d|INT|total_general_d|concepto_d|1|HUR|total_neto_d|total_general_d||||1000|10|18.00|total_neto_d|total_igv_d|total_neto_d|total_neto_d|total_neto_d|||").append("\n");
			
			String header=qheader.toString().replaceAll("numero_factura",String.format("%08d",comprobante.getSeqComprobante())).
					replaceAll("serie_factura",comprobante.getSerie()).
					replaceAll("fecha_factura",comprobante.getFechaComprobanteTxt()).
					replaceAll("tipo_documento", comprobante.getTipoDocSunat()).
					replaceAll("numero_ruc", comprobante.getNumeroDocumentoCliente()).
					replaceAll("razon_social", comprobante.getDenominacionCliente()).
					replaceAll("direccion_cliente", comprobante.getDireccionCliente()).
					replaceAll("total_igv", String.valueOf(comprobante.getTotalIgv())).
						replaceAll("total_general", String.valueOf(comprobante.getTotalGeneral())).
					replaceAll("total_en_letras_general", comprobante.getTotalNetoWord()).
						replaceAll("total_neto", String.valueOf(comprobante.getTotalNeto()));
            
			String footer=qfooter.toString().replaceAll("usuario", comprobante.getUsuario());
			Integer i=1;
			
			List<String> lista=new LinkedList<>();
			for( ComprobanteDetalle detalle:lDetalle ) {
				String item=qdetails.toString().replaceAll("cantidad_d", String.valueOf(detalle.getCantidad()))
						.replaceAll("total_general_d", String.valueOf(detalle.getSubTotalNeto()))
						.replaceAll("concepto_d", detalle.getDenominacionServicio())
						.replaceAll("total_neto_d", String.valueOf(detalle.getTotalLinea()))
						.replaceAll("total_igv_d", String.valueOf(detalle.getIgv()));
				lista.add(item);
			}
            
			// Create new file
			String txtname="01"+"_"+comprobante.getSerie()+"_"+String.format("%08d",comprobante.getSeqComprobante());
			String path=getFolderName()+txtname+".txt";
            File file = new File(path);

            // If file doesn't exists, then create it
            if (!file.exists()) {
                file.createNewFile();
            }

            FileWriter fw = new FileWriter(file.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);
            
            System.out.println(header);
            bw.write(header);
            for (String detalle : lista) {
            	System.out.println("\t"+detalle);
            	bw.write(detalle);
            }
            bw.write(footer);
            // Close connection
            bw.close();
            
        }
        catch(Exception e){
        	e.printStackTrace();
        }
    }
}

