package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.ListaPrecioBo;
import com.delfines.business.ServicioBo;
import com.delfines.vo.ListaPrecio;
import com.delfines.vo.Servicio;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class ListaPrecioController {
   
   @RequestMapping(path={"/lista-lista-precio"},method=RequestMethod.GET)
   public ModelAndView listaListaPrecio(Model model,HttpServletRequest request) {
	    ListaPrecioBo servicio=new ListaPrecioBo();
	    List lista=servicio.listaListaPrecio();
	   
		ModelAndView mv = new ModelAndView("mante-lista-precios-tabla");
		mv.addObject("lista",lista);
		return mv;
   }
   
   @RequestMapping(path={"/eliminar-lista-precio"},method=RequestMethod.GET)
   public ModelAndView eliminarListaPrecio(Integer idListaPrecio,Model model,HttpServletRequest request) {
	    Integer res=Constante.ID_INICIAL;
	    ListaPrecioBo servicio=new ListaPrecioBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    if(idListaPrecio>0){
	    	res=servicio.eliminarListaPrecio(idListaPrecio,pUsuario);
	    }
	    
	    List lista=new LinkedList<ListaPrecio>();
	    if(res>0){
	    	lista=servicio.listaListaPrecio();	
	    }
		ModelAndView mv = new ModelAndView("mante-lista-precios-tabla");
		mv.addObject("lista",lista);
		return mv;
   }
   
   @RequestMapping(path={"/init-registro-lista-precio"},method=RequestMethod.GET)
   public ModelAndView manteRegistroListaPrecio(Integer idListaPrecio,Model model,HttpServletRequest request) {
	   ListaPrecioBo servicio=new ListaPrecioBo();
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   request.getSession().setAttribute("p_IdListaPrecio", idListaPrecio);
	   //Lista de servicios por lista de precios
	   List lista=new LinkedList<Servicio>();
	   ListaPrecio obj=new ListaPrecio();
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   if(idListaPrecio>0){
			   obj=servicio.obtenerListaPrecioById(idListaPrecio);
			   lista=servicio.listarServicio(idListaPrecio);
		   }
	   }

	   request.getSession().setAttribute("p_ListaPrecio", obj);
	   request.getSession().setAttribute("p_Lista", lista);
	   
		ModelAndView mv = new ModelAndView("registro-lista-precio");
		mv.addObject("idListaPrecio",idListaPrecio);
		mv.addObject("lista",lista);
		mv.addObject("listaPrecio",obj);
		return mv;
   }
   
   @RequestMapping(path={"/guardar-lista-precio"},method=RequestMethod.GET)
   public ModelAndView guardarListaPrecio(Integer idListaPrecio,String denominacion,String descripcion,String fechaInicio,String fechaFin,
		   Model model,HttpServletRequest request) {
	   
	    ListaPrecioBo servicio=new ListaPrecioBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    if(idListaPrecio>0){
	    	servicio.actualizaListaPrecio(idListaPrecio,denominacion,descripcion,fechaInicio,fechaFin,pUsuario);
	    }else{
	    	idListaPrecio=servicio.registraListaPrecio(denominacion,descripcion,fechaInicio,fechaFin,pUsuario);
	    	servicio.insertarServicioDetalleLista(idListaPrecio,pUsuario);
	    }
	    
	    List lista=new LinkedList<Servicio>();
	    if(idListaPrecio>0){
		   lista=servicio.listarServicio(idListaPrecio);
	    }
	    
	    ModelAndView mv = new ModelAndView("registro-lista-precio-tabla");
	    mv.addObject("idListaPrecio",idListaPrecio);
		mv.addObject("lista",lista);
		return mv;
   }
   
   @RequestMapping(path={"/guardar-lista-precio-item"},method=RequestMethod.GET)
   public String guardarListaPrecioItem(Integer idListaPrecio,Integer idServicio,Integer idDetalleLista,Double precioUnitario,
		   Model model,HttpServletRequest request) {
	   
	    Integer result=Constante.ID_INICIAL; 
	    ListaPrecioBo servicio=new ListaPrecioBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    if(idListaPrecio>0&&idServicio>0){
	    	System.out.println("Actualiza precio "+precioUnitario);
	    	result=servicio.actualizaPrecioUnitario(idListaPrecio,idServicio,idDetalleLista,precioUnitario,pUsuario);
	    }
	    
		return "registro-lista-precio-tabla";
   }
   
   @RequestMapping(path={"/mostrar-lista-precio-tabla"},method=RequestMethod.GET)
   public ModelAndView mostrarListaPrecioItems(Integer idListaPrecio,Model model,HttpServletRequest request) {
	    ListaPrecioBo servicio=new ListaPrecioBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    
	    List lista=new LinkedList<Servicio>();
	    if(idListaPrecio>0){
		   lista=servicio.listarServicio(idListaPrecio);
	    }
	    
	    ModelAndView mv = new ModelAndView("registro-lista-precio-tabla");
	    mv.addObject("idListaPrecio",idListaPrecio);
		mv.addObject("lista",lista);
		return mv;
   }
   
   /**
    * Servicios en la lista de precios
    */
   @RequestMapping(path={"/registro-servicio"},method=RequestMethod.GET)
   public ModelAndView registroServicio(Integer idServicio,Integer idListaPrecio,Integer idDetalleLista,String denominacion,String descripcion,
		   Double precio,String clasificacion,
		   Model model,HttpServletRequest request) {
	   
	    ServicioBo servicio=new ServicioBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    if(idServicio>0){
	    	Integer res=servicio.actualizaServicio(idServicio,idListaPrecio,idDetalleLista,denominacion,descripcion,precio,clasificacion,pUsuario);
	    	if(res>0){
	    		ListaPrecioBo lpbo=new ListaPrecioBo(); 
		    	lpbo.actualizaPrecioUnitario(idListaPrecio,idServicio,idDetalleLista,precio,pUsuario);
	    	}
	    }else{
	    	idServicio=servicio.registraServicio(idListaPrecio,denominacion,descripcion,precio,clasificacion,pUsuario);
	    	if(idListaPrecio>0&&idServicio>0){
		    	ListaPrecioBo lpbo=new ListaPrecioBo(); 
		    	lpbo.insertaPrecioUnitario(idListaPrecio,idServicio,precio,pUsuario);
		    }
	    }
	    
	    ListaPrecioBo lPrecioBo=new ListaPrecioBo();
	    List lServicios=lPrecioBo.listarServicio(idListaPrecio);
	    
		ModelAndView mv = new ModelAndView("registro-lista-precio-tabla");
		mv.addObject("lista",lServicios);
		return mv;
		
   }
   
   @RequestMapping(path={"/eliminar-servicio"},method=RequestMethod.GET)
   public ModelAndView eliminarServicio(Integer idServicio,Integer idListaPrecio,Integer idDetalleLista,Model model,HttpServletRequest request) {
	    Integer res=Constante.ID_INICIAL; 
	    ServicioBo servicio=new ServicioBo();
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	    if(idServicio>0){
	    	res=servicio.eliminarServicio(idServicio,idListaPrecio,idDetalleLista,pUsuario);
	    }
	    
	    ListaPrecioBo lPrecioBo=new ListaPrecioBo();
	    List lServicios=lPrecioBo.listarServicio(idListaPrecio);
	    
		ModelAndView mv = new ModelAndView("registro-lista-precio-tabla");
		mv.addObject("lista",lServicios);
		return mv;
   }
   
}
