package com.delfines.spring.controller;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.activation.DataSource;
import javax.mail.util.ByteArrayDataSource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.ClienteBo;
import com.delfines.business.RegistroFacturaBo;
import com.delfines.business.RegistroGuiaBo;
import com.delfines.business.ServicioBo;
import com.delfines.dao.ConnectionFactory;
import com.delfines.sendmail.SendEmail;
import com.delfines.vo.Cliente;
import com.delfines.vo.Correo;
import com.delfines.vo.EstadoEntrega;
import com.delfines.vo.Guia;
import com.delfines.vo.GuiaDetalle;
import com.delfines.vo.QRComprobante;
import com.delfines.vo.Servicio;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.util.JRLoader;
import net.sf.jasperreports.export.SimpleExporterInput;
import net.sf.jasperreports.export.SimpleOutputStreamExporterOutput;

/**
 * @author imssbora
 */
@Controller
public class RegistroGuiaController {
   
	@RequestMapping(value="/guardar-estado-entrega", method=RequestMethod.GET)
	@ResponseBody
	public EstadoEntrega guardarEstadoEntrega(Integer idGuia,String comentarioEntrega,Integer estadoEntrega,Model model,HttpServletRequest request) {
		
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   ServicioBo servicio=new ServicioBo(); 
	   EstadoEntrega estado=new EstadoEntrega(); 
	   try{
		   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
			   Integer res=servicio.guardarEstadoEntrega(idGuia,comentarioEntrega,estadoEntrega);
			   estado=servicio.getEstadoEntrega(idGuia);
		   }
	   }catch(Exception e){
		   e.printStackTrace();
	   }
	   
	   return estado;
	}
	
	@RequestMapping(value="/obtener-detalle-servicio", method=RequestMethod.GET)
	@ResponseBody
	public Servicio obtenerDetalleServicio(Integer idListaPrecio,Integer idServicio,Model model,HttpServletRequest request) {
	   Servicio obj=new Servicio();
	   obj.setIdServicio(0);
	   try{
		   if(idListaPrecio!=null&&idListaPrecio>0&&idServicio!=null&&idServicio>0){
			   ServicioBo servicio=new ServicioBo(); 
			   obj=servicio.getServicioDetalleLista(idListaPrecio, idServicio);   
		   }
	   }catch(Exception e){
		   e.printStackTrace();
	   }
	   return obj;
	}
	
	@RequestMapping(value="/add-item-guia", method=RequestMethod.GET)
	@ResponseBody
	public ModelAndView agregarItemGuia(Integer idGuia,Integer idDetalleLista,Integer idServicio,Integer idPrioridad,
			Integer idDescuento,Double precio,Double cantidad,String descripcion,Integer idGuiaDetalle,
			Model model,HttpServletRequest request){
		   
		   RegistroGuiaBo bo=new RegistroGuiaBo();
		   List<GuiaDetalle> lista=new ArrayList<GuiaDetalle>();
		   
		   try{
			   Usuario pUsuario = new Usuario();
	       	
			   pUsuario.setUsuarioId(3);
			   pUsuario.setApellidosNombres("MANAYAY HUAMAN, MARCOS");
			   pUsuario.setUsername("mmanayay");
	           //--
			   pUsuario.setIdPerfilLead(1);
			   pUsuario.setAreaId(1);
			   pUsuario.setDenominacionArea("LAVANDERIA");
	       	   /**
			    * force fin
			    */
			   
			   Double pigv=new Double(0);
			   pigv=0.18;
			   //--
			   Double descuento=new Double(0);
			   Double recargo=new Double(0);
			   
			   Double totalIgv=new Double(0);
			   Double totalLinea=new Double(0);
			   
			   Double precioUnitario=new Double(0);
			   Double totalGravada=new Double(0);
			   
			   //Prioridad
			   if(idPrioridad==Constante.ID_PRIORIDAD_NORMAL){
				   recargo=Double.valueOf(0);
			   }
			   else if(idPrioridad==Constante.ID_PRIORIDAD_URGENTE){
				   recargo=precio*0.5;//50% adicional
			   }
			   
			   //Descuento
			   if(idDescuento==Constante.ID_DESCUENTO_CERO){
				   descuento=Double.valueOf(0);
			   }
			   else if(idDescuento==Constante.ID_DESCUENTO_PRONTO_PAGO){
				   descuento=precio*0.1;//10% descuento
			   }
			   else if(idDescuento==Constante.ID_DESCUENTO_PERSONAL){
				   descuento=precio*0.3;//30% descuento
			   }
			   else if(idDescuento==Constante.ID_DESCUENTO_CLIENTE_VIP){
				   descuento=precio*0.1;//10% descuento
			   }
	
			   //Calculo de precio unitario con decuentos
			   precioUnitario=(precio+recargo-descuento);
			   
			   //Calculo del total de linea
			   totalLinea=cantidad*precioUnitario;
			   
			   //Calculo del total Gravado
			   totalGravada=totalLinea/1.18;
			   
			   BigDecimal big = new BigDecimal(totalGravada);
			   big = big.setScale(2, RoundingMode.HALF_UP);
			   totalGravada=big.doubleValue();   
			   
			   //Calculo del total de IGV
			   //totalIgv=totalGravada*pigv;//El precio de lista de precio incluye IGV
			   totalIgv=(totalLinea-totalGravada);//El precio de lista de precio incluye IGV por errores en el redondeo centimos
			   
			   if(idGuiaDetalle>0){
				   Integer id=bo.actualizarGuiaDetalle(idGuiaDetalle,idGuia, idDetalleLista, idServicio, idPrioridad, precio, cantidad, descripcion, totalLinea, descuento, recargo,totalIgv, totalGravada, pUsuario);
			   }else{
				   Integer id=bo.registraGuiaDetalle(idGuia, idDetalleLista, idServicio, idPrioridad, precio, cantidad, descripcion, totalLinea, descuento, recargo,totalIgv, totalGravada, pUsuario);   
			   }
			   lista=bo.listaGuiaDetalle(idGuia);
		   }catch(Exception e){
			   e.printStackTrace();
		   }
		   
		   ModelAndView mv = new ModelAndView("registro-guia-tabla");
		   mv.addObject("lGuiaDetalle",lista);
		   return mv;
	}
	
	
	@RequestMapping(value="/delete-item-guia", method=RequestMethod.GET)
	@ResponseBody
	public ModelAndView eliminaItemGuia(Integer idGuia,Integer idGuiaDetalle,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   List<GuiaDetalle> lista=new ArrayList<GuiaDetalle>();
	   try{
		   RegistroGuiaBo bo=new RegistroGuiaBo();
		   
		   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
			   Integer id=bo.eliminarItemGuia(idGuiaDetalle,pUsuario);
			   lista=bo.listaGuiaDetalle(idGuia);
		   }
	   }catch(Exception e){
		   e.printStackTrace();
	   }
	   ModelAndView mv = new ModelAndView("registro-guia-tabla");
  	   mv.addObject("lGuiaDetalle",lista);
  	   return mv;
	}
	
	@RequestMapping(value="/get-item-guia", method=RequestMethod.GET)
	@ResponseBody
	public GuiaDetalle getItemGuia(Integer idGuia,Integer idGuiaDetalle,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroGuiaBo bo=new RegistroGuiaBo();
	   GuiaDetalle obj=new GuiaDetalle();
	   try{
		   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
			   obj=bo.obtenerItemGuia(idGuia,idGuiaDetalle);
		   }
	   }catch(Exception e){
		   e.printStackTrace();
	   }
	   return obj;
	}
	
	@RequestMapping(value="/inicia-guia", method=RequestMethod.GET)
    @ResponseBody
    public Guia iniciaNuevaGuia(Model model,HttpServletRequest request){
		Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
		Guia guia=new Guia();	
		try{
		   RegistroGuiaBo registroGuiaBo=new RegistroGuiaBo();
		   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
			   Integer idGuia=registroGuiaBo.crearGuia(pUsuario);
			   guia=registroGuiaBo.obtenerGuia(idGuia);
		   }
		}catch(Exception e){
			e.printStackTrace();	
		}
	   return guia;
    }
	
	
	@RequestMapping(value="/buscar-guia", method=RequestMethod.GET)
    @ResponseBody
    public Guia buscarGuia(Integer numeroGuia,Model model,HttpServletRequest request) throws Exception{
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   Guia guia=new Guia();
	   RegistroGuiaBo registroGuiaBo=new RegistroGuiaBo();  
	   try{
		   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
			   if(numeroGuia!=null && numeroGuia>0){
				   
				   if(numeroGuia>0){
					   guia=registroGuiaBo.obtenerGuiaBusquedaBySeq(numeroGuia);
					   
					   if(guia==null){
						   throw new Exception("Numero de guia no encontrada");
					   }
					   
				   }
			   }
		   }
	   }catch(Exception e){
		   throw e;
	   }
	   
	   return guia;
    }
	
	@RequestMapping(value="/buscar-guia-detalle", method=RequestMethod.GET)
	@ResponseBody
	public ModelAndView buscarGuiaDetalle(Integer idGuia,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	   RegistroGuiaBo bo=new RegistroGuiaBo();
	   List<GuiaDetalle> lista=new ArrayList<GuiaDetalle>();
	   try{
		   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
			   lista=bo.listaGuiaDetalle(idGuia);
		   }
	   }catch(Exception e){
		   e.printStackTrace();
	   }
	   ModelAndView mv = new ModelAndView("registro-guia-tabla");
  	   mv.addObject("lGuiaDetalle",lista);
  	   return mv;
	}
	
	@RequestMapping(value="/complete-guia", method=RequestMethod.GET)
    @ResponseBody
    public String completeGuia(Integer idGuia,Integer idCliente,String fechaComprometida,Integer idListaPrecio,Integer idPrioridad,Integer idDescuento,String comentario,
    	Double totalDescuento,Double totalRecargo,Double totalGeneral,Double totalNeto,Double totalIgv,
    	Model model,HttpServletRequest request) {
	    Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   
	    RegistroGuiaBo bo=new RegistroGuiaBo();  
	    
	    String numeroGuia="000000";
	    try{
		    if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
			   if(!bo.esGuiaCompleto(idGuia)){
				    RegistroFacturaBo facturaBo=new RegistroFacturaBo();
			    	HashMap<String, String> comprobante=facturaBo.getNumeroComprobante(Constante.ID_TIPO_GUIA_RECEPCION);
			    	
			    	String numero=comprobante.get("numero");
			    	String serie=comprobante.get("serie");
			    	
			    	if(numero!=null){
			    		Integer secuencia=Integer.valueOf(comprobante.get("secuencia")==null?"0":comprobante.get("secuencia"));
				    	
			    		bo.actualizarGuia(idGuia,idCliente,fechaComprometida,idListaPrecio,idPrioridad,idDescuento,comentario,
			        	    	totalDescuento,totalRecargo,totalGeneral,totalNeto,totalIgv,numero,secuencia,serie,pUsuario);
					   
					    numeroGuia=numero;	
			    	}
				    request.getSession().setAttribute("p_idGuia",idGuia);
			   }
		    }
	    }catch(Exception e){
	    	e.printStackTrace();
	    }
	    return numeroGuia;
    }
	
	@RequestMapping(value="/print-guia", method=RequestMethod.GET)
    @ResponseBody
    public Integer printGuia(Integer idGuia,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   request.getSession().setAttribute("p_idGuia",idGuia);
	   return 0;
    }
	
	
    @RequestMapping(path={"/impresion-guia"}, method=RequestMethod.GET)
	public void generatePdfReport(HttpServletRequest request, HttpServletResponse response) {
        try {
        	Integer idGuia=(Integer)request.getSession().getAttribute("p_idGuia");
        	if(idGuia!=null&&idGuia>0){
        		
        		//--Obtencion del correo de cliente
        		RegistroFacturaBo bo=new RegistroFacturaBo();
        		Correo correo=bo.obtenerCorreoGuia(idGuia);
     		    //--Obtencion del correo de cliente
     		    
        		String jasperDir = "/jasper/";
                String realPathtoJasper =  request.getServletContext().getRealPath(jasperDir);
                System.out.println(realPathtoJasper);
                
            	JasperReport reporte = (JasperReport) JRLoader.loadObject(new File(realPathtoJasper+"/cab_guia_lav.jasper"));

                Map<String, Object> parametros = new HashMap<String, Object>();
                parametros.put("P_ID_GUIA",idGuia);
                parametros.put("P_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
                parametros.put("P_SUBREPORT_PATH",realPathtoJasper);
                
                Connection conn = ConnectionFactory.getInstance().getConnection();
                
                JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros,conn);
                
                JRPdfExporter pdfExporter = new JRPdfExporter();
                pdfExporter.setExporterInput(new SimpleExporterInput(jasperPrint));
                ByteArrayOutputStream pdfReportStream = new ByteArrayOutputStream();
                pdfExporter.setExporterOutput(new SimpleOutputStreamExporterOutput(pdfReportStream));
                pdfExporter.exportReport();

                response.setContentType("application/pdf");
                response.setHeader("Content-Length", String.valueOf(pdfReportStream.size()));
                response.addHeader("Content-Disposition", "inline; filename=guia.pdf;");

                OutputStream responseOutputStream = response.getOutputStream();
                responseOutputStream.write(pdfReportStream.toByteArray());
                
                
                /***
                 * Envio por correo electronico                 * 
                 */
                if(correo!=null&&correo.getCorreo()!=null&&correo.getCorreo().trim().length()>0){
                	DataSource aAttachment =  new ByteArrayDataSource(pdfReportStream.toByteArray(), "application/pdf");
                    String subject="Guia de Servicio electrnico - "+correo.getNumero();
    		   		String text="Estimado cliente,\nMediante el presente adjuntamos su guia de servicio electrnico.\nSi tiene alguna duda o consulta, comunquese con nosotros.\nAtentamente,\nhttps://www.losdelfineshotel.com/";
    		   		String toList=correo.getCorreo();
    		   		String ccList="lavanderia@losdelfineshotel.com.pe";
    		   		SendEmail.sendEmailLead(toList, ccList, subject, text,aAttachment,correo.getNumero());	
                }
		   		/***
                 * Envio por correo electronico                 * 
                 */
                 
		   		responseOutputStream.close();
                pdfReportStream.close();
        	}
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
	
	@RequestMapping(path={"/registro-cliente-simple"},method=RequestMethod.GET)
	@ResponseBody	
    public Cliente registroClienteSimple(Integer idCliente,Integer idTipoCliente,Integer idTipoDocumento,String denominacion,
		   String nrodocumento,String telefono,String direccion,String email,Model model,HttpServletRequest request) {
		Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
		
		ClienteBo servicio=new ClienteBo();
		Cliente cliente=new Cliente();
    	try{
			if(idCliente>0){
				//Actualizar
				idCliente=servicio.actualizaCliente(idCliente, idTipoCliente, idTipoDocumento, denominacion, nrodocumento, telefono, direccion,email, pUsuario);	
			}else{
				//Nuevo registro
				idCliente=servicio.registraCliente(idTipoCliente,idTipoDocumento,denominacion,nrodocumento,telefono,direccion,email,pUsuario);
			}
			
		    cliente.setIdCliente(idCliente);
		    cliente.setNroDocumento(nrodocumento);
		    cliente.setDenominacion(denominacion);
    	}catch(Exception e){
    		e.printStackTrace();
    	}
    	
    	return cliente;
	}
	
	@RequestMapping(path={"/obtener-servicios-lista"},method=RequestMethod.GET)
	@ResponseBody
    public List<Value> obtenerSericiosLista(Integer idListaPrecio,Model model,HttpServletRequest request) {
		ServicioBo serv=new ServicioBo();
		List listaServicios=new LinkedList<Value>();
		try{	
	    	listaServicios=serv.listaServiciosGuia(idListaPrecio);
		}catch(Exception e){
			e.printStackTrace();
		}
	    return listaServicios;
	}
	
	@RequestMapping(path={"/obtener-clientes-lista"},method=RequestMethod.GET)
	@ResponseBody
    public List<Value> obtenerClientesLista(Model model,HttpServletRequest request) {
		ClienteBo servicio=new ClienteBo();
		List lCliente=new LinkedList<Value>();
		try{
	    	lCliente=servicio.listaClientesGuia();
		}catch(Exception e){
			e.printStackTrace();
		}
	    return lCliente;
	}

	@RequestMapping(path={"/buscar-cliente-simple"},method=RequestMethod.GET)
	@ResponseBody	
    public Cliente buscarClienteSimple(Integer idCliente,Model model,HttpServletRequest request) {
		ClienteBo servicio=new ClienteBo();
		Cliente cliente=new Cliente();
		try{
			cliente=servicio.buscarClienteSimple(idCliente);
		}catch(Exception e){
			e.printStackTrace();
		}
    	return cliente;
	}
	 
}
